#include "os.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <memory.h>
#include <malloc.h>
#include <sys/types.h>

#define TABBUFSIZE     189
#define TABROUTESIZE  1500

#define D_N01    (long)0x00000001
#define D_N15    (long)0x00000002
#define D_N10    (long)0x00000004
#define D_N11    (long)0x00000008
#define D_N25    (long)0x00000010
#define D_N03    (long)0x00000020
#define D_N33    (long)0x00000040
#define D_N09    (long)0x00000080
#define D_TTL    (long)0x00000100
#define D_N12    (long)0x00000200
#define D_N17    (long)0x00000400
#define D_N04    (long)0x00000800
#define D_N05    (long)0x00001000
#define D_N13    (long)0x00002000
#define D_N19    (long)0x00004000
#define D_TTC    (long)0x00008000
#define D_TTR    (long)0x00010000
#define D_GCR    (long)0x00020000
#define D_PCR    (long)0x00040000
#define D_N23    (long)0x00080000

#define O_INCREQ    (long)0x00000001
#define O_TXTREQ    (long)0x00000002
#define O_FACREQ    (long)0x00000004
#define O_WASNET    (long)0x00000008

char *mustcalloc();

struct tabroute {
       char  taba[16];
       short posa;
       short lena;
       short tnuma;
       short inca;
       char  tabb[16];
       short posb;
       short lenb;
       short tnumb;
       short incb;
       short fltnum;
       int   flag_1;
       unsigned short opval;
       short          dpval;
       short          dcval;
       short colwid;
       short paglen;
       short pagwid;
       short side;
       short pagenum;
       char  spechr[2];
       } ;

struct axesdef {
       long           genre;
       long           option;
       short          txtn;
       short          ttlnum;
       short          fltnum;
       short          tcase;
       int            flag_1;
       unsigned short opval;
       short          dpval;
       short          dcval;
       short          colwid;
       } ;

main()
{
struct tabroute *tr_[TABROUTESIZE];
struct axesdef ad_;
unsigned short tabbuf[TABBUFSIZE];
char datnam[32];
float *axbuf;
short *axdes;
char *imedptr;
FILE *fpc; /* ccroute.inf */
FILE *fpi; /* intermed.ccc */
FILE *fpt; /* cctabs.ccc */
FILE *fax; /* *.ax-files */
FILE *out; /* ccvals.ccc */
FILE *wgt; /* ccwght.ccc */
FILE *fpx; /* ccfacs.ccc */
short tlen_,sr_,kp_,s_,k_,os_,ok_,fkidx_,sof_;
char bs_,bk_;
unsigned short comp_;
short rcount_ = 0;
short fcount_ = 0;
int axbufsize_ = 0;
int axdessize_ = 0;
int i_,j_,tidx_,ilen_,nlen_,incposa_,incposb_,dmy_;
int axbufidx_,axdesidx_,sidx_,kidx_,ssidx_,kkidx_;
long rec_count = 0L;
float ssval_,kkval_,facval_;
double pre_ = 1.0;
short isweight_ = 0;
char pbuf_[10001];
short pct_;

#ifdef SWAP
char c_;
float convf_;
char *convc_ = (char*)&convf_;
register int l_;
#endif

printf("\n");
printf("PAN-DATA CCOUNT - ccaccum      Version 1.0j\n");
printf("Created 11.11.2003        prog: V. Hoffmann\n\n");

if((fpc = fopen("ccroute.inf","rb")) == NULL)
  {
  fprintf(stderr,"cannot open ccroute.inf\n");
  exit(1);
  }
if((fpi = fopen("intermed.ccc","rb")) == NULL)
  {
  fprintf(stderr,"cannot open intermed.ccc\n");
  exit(1);
  }
if((fpt = fopen("cctabs.ccc","rb")) == NULL)
  {
  fprintf(stderr,"cannot open cctabs.ccc\n");
  exit(1);
  }
if((fpx = fopen("ccfacs.ccc","wb")) == NULL)
  {
  fprintf(stderr,"cannot open ccfacs.ccc\n");
  exit(1);
  }
if((wgt = fopen("ccwght.ccc","rb")) == NULL)
  {
  fprintf(stderr,"cannot open ccwght.ccc\n");
  exit(1);
  }
else
if(fread(&pre_,sizeof(double),1,wgt))
  {
  isweight_ = 1;
  rewind(wgt);
  }
for(i_=0;i_<TABBUFSIZE;i_++)
   tabbuf[i_] = 0;

if(fread(&nlen_,sizeof(int),1,fpc))
  {
  fread(&ilen_,sizeof(int),1,fpc);
  fread(&dmy_,sizeof(int),1,fpc);
  fread(&comp_,sizeof(unsigned short),1,fpc);
  fread(&dmy_,sizeof(short),1,fpc);
  fread(&dmy_,sizeof(short),1,fpc);
  fread(&dmy_,sizeof(short),1,fpc);
  fread(&pct_,sizeof(short),1,fpc);
  fread(pbuf_,sizeof(char),(int)pct_,fpc);
  if((out = fopen("ccvals.ccc","wb")) == NULL)
    {
    fprintf(stderr,"cannot open ccvals.ccc\n");
    exit(1);
    }
  }
else
  {
  printf("no tables to be done\n");
  exit(1);
  }
if(ilen_)
  imedptr = (char*)mustcalloc((unsigned)ilen_,(unsigned)sizeof(char),"imedptr");

i_ = 1;
while(i_)
     {
     if(rcount_ >= TABROUTESIZE)
       {
       fprintf(stderr,"limit of number of axes in run exeeded\n");
       exit(1);
       }
     tr_[rcount_] = (struct tabroute*)mustcalloc((unsigned)1,(unsigned)sizeof(struct tabroute),"tr_[]");
     i_ = fread(tr_[rcount_],sizeof(struct tabroute),1,fpc);
     if(i_)
       ++rcount_;
     }
tlen_ = ((rcount_ - 1) / (short)(sizeof(unsigned short)*8)) + 1;

for(i_=0;i_<rcount_;i_++)
   {
   axbufsize_ += (int)(tr_[i_]->lena * tr_[i_]->lenb);
   axdessize_ += (int)(tr_[i_]->lena + tr_[i_]->lenb);
   }

if(axbufsize_)
  axbuf = (float*)mustcalloc((unsigned)axbufsize_,(unsigned)sizeof(float),"axbuf");
if(axdessize_)
  axdes = (short*)mustcalloc((unsigned)axdessize_,(unsigned)sizeof(short),"axdes");
for(i_=0;i_<axbufsize_;i_++)
   *(axbuf+i_) = (float)0.0;
for(i_=0;i_<axdessize_;i_++)
   *(axdes+i_) = 0;

axdesidx_ = 0; j_ = 2;
while(j_--)
  {
  if(j_)
    sidx_ = axdesidx_;
  else
    {
    kidx_ = axdesidx_;
    fkidx_ = fcount_;
    }
  for(i_=0;i_<rcount_;i_++)
     {
     if(j_)
       strcpy(datnam,tr_[i_]->taba);
     else
       strcpy(datnam,tr_[i_]->tabb);
     strcat(datnam,".ax");
     if((fax = fopen(datnam,"rb")) == NULL)
       {
       fprintf(stderr,"cannot open %s\n",datnam);
       exit(1);
       }
     while(fread(&ad_,sizeof(struct axesdef),1,fax))
       {
       if(ad_.genre & (D_N01 | D_N15 | D_N10 | D_N11))
         {
         if(ad_.option & O_INCREQ)
           *(axdes+axdesidx_) |= 0x0001;
         if(ad_.option & O_FACREQ)
           {
           fread(&facval_,sizeof(float),1,fax);
           fwrite(&facval_,sizeof(float),1,fpx);
           ++fcount_;
           }
         ++axdesidx_;
         }
       else
       if(ad_.genre & D_N25)
         {
         *(axdes+axdesidx_++) |= 0x0003;
         *(axdes+axdesidx_++) |= 0x0007;
         *(axdes+axdesidx_++) |= 0x000d;
         }
       fseek(fax,(long)ad_.txtn,1);
       }
     fclose(fax);
     }
  }
fclose(fpx);
printf("%d tables to be done in next pass\n",rcount_);

sof_ = (short)sizeof(float);

while(fread(imedptr,sizeof(char),ilen_,fpi))
  {
#ifdef SWAP
  for(j_=0;j_<nlen_;j_+=2)
     {
     c_ = *(imedptr+j_);
     *(imedptr+j_) = *(imedptr+(j_+1));
     *(imedptr+(j_+1)) = c_;
     }
#endif
  if(isweight_)
    if(!fread(&pre_,sizeof(double),1,wgt))
      {
      fprintf(stderr,"unexpected eof in file ccwght.ccc\n");
      exit(1);
      }
  axbufidx_ = 0; comp_ = 0x0001; tidx_ = 0;
  ssidx_ = sidx_; kkidx_ = kidx_;
  fread(tabbuf,sizeof(unsigned short),(int)tlen_,fpt);
  if(!(++rec_count % 1000))
    printf(" %ld Records\n",rec_count);
  else
  if(!(rec_count % 100))
    {
    putchar('.');
    fflush(stdout);
    }
  for(j_=0;j_<rcount_;j_++)
     {
     if(!comp_)
       {
       comp_ = 0x0001;
       ++tidx_;
       }
     if(tabbuf[tidx_] & comp_)
       {
       incposa_ = nlen_ + (int)(tr_[j_]->inca * sof_);
       for(sr_=0;sr_ < tr_[j_]->lena;sr_++)
          {
          os_ = sr_ / 8;
          bs_ = (char)(sr_ % 8);
          s_ = tr_[j_]->posa + os_;
          if(*(axdes+ssidx_) & 0x0001)
            {
#ifdef SWAP
            for(l_=0; l_<sizeof(float); l_++)
               *(convc_+l_) = *(imedptr+incposa_+l_);
            ssval_ = convf_;
#else
            ssval_ = *(float*)(imedptr+incposa_);
#endif
            if(*(axdes+ssidx_) & 0x0006)
              {
              if(*(axdes+ssidx_) & 0x0008)
                ssval_ = ssval_ * ssval_;
              else
              if(*(axdes+ssidx_) & 0x0004)
                ;
              else
              if(*(axdes+ssidx_) & 0x0002)
                ssval_ = (float)1.0;
              }
            if(!(*(axdes+ssidx_) & 0x0002))
              incposa_ += (int)sof_;
            }
          else
            ssval_ = (float)1.0;
          ++ssidx_;
          if((*(imedptr+s_) & (char)(1 << bs_)))
            {
            incposb_ = nlen_ + (int)(tr_[j_]->incb * sof_);
            for(kp_=0;kp_ < tr_[j_]->lenb;kp_++)
               {
               ok_ = kp_ / 8;
               bk_ = (char)(kp_ % 8);
               k_ = tr_[j_]->posb + ok_;
               if(*(axdes+kkidx_) & 0x0001)
                 {
#ifdef SWAP
                 for(l_=0; l_<sizeof(float); l_++)
                    *(convc_+l_) = *(imedptr+incposb_+l_);
                 kkval_ = convf_;
#else
                 kkval_ = *(float*)(imedptr+incposb_);
#endif
                 if(*(axdes+kkidx_) & 0x0006)
                   {
                   if(*(axdes+kkidx_) & 0x0008)
                     kkval_ = kkval_ * kkval_;
                   else
                   if(*(axdes+kkidx_) & 0x0004)
                     ;
                   else
                   if(*(axdes+kkidx_) & 0x0002)
                     kkval_ = (float)1.0;
                   }
                 if(!(*(axdes+kkidx_) & 0x0002))
                   incposb_ += (int)sof_;
                 }
               else
                 kkval_ = (float)1.0;
               ++kkidx_;
               if((*(imedptr+k_) & (char)(1 << bk_)))
                 *(axbuf+axbufidx_) += ((ssval_ * kkval_) * (float)pre_);
               ++axbufidx_;
               }
            kkidx_ -= tr_[j_]->lenb;
            }
          else
            axbufidx_ += tr_[j_]->lenb;
          }
       kkidx_ += tr_[j_]->lenb;
       }
     else
       {
       axbufidx_ += (tr_[j_]->lena * tr_[j_]->lenb);
       ssidx_ += tr_[j_]->lena;
       kkidx_ += tr_[j_]->lenb;
       }
     comp_ <<= 1;
     }
  }

fwrite(&axbufidx_,sizeof(int),1,out);
fwrite(&fcount_,sizeof(short),1,out);
fwrite(&fkidx_,sizeof(short),1,out);
fwrite(axbuf,sizeof(float),axbufidx_,out);

printf(" %ld Records passed.\n\n",rec_count);
if(rec_count == 0L)
  exit(1);
else
  exit(0);
}

char *mustcalloc(n_,s_,v_)
unsigned n_;
unsigned s_;
char *v_;
{
char *ret_;

if((ret_ = (char*)calloc(n_,s_)) == NULL)
  {
  printf("memory allocation error: %s\n",v_);
  exit(1);
  }
return(ret_);
}
