#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <memory.h>
#include <malloc.h>
#include <signal.h>
#include <stdarg.h>
#include "os.h"

#define PAGLENO2        55
#define PAGLEN          62
#define MAXINBUF    300003
#define FNAMLEN        256
#define MAXFILESTACK    16

#define DATA     1
#define REPORT   2
#define PRINT    3
#define APPEND   4

#define SERLEN  64

/* externe Variablen */
extern struct req_struct {
char *text;        /*text to accompany print*/
short type;        /*0-7 for require action code*/
short start;       /*first column for requires to examine*/
short finish;      /*last column to examine, or -1*/
short appear;      /*message occured this time*/
long wcount;       /*number of records passed this write*/
} req_texts_[];
extern struct file_def {
char *name;        /*file name*/
char *heading;     /*page heading for print files*/
short mptype;      /*how to output multipunches*/
char seqno;        /*filedef_ sequence number*/
char ifrule;       /*whether to print ruler*/
char ifser;        /*whether to print 'Record NNN'*/
short ifdone;      /*whether current (level of) record output to this file yet*/
int   reclen;      /*number of columns in record*/
short lineno;      /*current line number on current page*/
short pageno;      /*current page number*/
short ftype;       /*type of file*/
FILE *fp;          /*where the file is open*/
} filedef_[];
extern struct list_struct {
unsigned short *string;        /*pointer to string segment*/
double total;                  /*number of times the string appears*/
struct list_struct *nextruct;  /*the next structure*/
} lists_[];
extern struct name_struct {
        char *name;     /*pointer to variable name*/
        long arraysize; /*arraysize*/
} name_vec[];
extern int cvars;
extern int tvars;
extern int xvars;
extern int maxdata;
FILE *fpx;
FILE *fpw;
FILE *fpz;
FILE *fph;
FILE *fpl;
FILE *fps;

/* interne Variablen */
long file_count[MAXFILESTACK];
long gcount           = 0;
int filestack_counter = 0;
int eof_flag          = 0;
int fil_flag          = 0;
int miscard_          = 0;
int repcount_         = 0;
char filename_[FNAMLEN+1];
int filename_offset;
char mserial[SERLEN+1];
int cseqs_,max_file;
int oorsign_;
char t_char[128];
char *asc_s;
unsigned short *c_tmp;
short *lways;
int *lcnts;
char **lsstr;
double *lval;
char ruler_[] = "   ___+___ 1 ___+___ 2 ___+___ 3 ___+___ 4 ___+___ 5 ___+___ 6 ___+___ 7 ___+___ 8 ___+___ 9 ___+___ 0";
char hcr1_[]  = "   Col       &      -      0      1      2      3      4      5      6      7      8      9  Blank        Den1   Den2   Den3+ Total";
char hcr2_[]  = "   --------------------------------------------------------------------------------------------------------------------------------";
char lst1_[]  = "String                                                Frequency      Cumulative";
char lst2_[]  = "------                                                ---------      ----------";
unsigned short bt[8400];
unsigned short qval[] = {
0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,
0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,
0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x0000,
0x0482,0x0006,0x0042,0x0442,0x0222,0x0800,0x0012,0x0812,0x0412,0x0422,0x080a,
0x0242,0x0400,0x0842,0x0300,0x0200,0x0100,0x0080,0x0040,0x0020,0x0010,0x0008,
0x0004,0x0002,0x0001,0x0082,0x040a,0x0822,0x000a,0x020a,0x0206,0x0022,0x0900,
0x0880,0x0840,0x0820,0x0810,0x0808,0x0804,0x0802,0x0801,0x0500,0x0480,0x0440,
0x0420,0x0410,0x0408,0x0404,0x0402,0x0401,0x0280,0x0240,0x0220,0x0210,0x0208,
0x0204,0x0202,0x0201,0x1fff,0x0282,0x1fff,0x1fff,0x0212,0x0902,0x0b00,0x0a80,
0x0a40,0x0a20,0x0a10,0x0a08,0x0a04,0x0a02,0x0a01,0x0d00,0x0c80,0x0c40,0x0c20,
0x0c10,0x0c08,0x0c04,0x0c02,0x0c01,0x0680,0x0640,0x0620,0x0610,0x0608,0x0604,
0x0602,0x0601,0x0a00,0x0882,0x0600,0x0700,0x1fff,
0x2001,0x2002,0x2003,0x2004,0x2005,0x2006,0x2007,0x2008,0x2009,0x200a,0x200b,
0x200c,0x200d,0x200e,0x200f,0x2010,0x2011,0x2012,0x2013,0x2014,0x2015,0x2016,
0x2017,0x2018,0x2019,0x201a,0x201b,0x201c,0x201d,0x201e,0x201f,0x2020,0x2021,
0x2022,0x2023,0x2024,0x2025,0x2026,0x2027,0x2028,0x2029,0x202a,0x202b,0x202c,
0x202d,0x202e,0x202f,0x2030,0x2031,0x2032,0x2033,0x2034,0x2035,0x2036,0x2037,
0x2038,0x2039,0x203a,0x203b,0x203c,0x203d,0x203e,0x203f,0x2040,0x2041,0x2042,
0x2043,0x2044,0x2045,0x2046,0x2047,0x2048,0x2049,0x204a,0x204b,0x204c,0x204d,
0x204e,0x204f,0x2050,0x2051,0x2052,0x2053,0x2054,0x2055,0x2056,0x2057,0x2058,
0x2059,0x205a,0x205b,0x205c,0x205d,0x205e,0x205f,0x2060,0x2061,0x2062,0x2063,
0x2064,0x2065,0x2066,0x2067,0x2068,0x2069,0x206a,0x206b,0x206c,0x206d,0x206e,
0x206f,0x2070,0x2071,0x2072,0x2073,0x2074,0x2075,0x2076,0x2077,0x2078,0x2079,
0x207a,0x207b,0x207c,0x207d,0x207e,0x207f,0x2080
                        };
char qfolg[ ] = "&-01234567890-&";

/* Alle in diesem Programmteil auftretenden Funktionen */
int range();
int rangeb();
int incint_();
int inccol_();
long numbf();
void countf();
void nlistf();
void colcmv_();
void colsmv_();
void fillblankf_();
void rfillcode_();
void reqtype_();
void reqout_();
void swaprec_();
int colcol_();
int blankf_();
int colstrn_();
int readrec();
int readtrc();
void subwrite();
void mkhead();
void subwriterec();
void writerec();
void subwriteout();
void writerecout();
void setbintab();
int setqtmstr();
int setqtmstrout();
void setbintail();
char ccisdigit();
char fccisdigit();
char rangedigit();
char rangebdigit();
unsigned short getbintail();
unsigned short gethighval_();
double fcolfnc_();
long colfnc_();
void colint_();
void colreal_();
void prior_();
void wrtrec();
void dotabsect_();
void setrec_();
void newrec_high_();
void newrec_rep_();
int testreq_();
int testrep_();
void process_();
char *mustcalloc();
char *mkmpstr_();
char *mpastr_();
void outhct_();
void outlst_();
char *getstr_();
char *colasc_();
void sortstr_();
void sortval_();
void sortsum_();
void cvtba_();
void val_t1();
void val_t2();
void val_t3();
void errset_();
char getcode_();
int nobits_();
void null_division();
void fetch_report_out();
int test_line_();
int check_file_end();
void qfprnt(long fileidx, char *fmt, ...);

main(argc,argv)
int argc;
char *argv[];
{
FILE *filestack_[MAXFILESTACK];
register int i;
int lastread_file;
int asc_l;
float of        = (float)0.0;
int corrdat_    = 0;
int tabfdat_    = 0;
int trunctd_    = 0;
int oorange_    = 0;
int dupcard_    = 0;
int oldcard     = 0;
long run_count  = 0;
int card        = 0;
int msganz_     = 0;
short isfp_     = 0;
short blankfnd_ = 0;
short lastrdone_= 0;
short firstrec_ = 0;
int repfound_   = 0;
char nserial[SERLEN+1];
char oserial[SERLEN+1];
char opentype[2];
/* externe Variablen */
extern int structargs[];
extern long *thisread;
extern long *allread;
extern unsigned short *c;
extern unsigned short *cx;
extern long *t;
extern double *x;
extern short stop_id;
extern short lastrec;
extern short lastread;
extern long crange[][2];
extern int ncounts;
extern int nlists;
extern float htotal[];
extern double list_total[];
extern int list_slen[];
extern long rec_count;
extern long rec_acc;
extern long rec_rej;
extern short nologo_;
extern short nodata_;

if(signal(SIGFPE,null_division) == SIG_ERR)
   printf("unable to install signal handler\n");

if(!nologo_)
  {
  printf("\n");
  printf("PAN-DATA CCOUNT - data pass    Version 1.0w\n");
  printf("Created 16.03.2004        prog: V. Hoffmann\n\n");
  }

if(!nodata_)
  {
  if(argc < 2)
    filestack_[filestack_counter] = stdin;
  else
  if((filestack_[filestack_counter] = fopen(argv[1],"r")) == NULL)
    {
    puts("cannot open data file");
    exit(1);
    }
  file_count[filestack_counter] = 0;
  lastread_file = filestack_counter;
  filestack_counter++;
  }

if((fpx = fopen("intermed.ccc","wb")) == NULL)
  { puts("Error opening file intermed.ccc"); exit(1); }
if((fpw = fopen("ccwght.ccc","wb")) == NULL)
  { puts("Error opening file ccwght.ccc"); exit(1); }
if((fpz = fopen("cctabs.ccc","wb")) == NULL)
  { puts("Error opening file cctabs.ccc"); exit(1); }
if(ncounts)
  if((fph = fopen("hct_","w")) == NULL)
    { puts("Error opening file hct_"); exit(1); }
if(nlists)
  if((fpl = fopen("lst_","w")) == NULL)
    { puts("Error opening file lst_"); exit(1); }
if((fps = fopen("sum_","w")) == NULL)
  { puts("Error opening file sum_"); exit(1); }

max_file = 0;
while(filedef_[max_file].name != NULL)
  {
  if(filedef_[max_file].ftype == APPEND)
    strcpy(opentype,"a");
  else
    strcpy(opentype,"w");
  if((filedef_[max_file].fp = fopen(filedef_[max_file].name,opentype)) == NULL)
    {
    printf("Error opening file %s\n",filedef_[max_file].name);
    exit(1);
    }
  ++max_file;
  }

setbintab();
varset_();

cseqs_ = cvars / (structargs[5] + 1);
/* initialisieren der default-variablen */
for(i=0;i<=tvars;i++)
   *(t+i) = 0;
for(i=0;i<=xvars;i++)
   *(x+i) = 0.0;
for(i=0;i<ncounts;i++)
   {
   crange[i][0] = 0;
   crange[i][1] = 0;
   htotal[i]    = (float)0.0;
   }
for(i=0;i<nlists;i++)
   {
   list_total[i] = 0.0;
   list_slen[i]  = 0;
   lists_[i].string = NULL;
   }
asc_s = (char *)(mustcalloc((unsigned)MAXINBUF+1,sizeof(char),"asc_s"));
c_tmp = (unsigned short *)(mustcalloc((unsigned)(maxdata+1),sizeof(unsigned short),"c_tmp"));
if(nlists)
  {
  lways = (short *)(mustcalloc((unsigned)nlists,sizeof(short),"lways"));
  lcnts = (int *)(mustcalloc((unsigned)nlists,sizeof(int),"lcnts"));
  }
*(asc_s+MAXINBUF) = '\0';
strcpy(nserial,"\0");strcpy(mserial,"\0");strcpy(oserial,"\0");
newrec_high_();
mkhead((long)0,0);
if(nodata_)
  {
  while(!stop_id)
    {
    process_();
    newrec_high_();
    }
  }
else
while(filestack_counter)
  {
  while(fgets(asc_s,MAXINBUF,filestack_[filestack_counter-1]) != NULL && !stop_id)
    {
    asc_l = strlen(asc_s) - 1;
    if(asc_l && *(asc_s+(asc_l-1)) == 0x0d)
      asc_l--;
    while(asc_l && *(asc_s+(asc_l-1)) == ' ')
      {
      asc_l--;
      blankfnd_ = 1;
      }
    ++run_count; file_count[filestack_counter-1]++; oorsign_ = 0;
    if(asc_l && (*(asc_s+0) == '#' || *(asc_s+0) == '*') && (filename_offset = test_line_(asc_s+1,"include")))
      {
      if(strlen(asc_s+filename_offset) > FNAMLEN)
        {
        printf("Error: data include filename %s longer than %d characters\n",asc_s+filename_offset,FNAMLEN);
        exit(1);
        }
      strcpy(filename_,asc_s+filename_offset);
      if((filestack_[filestack_counter] = fopen(filename_,"r")) == NULL)
        {
        printf("Error opening file %s\n",filename_);
        exit(1);
        }
      else
        {
        if(filestack_counter >= MAXFILESTACK)
          {
          printf("Error: data include files nested too deeply\n");
          exit(1);
          }
        fil_flag = 1;
        if(structargs[0] == 0 && fil_flag)
          {
          fprintf(filedef_[0].fp,"\n");
          mkhead((long)0,1);
          fprintf(filedef_[0].fp,"Including file %.100s\n",filename_);
          mkhead((long)0,1);
          fil_flag = 0;
          }
        if(check_file_end(filestack_[filestack_counter-1]))
          lastread_file = filestack_counter;
        file_count[filestack_counter] = 0;
        filestack_counter++;
        continue;
        }
      }
    asc_l = readrec(c+1,asc_s,asc_l,structargs[8]);
    if(asc_l == -1)
      {
      ++corrdat_;
      fprintf(filedef_[0].fp,"Data error: card %ld in run, %ld in file: corrupt multipunched data\n\n",
              run_count,file_count[filestack_counter-1]);
      mkhead((long)0,2);
      continue;
      }
    else
    if(asc_l == -2)
      {
      ++tabfdat_;
      fprintf(filedef_[0].fp,"Data error: card %ld in run, %ld in file: tab chars in data\n\n",
              run_count,file_count[filestack_counter-1]);
      mkhead((long)0,2);
      continue;
      }
    if(asc_l > structargs[8])
      {
      ++trunctd_;
      fprintf(filedef_[0].fp,"Data error: card %ld in run, %ld in file: record truncated at col %d\n\n",
              run_count,file_count[filestack_counter-1],structargs[8]);
      mkhead((long)0,2);
      if((asc_l = readtrc(c+1,asc_s,asc_l,structargs[8])) == -1)
        {
        ++corrdat_;
        fprintf(filedef_[0].fp,"Data error: card %ld in run, %ld in file: corrupt multipunched data\n\n",
                run_count,file_count[filestack_counter-1]);
        mkhead((long)0,2);
        continue;
        }
      }

    for(i=asc_l+1;i<=cseqs_;i++)
       *(c+i) = (unsigned short)0;

    if(lastread_file == (filestack_counter-1))
      lastrec = check_file_end(filestack_[filestack_counter-1]);

    if(structargs[3])
      {
      if(structargs[4] > SERLEN)
        {
        fprintf(filedef_[0].fp,"Warning: serial number truncated to %d characters\n\n",SERLEN);
        structargs[4] = SERLEN;
        }
      strcpy(nserial,getstr_(c+structargs[3],structargs[4]));
      }

    if(!firstrec_)
      {
      firstrec_ = 1;
      strcpy(oserial,nserial);
      gcount = file_count[filestack_counter-1];
      }
    if(structargs[0] == 0)  /* read = 0 */
      {
      setrec_(0);
      strcpy(mserial,nserial);
      gcount = file_count[filestack_counter-1];
      process_();
      newrec_high_();
      }
    else
    if(structargs[0] == 2)  /* read = 2 */
      {
      card = (int)colfnc_(c,(long)structargs[1],(long)structargs[2]);
      if((card > structargs[5]) || (card < 1))
        {
        ++oorange_;
        fprintf(filedef_[0].fp,"Record structure error: serial number %s, card %ld in run, %ld in file\n",
                nserial,run_count,file_count[filestack_counter-1]);
        fprintf(filedef_[0].fp,"card type %d - out of range\n\n",card);
        fprintf(filedef_[0].fp,"%-100s\n",asc_s);
        mkhead((long)0,5);
        oorsign_ = 1;
        }
      if(!strcmp(oserial,nserial))
        {
        repfound_ = testrep_(card);
        if(!oorsign_ && repfound_ && (card <= oldcard))
          {
          strcpy(mserial,oserial);
          if(lastrec)
            {
            lastrdone_ = 1;
            lastrec = 0;
            }
          process_();
          if(lastrdone_)
            lastrec = 1;
          gcount = file_count[filestack_counter-1];
          newrec_rep_();
          setrec_(card);
          oldcard = card;
          }
        else
        if(!oorsign_ && !repfound_ && *(thisread+card))
          {
          ++dupcard_;
          fprintf(filedef_[0].fp,"Record structure error: serial number %s, card %ld in run, %ld in file\n",
                  nserial,run_count,file_count[filestack_counter-1]);
          fprintf(filedef_[0].fp,"card type %d - duplicate\n\n",card);
          fprintf(filedef_[0].fp,"%-100s\n",asc_s);
          mkhead((long)0,5);
          setrec_(card);
          }
        else
          {
          setrec_(card);
          oldcard = card;
          }
        }
      else
        {
        strcpy(mserial,oserial);
        strcpy(oserial,nserial);
        lastread = 1;
        if(lastrec)
          {
          lastrdone_ = 1;
          lastrec = 0;
          }
        process_();
        if(lastrdone_)
          lastrec = 1;
        gcount = file_count[filestack_counter-1];
        newrec_high_();
        setrec_(card);
        oldcard = 0;
        }
      if(lastrec)
        {
        strcpy(mserial,oserial);
        lastread = 1;
        process_();
        }
      }
    else
    if(structargs[0] == 3)  /* read = 3 */
      {
      ++card;
      if(card > structargs[5] && !strcmp(oserial,nserial))
        {
        ++oorange_;
        fprintf(filedef_[0].fp,"Record structure error: serial number %s, card %ld in run, %ld in file\n",
                nserial,run_count,file_count[filestack_counter-1]);
        fprintf(filedef_[0].fp,"card type %d - out of range\n\n",card);
        fprintf(filedef_[0].fp,"%-100s\n",asc_s);
        mkhead((long)0,5);
        oorsign_ = 1;
        }
      if(!strcmp(oserial,nserial))
        setrec_(card);
      else
        {
        strcpy(mserial,oserial);
        strcpy(oserial,nserial);
        lastread = 1;
        process_();
        gcount = file_count[filestack_counter-1];
        newrec_high_();
        card = 1;
        setrec_(card);
        }
      if(lastrec)
        {
        strcpy(mserial,oserial);
        lastread = 1;
        process_();
        }
      }
    if(structargs[0] > 0 && eof_flag)
      {
      fprintf(filedef_[0].fp,"\n");
      mkhead((long)0,1);
      fprintf(filedef_[0].fp,"** EOF **\n");
      mkhead((long)0,1);
      eof_flag = 0;
      }
    if(structargs[0] > 0 && fil_flag)
      {
      fprintf(filedef_[0].fp,"\n");
      mkhead((long)0,1);
      fprintf(filedef_[0].fp,"Including file %.100s\n",filename_);
      mkhead((long)0,1);
      fil_flag = 0;
      }
    }
  fclose(filestack_[--filestack_counter]);
  if(filestack_counter)
    {
    eof_flag = 1;
    if(structargs[0] == 0 && eof_flag)
      {
      fprintf(filedef_[0].fp,"\n");
      mkhead((long)0,1);
      fprintf(filedef_[0].fp,"** EOF **\n");
      mkhead((long)0,1);
      eof_flag = 0;
      }
    }
  }

if(stop_id)
  {
  fprintf(filedef_[0].fp,"\n");
  mkhead((long)0,1);
  fprintf(filedef_[0].fp,"*** Run stopped ***\n");
  mkhead((long)0,1);
  }
fetch_report_out();
mkhead((long)0,999);
fprintf(filedef_[0].fp,"           summary of exceptions\n\n");
fprintf(filedef_[0].fp,"%7ld cards read\n",run_count);
fprintf(filedef_[0].fp,"%7ld records\n",rec_count);
of = (float)0.0;
if(rec_count)
  of = (float)(rec_acc * 100.0 / rec_count);
fprintf(filedef_[0].fp,"%7ld (%3.0f%%) records accepted\n",rec_acc,of);
of = (float)0.0;
if(rec_count)
  of = (float)(rec_rej * 100.0 / rec_count);
fprintf(filedef_[0].fp,"%7ld (%3.0f%%) records rejected\n\n",rec_rej,of);
mkhead((long)0,7);
i = 0;
while(req_texts_[i].text != NULL)
  {
  if(req_texts_[i].finish && req_texts_[i].start != -1)
    {
    if(!req_texts_[i].wcount)
      req_texts_[i].text = (char *)(mustcalloc(128,sizeof(char),"req_texts[i].text"));
    if(req_texts_[i].finish == 1)
      sprintf(req_texts_[i].text,"occurences of column %d",req_texts_[i].start);
    else
    if(req_texts_[i].finish == -1)
      sprintf(req_texts_[i].text,"occurences of variable defined columns");
    else
      sprintf(req_texts_[i].text,"occurences in range %d - %d",req_texts_[i].start,(req_texts_[i].start+req_texts_[i].finish)-1);
    }
  of = (float)0.0;
  if(rec_count)
    of = (float)(req_texts_[i].wcount * 100.0 / rec_count);
  fprintf(filedef_[0].fp,"%7ld (%3.0f%%) %s\n",req_texts_[i].wcount,of,req_texts_[i].text);
  mkhead((long)0,1);
  ++i;
  }
msganz_ = i;
if(tabfdat_)
  {
  fprintf(filedef_[0].fp,"%7d records with tabchars found in run\n",tabfdat_);
  mkhead((long)0,1);
  }
if(corrdat_)
  {
  fprintf(filedef_[0].fp,"%7d corrupt m/p strings in data\n",corrdat_);
  mkhead((long)0,1);
  }
if(trunctd_)
  {
  fprintf(filedef_[0].fp,"%7d truncated cards in run\n",trunctd_);
  mkhead((long)0,1);
  }
if(oorange_)
  {
  fprintf(filedef_[0].fp,"%7d out of range cards in run\n",oorange_);
  mkhead((long)0,1);
  }
if(dupcard_)
  {
  fprintf(filedef_[0].fp,"%7d duplicate cards in run\n",dupcard_);
  mkhead((long)0,1);
  }
if(miscard_)
  {
  fprintf(filedef_[0].fp,"%7d missing cards in run\n",miscard_);
  mkhead((long)0,1);
  }
if(blankfnd_)
  {
  fprintf(filedef_[0].fp,"Warning: blank(s) found (ignored) at the end of record(s)\n");
  mkhead((long)0,1);
  }
mkhead((long)0,999);
fprintf(filedef_[0].fp,"There were %d T variables. Here are the values of the non-zero T variables:\n",tvars);
mkhead((long)0,1);
for(i=0;i<=tvars;i++)
   if(t[i])
     {
     fprintf(filedef_[0].fp,"t%d = %ld\n",i,t[i]);
     mkhead((long)0,1);
     }
sortsum_(msganz_);
fprintf(fps,"\f\n\n");
fprintf(fps,"           summary of exceptions (sorted)\n\n");
fprintf(fps,"%7ld records\n",rec_count);
of = (float)0.0;
if(rec_count)
  of = (float)(rec_acc * 100.0 / rec_count);
fprintf(fps,"%7ld (%3.0f%%) records accepted\n",rec_acc,of);
of = (float)0.0;
if(rec_count)
  of = (float)(rec_rej * 100.0 / rec_count);
fprintf(fps,"%7ld (%3.0f%%) records rejected\n\n",rec_rej,of);
for(i=0;i<msganz_;i++)
  {
  of = (float)0.0;
  if(rec_count)
    of = (float)(req_texts_[i].wcount * 100.0 / rec_count);
  if(!isfp_ && (of <= (float)5.0))
    {
    fprintf(fps,"\n------------------------------------------ 5 %% --------------------------------\n\n");
    isfp_ = 1;
    }
  fprintf(fps,"%7ld (%3.0f%%) %s\n",req_texts_[i].wcount,of,req_texts_[i].text);
  }
if(tabfdat_)
  fprintf(fps,"%7d records with tabchars found in run\n",tabfdat_);
if(corrdat_)
  fprintf(fps,"%7d corrupt m/p strings in data\n",corrdat_);
if(trunctd_)
  fprintf(fps,"%7d truncated cards in run\n",trunctd_);
if(oorange_)
  fprintf(fps,"%7d out of range cards in run\n",oorange_);
if(dupcard_)
  fprintf(fps,"%7d duplicate cards in run\n",dupcard_);
if(miscard_)
  fprintf(fps,"%7d missing cards in run\n",miscard_);
if(blankfnd_)
  fprintf(fps,"Warning: blank(s) found (ignored) at the end of record(s)\n");
fprintf(fps,"\f\n\n");
fprintf(fps,"There were %d T variables. Here are the values of the non-zero T variables:\n",tvars);
for(i=0;i<=tvars;i++)
   if(t[i])
     fprintf(fps,"t%d = %ld\n",i,t[i]);
if(!nologo_)
  printf(" %ld Records passed.\n\n",rec_count);
if(tabfdat_)
  printf("    %d records with tabchars found in run\n",tabfdat_);
if(corrdat_)
  printf("    %d corrupt m/p strings in data\n",corrdat_);
if(trunctd_)
  printf("    %d truncated cards in run\n",trunctd_);
if(oorange_)
  printf("    %d out of range cards in run\n",oorange_);
if(dupcard_)
  printf("    %d duplicate cards in run\n",dupcard_);
if(miscard_)
  printf("    %d missing cards in run\n",miscard_);
if(blankfnd_)
  printf("Warning: blank(s) found (ignored) at the end of record(s) in data file\n");
printf("\n");

if(ncounts)
  outhct_();
if(nlists)
  outlst_();

exit(0);
}

void process_()
{
extern long rec_count;
extern short rejected_;
extern short printed_;
extern long rec_rej;
extern long rec_acc;
extern short nologo_;
extern short firstread;
extern short rep_cards[];

if(testreq_())
  {
  printed_ = 0;
  if(rep_cards[0] != (short)-1)
    repcount_++;
  ed_sect_();
  if(rejected_)
    {
    ++rec_rej;
    rejected_ = 0;
    }
  else
    {
    ++rec_acc;
    dotabsect_();
    }
  firstread = 0;
  }
else
  ++rec_rej;

if(!(++rec_count % 1000))
  {
  if(!nologo_)
    printf(" %ld Records\n",rec_count);
  }
else
if(!(rec_count % 100))
  {
  if(!nologo_)
    {
    putchar('.');
    fflush(stdout);
    }
  }
}

void setrec_(card_)
int card_;
{
extern int structargs[];
extern long *thisread;
extern long *allread;
extern unsigned short *c;
register int i_,d_;

if(!oorsign_)
  {
  d_ = card_*cseqs_;
  for(i_=1;i_<=structargs[8];i_++)
     *(c+d_+i_) = *(c+i_);

  *(thisread+card_) = 1;
  *(allread+card_) += 1;
  }
}

void newrec_high_()
{
register int i_;
extern int structargs[];
extern long *thisread;
extern long *allread;
extern short lastread;
extern short firstread;
extern unsigned short *c;
extern int edcorr;

lastread = 0; firstread = 1; repcount_ = 0;
for(i_=structargs[8]+1;i_<=cvars;i_++)
   *(c+i_) = (unsigned short)0;
for(i_=0;i_<=structargs[5];i_++)
   {
   *(thisread+i_) = 0;
   *(allread+i_)  = 0;
   }
i_ = 0;
while(filedef_[i_].name != NULL)
  {
  if(filedef_[i_].ifdone == 2)
    fprintf(filedef_[i_].fp,"\n");
  filedef_[i_].ifdone = 0;
  ++i_;
  }
if(edcorr)
  {
  i_ = 0;
  while(req_texts_[i_].text != NULL)
    req_texts_[i_++].appear = 0;
  }
}

int testreq_()
{
register int i_;
int ret_ = 1;
extern long *thisread;
extern short req_cards[];
extern int structargs[];

 i_ = 0;
 while(req_cards[i_] != -1)
   {
   if(((int)req_cards[i_] > structargs[5]) || (!*(thisread+(int)req_cards[i_])))
     {
     ++miscard_;
     fprintf(filedef_[0].fp,"Record structure error: missing card in record %s card type %d\n\n",mserial,req_cards[i_]);
     mkhead((long)0,2);
     ret_ = 0;
     }
   ++i_;
   }
return(ret_);
}

/* allgemeine Funktionen */
int rangeb(startcol,endcol,minval,maxval)
long startcol;
long endcol;
long minval;
long maxval;
{
int ret_ = 1;
int n_   = 0;
int digitsign_ = 0;
long collen_,compval_;
register int i_;
long nflag_ = 1;
unsigned short sign_;
extern unsigned short *c;

collen_ = (endcol - startcol) + 1;
for(i_=0;i_<(int)collen_;i_++)
   {
   sign_ = *(c+startcol+i_);
   if(sign_ & 0x0400 && sign_ != 0x0400)
     nflag_ = -1;
   if((*(t_char+n_) = rangebdigit(sign_ & 0x0bff)) == '\0')
     {
     ret_ = 0;
     break;
     }
   if(*(t_char+n_) >= '0' && *(t_char+n_) <= '9')
     digitsign_ = 1;
   else
   if(*(t_char+n_) == ' ' && digitsign_)
     {
     ret_ = 0;
     break;
     }
   ++n_;
   }
*(t_char+n_) = '\0';

if(ret_)
  {
  sscanf(t_char,"%ld",&compval_);
  compval_ *= nflag_;
  if(compval_ < minval || compval_ > maxval)
    ret_ = 0;
  }

return(ret_);
}

int range(startcol,endcol,minval,maxval)
long startcol;
long endcol;
long minval;
long maxval;
{
int ret_ = 1;
int n_   = 0;
long collen_,compval_;
register int i_;
long nflag_ = 1;
unsigned short sign_;
extern unsigned short *c;

collen_ = (endcol - startcol) + 1;
for(i_=0;i_<(int)collen_;i_++)
   {
   sign_ = *(c+startcol+i_);
   if(sign_ & 0x0400)
     nflag_ = -1;
   if((*(t_char+n_++) = rangedigit(sign_ & 0x0bff)) == '\0')
     {
     ret_ = 0;
     break;
     }
   }
*(t_char+n_) = '\0';

if(ret_)
  {
  sscanf(t_char,"%ld",&compval_);
  compval_ *= nflag_;
  if(compval_ < minval || compval_ > maxval)
    ret_ = 0;
  }

return(ret_);
}

int incint_(destint,compstr)
long destint;
char *compstr;
{
char *ctab[256];
char buf[4096];
short count;
short len_;
register short i;
short jn;
long von,bis,lp;

strcpy(buf,compstr);
len_ = strlen(buf);

count = 0; jn = 0;
for(i=0;i<len_;i++)
   {
   if(*(buf + i) != ' ')
     {
     if(!jn)
       {
       ctab[count++] = buf + i;
       jn = 1;
       }
     }
     else
     {
     *(buf + i) = '\0';
     jn = 0;
     }
   }

for(i=0;i<count;i++)
   {
   if(!strcmp(ctab[i],":"))
     {
     sscanf(ctab[i-1],"%ld",&von);
     sscanf(ctab[i+1],"%ld",&bis);
     i += 1;
     if(destint >= von && destint <= bis)
       return(1);
     }
   else
   if(strcmp(ctab[i],","))
     {
     if(*(ctab[i]+0) == '$')
       {
       len_ = strlen(ctab[i]) - 1;
       *(ctab[i]+len_) = '\0';
       sscanf(ctab[i]+1,"%ld",&lp);
       }
     else
       sscanf(ctab[i],"%ld",&lp);
     if(destint == lp)
       return(1);
     }
   }

return(0);
}

int inccol_(destcol,destpos,destlen,compstr)
unsigned short *destcol;
long destpos;
long destlen;
char *compstr;
{
char *ctab[256];
char buf[4096];
short count;
short len_;
register short i;
short jn;
short dl_ = 0;
long von,bis,lp,l_;
extern unsigned short *c;

if((destpos < 0L) || (destlen < 1L) || destcol == c && (destpos+destlen) > (cvars + 1))
  errset_(destpos,destlen);
else
  {
  strcpy(buf,compstr);
  len_ = strlen(buf);

  count = 0; jn = 0;
  for(i=0;i<len_;i++)
     {
     if(*(buf + i) == '$')
       dl_ = 1 - dl_;
     if(*(buf + i) != ' ' || dl_)
       {
       if(!jn)
         {
         ctab[count++] = buf + i;
         jn = 1;
         }
       }
       else
       {
       *(buf + i) = '\0';
       jn = 0;
       }
     }

  for(i=0;i<count;i++)
     {
     if(!strcmp(ctab[i],":"))
       {
       sscanf(ctab[i-1],"%ld",&von);
       sscanf(ctab[i+1],"%ld",&bis);
       i += 1;
       lp = colfnc_(destcol,destpos,destlen);
       if(lp >= von && lp <= bis)
         return(1);
       }
     else
     if(strcmp(ctab[i],",") && *(ctab[i]+0) != '$')
       {
       sscanf(ctab[i],"%ld",&lp);
       if(colfnc_(destcol,destpos,destlen) == lp)
         return(1);
       }
     else
     if(*(ctab[i]+0) == '$')
       {
       l_ = (long)strlen(ctab[i]) - 1;
       *(ctab[i]+(int)l_) = '\0';
       if(colstrn_(destcol,destpos,destlen,ctab[i]+1,l_-1))
         return(1);
       }
     }
  }

return(0);
}

void stop_()
{
extern short stop_id;

stop_id = 1;
printf("\n** Data Reading has been stopped\n");
fprintf(filedef_[0].fp,"\n");
mkhead((long)0,1);
fprintf(filedef_[0].fp,"** Data Reading has been stopped\n");
mkhead((long)0,1);
}

long numbf(sourcecol)
unsigned short sourcecol;
{
long ret_ = 0;
unsigned short u_ = sourcecol;

while(u_)
  {
  if(u_ & 0x0800)
    ++ret_;
  u_ <<= 1;
  }
return(ret_);
}

double fcolfnc_(destcol,destpos,destlen)
unsigned short *destcol;
long destpos;
long destlen;
{
register int i_;
char z_;
double ret_ = 0.0;
int n_    = 0;
double nflag_ = 1.0;
extern unsigned short *cx;

if((destpos < 0L) || (destlen < 1L) || destcol == cx && (destpos+destlen) > (cvars + 1))
  errset_(destpos,destlen);
else
  {
  for(i_=0;i_<(int)destlen;i_++)
     if((z_ = fccisdigit(*(destcol+destpos+i_))) != '\0')
       if(z_ == '-')
         nflag_ = -1.0;
       else
         *(t_char+n_++) = z_;
  *(t_char+n_) = '\0';

  if(n_)
    sscanf(t_char,"%lf",&ret_);
  }

return(ret_ * nflag_);
}

long colfnc_(destcol,destpos,destlen)
unsigned short *destcol;
long destpos;
long destlen;
{
register int i_;
char z_;
long ret_ = 0;
int n_    = 0;
long nflag_ = 1;
extern unsigned short *c;

if((destpos < 0L) || (destlen < 1L) || destcol == c && (destpos+destlen) > (cvars + 1))
  errset_(destpos,destlen);
else
  {
  for(i_=0;i_<(int)destlen;i_++)
     if((z_ = ccisdigit(*(destcol+destpos+i_))) != '\0')
       if(z_ == '-')
         nflag_ = -1;
       else
         *(t_char+n_++) = z_;
  *(t_char+n_) = '\0';

  if(n_)
    sscanf(t_char,"%ld",&ret_);
  }

return(ret_ * nflag_);
}

void colreal_(destcol,destpos,destlen,destpoint,sourcerval)
unsigned short *destcol;
long destpos;
long destlen;
long destpoint;
double sourcerval;
{
char k_strg[16];
register int i_;
extern unsigned short *cx;

if((destpos < 0L) || (destlen < 1L) || destcol == cx && (destpos+destlen) > (cvars + 1))
  errset_(destpos,destlen);
else
  {
  sprintf(k_strg,"%%0%ld.%ldf\0",destlen,destpoint);
  sprintf(t_char,k_strg,sourcerval);
  for(i_=0;i_<(int)destlen;i_++)
     *(destcol+destpos+i_) = qval[(unsigned char)*(t_char+i_)];
  }
}

void colint_(destcol,destpos,destlen,sourcelval)
unsigned short *destcol;
long destpos;
long destlen;
long sourcelval;
{
char k_strg[16];
register int i_;
extern unsigned short *c;

if((destpos < 0L) || (destlen < 1L) || destcol == c && (destpos+destlen) > (cvars + 1))
  errset_(destpos,destlen);
else
  {
  sprintf(k_strg,"%%0%ldld",destlen);
  sprintf(t_char,k_strg,sourcelval);
  for(i_=0;i_<(int)destlen;i_++)
     *(destcol+destpos+i_) = qval[(unsigned char)*(t_char+i_)];
  }
}

void colcmv_(destcol,destpos,destlen,sourcecol,sourcepos,sourcelen)
unsigned short *destcol;
long destpos;
long destlen;
unsigned short *sourcecol;
long sourcepos;
long sourcelen;
{
register int i_;
long d_;
extern unsigned short *c;

d_ = destlen-sourcelen;
if((destpos < 0L) || (destlen < 1L) || destcol == c && (destpos+destlen) > (cvars + 1))
  errset_(destpos,destlen);
else
if((sourcepos < 0L) || (sourcelen < 1L) || sourcecol == c && (sourcepos+sourcelen) > (cvars + 1))
  errset_(sourcepos,sourcelen);
else
if((long)destcol+destpos+d_ < (long)destcol)
  printf("Array Dimension Error-Setting to Col %ld\n",destpos+d_);
else
  {
  for(i_=0;i_<(int)sourcelen;i_++)
     *(c_tmp+i_) = *(sourcecol+sourcepos+i_);
  for(i_=0;i_<(int)d_;i_++)
     *(destcol+destpos+i_) = 0x0000;
  for(i_=0;i_<(int)sourcelen;i_++)
     *(destcol+destpos+i_+d_) = *(c_tmp+i_);
  }
}

void colsmv_(destcol,destpos,destlen,sourcestr,sourcelen)
unsigned short *destcol;
long destpos;
long destlen;
char *sourcestr;
long sourcelen;
{
register int i_;
long d_;
extern unsigned short *c;

d_ = destlen-sourcelen;
if((destpos < 0L) || (destlen < 1L) || destcol == c && (destpos+destlen) > (cvars + 1))
  errset_(destpos,destlen);
else
if((long)destcol+destpos+d_ < (long)destcol)
  printf("Array Dimension Error-Setting to Col %ld\n",destpos+d_);
else
  {
  for(i_=0;i_<(int)d_;i_++)
     *(destcol+destpos+i_) = 0x0000;
  for(i_=0;i_<(int)sourcelen;i_++)
     *(destcol+destpos+i_+d_) = qval[(unsigned char)*(sourcestr+i_)];
  }
}

void fillblankf_(destcol,destpos,destlen)
unsigned short *destcol;
long destpos;
long destlen;
{
register int i_;
extern unsigned short *c;

if((destpos < 0L) || (destlen < 1L) || destcol == c && (destpos+destlen) > (cvars + 1))
  errset_(destpos,destlen);
else
  for(i_=0;i_<(int)destlen;i_++)
     *(destcol+destpos+i_) = 0x0000;
}

void rfillcode_(destcol,destpos,destlen,iv_)
unsigned short *destcol;
long destpos;
long destlen;
unsigned short iv_;
{
register int i_;
extern unsigned short *c;

if((destpos < 0L) || (destlen < 1L) || destcol == c && (destpos+destlen) > (cvars + 1))
  errset_(destpos,destlen);
else
  {
  for(i_=0;i_<(int)destlen;i_++)
     *(destcol+destpos+i_) = 0x0000;
  *(destcol+destpos+(destlen-1)) = iv_;
  }
}

int colcol_(destcol,destpos,destlen,sourcecol,sourcepos,sourcelen)
unsigned short *destcol;
long destpos;
long destlen;
unsigned short *sourcecol;
long sourcepos;
long sourcelen;
{
register int i_;
int ret_ = 1;
extern unsigned short *c;

if((destpos < 0L) || (destlen < 1L) || destcol == c && (destpos+destlen) > (cvars + 1))
  errset_(destpos,destlen);
else
if((sourcepos < 0L) || (sourcelen < 1L) || sourcecol == c && (sourcepos+sourcelen) > (cvars + 1))
  errset_(sourcepos,sourcelen);
else
  {
  if(destlen != sourcelen)
    ret_ = 0;
  else
    for(i_=0;i_<(int)destlen;i_++)
       if(*(destcol+destpos+i_) != *(sourcecol+sourcepos+i_))
         {
         ret_ = 0;
         break;
         }
  }

return(ret_);
}

int blankf_(destcol,destpos,destlen)
unsigned short *destcol;
long destpos;
long destlen;
{
register int i_;
int ret_ = 1;
extern unsigned short *c;

if((destpos < 0L) || (destlen < 1L) || destcol == c && (destpos+destlen) > (cvars + 1))
  errset_(destpos,destlen);
else
  {
  for(i_=0;i_<(int)destlen;i_++)
     if(*(destcol+destpos+i_) != 0x0000)
       {
       ret_ = 0;
       break;
       }
  }

return(ret_);
}

int colstrn_(destcol,destpos,destlen,sourcestr,sourcelen)
unsigned short *destcol;
long destpos;
long destlen;
char *sourcestr;
long sourcelen;
{
register int i_;
int ret_ = 1;
extern unsigned short *c;

if((destpos < 0L) || (destlen < 1L) || destcol == c && (destpos+destlen) > (cvars + 1))
  errset_(destpos,destlen);
else
  {
  if(destlen != sourcelen)
    ret_ = 0;
  else
    for(i_=0;i_<(int)destlen;i_++)
       if(*(destcol+destpos+i_) != qval[(unsigned char)*(sourcestr+i_)])
         {
         ret_ = 0;
         break;
         }
  }

return(ret_);
}

void prior_(code_)
unsigned short code_;
{
extern int pri1_ ;
extern unsigned short *pri2_ ;

if(pri1_ && (*pri2_ & code_))
  pri1_ = 0;
else
  *pri2_ &= 0x0FFF - code_;
}

void dotabsect_()
{

tabroutine_();
ax_c();
wrtrec();

}

void wrtrec()
{
extern int tabbuflng_;
extern int axbuflng_;
extern int numbincs_;
extern unsigned short tabbuf_[];
extern unsigned short buffer__[];
extern float value[];
extern int wmlevs_;
extern double pre;

fwrite((char*)tabbuf_ ,sizeof(char),tabbuflng_,fpz);
fwrite((char*)buffer__,sizeof(char),axbuflng_ ,fpx);
fwrite((char*)value   ,sizeof(char),numbincs_ ,fpx);
if(wmlevs_)
  fwrite(&pre,sizeof(double),1,fpw);
memset(tabbuf_,0,(unsigned)tabbuflng_);
memset(value,0,(unsigned)numbincs_);

}

void setbintab()
{
register int i_;
extern char mp_char;

qval[(unsigned char)mp_char] |= 0x1000;

for(i_=0;i_<8400;i_++)
   bt[i_]=(unsigned short)mp_char;

for(i_=0;i_<256;i_++)
   if(!(qval[i_] & 0x1000))
     bt[qval[i_]]=(unsigned short)i_;

}

int setqtmstr(instr,inlen,outstr)
unsigned short *instr;
long inlen;
char *outstr;
{
register int i_,j_;
int m_ = 0;
extern char mp_char;

while(!instr[(int)inlen-1])
  --inlen;

for(i_=0;i_<(int)inlen;i_++)
   if((*(outstr+i_) = (char)bt[instr[i_]]) == mp_char)
     m_ = i_ + 1;

if(m_)
  {
  --m_;
  *(outstr+i_) = 0x7f;
  for(j_=0;j_<=m_;j_++)
     if(*(outstr+j_) == mp_char)
       {
       setbintail(outstr,i_,instr[j_]);
       i_ += 2;
       }
  ++i_;
  }
return(i_);
}

void setbintail(tout,tpos,tval)
char *tout;
int tpos;
unsigned short tval;
{

*(tout+tpos+1) = ((tval & 0x0fc0) >> 6) | 0x40;
*(tout+tpos+2) = (tval & 0x003f) | 0x40;

}

void writerec(wfp,instr,coloffset,inlen,msgnbr)
long wfp;
unsigned short *instr;
long coloffset;
long inlen;
long msgnbr;
{
extern int structargs[];
extern long *thisread;
extern int edcorr;
register int i_;
extern unsigned short *c;

if((coloffset < 0L) || (inlen < 1L) || instr == c && (coloffset+inlen) > (cvars + 1))
  errset_(coloffset,inlen);
else
if(!filedef_[(int)wfp].ifdone || filedef_[(int)wfp].ftype == APPEND)
  {
  filedef_[(int)wfp].ifdone = 1;
  for(i_=0;i_<=structargs[5];i_++)
     if(*(thisread+i_))
       subwriterec(wfp,instr,(i_*cseqs_)+coloffset,inlen);
  }
req_texts_[(int)msgnbr].wcount += 1;
if(edcorr)
  req_texts_[(int)msgnbr].appear = 1;
}

void subwriterec(wfp,instr,coloffset,inlen)
long wfp;
unsigned short *instr;
long coloffset;
long inlen;
{
int writereclen_;
extern unsigned short *c;

if((coloffset < 0L) || (inlen < 1L) || instr == c && (coloffset+inlen) > (cvars + 1))
  errset_(coloffset,inlen);
else
  {
  writereclen_ = setqtmstr(instr+coloffset,(long)inlen,asc_s);
  fwrite(asc_s,sizeof(char),(unsigned int)writereclen_,filedef_[(int)wfp].fp);
  fwrite("\n",sizeof(char),1,filedef_[(int)wfp].fp);
  if(filedef_[(int)wfp].ftype == APPEND)
    fflush(filedef_[(int)wfp].fp);
  }
}

void subwrite(wfp,instr,coloffset,inlen,msgnbr)
long wfp;
unsigned short *instr;
long coloffset;
long inlen;
long msgnbr;
{
int writereclen_;
extern int edcorr;
extern unsigned short *c;

if((coloffset < 0L) || (inlen < 1L) || instr == c && (coloffset+inlen) > (cvars + 1))
  errset_(coloffset,inlen);
else
  {
  writereclen_ = setqtmstr(instr+coloffset,(long)inlen,asc_s);
  fwrite(asc_s,sizeof(char),(unsigned int)writereclen_,filedef_[(int)wfp].fp);
  fwrite("\n",sizeof(char),1,filedef_[(int)wfp].fp);
  req_texts_[(int)msgnbr].wcount += 1;
  }
if(edcorr)
  req_texts_[(int)msgnbr].appear = 1;
}

int readrec(destcol,sourcestr,sourcestrlen,mustlen)
unsigned short *destcol;
char *sourcestr;
int sourcestrlen;
int mustlen;
{
register int i_,m_,n_;
int ret_;
short tabchar_ = 0;

if(sourcestrlen < mustlen)
  ret_ = sourcestrlen;
else
  ret_ = mustlen;
for(i_=0;i_<ret_;i_++)
   {
   if(*(sourcestr+i_) == 0x09)
     tabchar_ = 1;
   else
   if(*(sourcestr+i_) == 0x7f)
     break;
   *(destcol+i_) = qval[(unsigned char)*(sourcestr+i_)];
   }
if(*(sourcestr+i_) == 0x7f)
  {
  n_ = i_ + 1;
  for(m_=0;m_<i_;m_++)
     if(*(destcol+m_) & 0x1000)
       {
       if(n_+2 > sourcestrlen)
         ret_ = -1;
       else
         *(destcol+m_) = getbintail(sourcestr+n_);
       n_ += 2;
       }
  if(n_ < sourcestrlen)
    ret_ = -1;
  else
    ret_ = i_;
  }
else
  ret_ = sourcestrlen;
if(tabchar_)
  ret_ = -2;
return(ret_);
}

int readtrc(destcol,sourcestr,sourcestrlen,mustlen)
unsigned short *destcol;
char *sourcestr;
int sourcestrlen;
int mustlen;
{
register int i_,m_,n_;
int ret_ = 0;

for(i_=0;i_<sourcestrlen;i_++)
   {
   if(*(sourcestr+i_) == 0x7f)
     break;
   if(i_ < mustlen)
     {
     *(destcol+i_) = qval[(unsigned char)*(sourcestr+i_)];
     ++ret_;
     }
   }
n_ = i_ + 1;
for(m_=0;m_<i_;m_++)
   if((m_ < mustlen) && (*(destcol+m_) & 0x1000))
     {
     if(n_+2 > sourcestrlen)
       ret_ = -1;
     else
       if(m_ < mustlen)
         *(destcol+m_) = getbintail(sourcestr+n_);
     n_ += 2;
     }
return(ret_);
}

unsigned short getbintail(sourceval)
char *sourceval;
{
unsigned short retval_;

retval_  = (unsigned short) (*(sourceval+0) & 0x3f) << 6;
retval_ |= (unsigned short)  *(sourceval+1) & 0x3f;

return(retval_);
}

char ccisdigit(ccid_us)
unsigned short ccid_us;
{
char z_;
char ret_ = '\0';

z_ = (char)bt[(int)ccid_us];
if((z_ >= '0' && z_ <= '9') || z_ == '-')
  ret_ = z_;
return(ret_);
}

char fccisdigit(ccid_us)
unsigned short ccid_us;
{
char z_;
char ret_ = '\0';

z_ = (char)bt[(int)ccid_us];
if((z_ >= '0' && z_ <= '9') || z_ == '-' || z_ == '.')
  ret_ = z_;
return(ret_);
}

char rangebdigit(ccid_us)
unsigned short ccid_us;
{
char z_;
char ret_ = '\0';

z_ = (char)bt[(int)ccid_us];
if((z_ >= '0' && z_ <= '9') || z_ == ' ')
  ret_ = z_;
return(ret_);
}

char rangedigit(ccid_us)
unsigned short ccid_us;
{
char z_;
char ret_ = '\0';

z_ = (char)bt[(int)ccid_us];
if(z_ >= '0' && z_ <= '9')
  ret_ = z_;
return(ret_);
}

void writerecout(wfp,instr,coloffset,inlen,msgnbr)
long wfp;
unsigned short *instr;
long coloffset;
long inlen;
long msgnbr;
{
extern int structargs[];
extern long *allread;
extern short printed_;
extern int edcorr;
extern short trun_;
extern short rejected_;
register int i_;
int writereclen_;
int first_;
int j_,k_,l_,m_;
char s_[64];
extern unsigned short *c;

if((coloffset < 0L) || (inlen < 1L) || instr == c && (coloffset+inlen) > (cvars + 1))
  errset_(coloffset,inlen);
else
if(req_texts_[(int)msgnbr].type & 0x0002)
  {
  sprintf(s_,"%-29s%%.%lds\n\0","",inlen);
  k_ = (int)(coloffset % 100) + 1;
  mkhead(wfp,0);
  if(!filedef_[(int)wfp].ifdone)
    {
    filedef_[(int)wfp].ifdone = 1;
    fprintf(filedef_[(int)wfp].fp,"\n");
    m_ = 1;
    if((int)filedef_[(int)wfp].ifser)
      {
      if(structargs[3])
        {
        if(repcount_)
          fprintf(filedef_[(int)wfp].fp,"%23sRecord %s - read %d","",mserial,repcount_);
        else
          fprintf(filedef_[(int)wfp].fp,"%23sRecord %s","",mserial);
        fprintf(filedef_[(int)wfp].fp,"%39s%ld in file\n","",gcount);
        if(edcorr && !trun_)
          {
          if(repcount_)
            fprintf(stdout,"Record %s - read %d\n",mserial,repcount_);
          else
            fprintf(stdout,"Record %s\n",mserial);
          fprintf(stdout,"%ld in file\n",gcount);
          }
        }
      else
        {
        fprintf(filedef_[(int)wfp].fp,"%74s%ld in file\n","",gcount);
        if(edcorr && !trun_)
          fprintf(stdout,"%ld in file\n",gcount);
        }
      ++m_;
      }
    if((int)filedef_[(int)wfp].ifrule)
      {
      fprintf(filedef_[(int)wfp].fp,s_,ruler_+k_);
      ++m_;
      }
    mkhead(wfp,m_);
    if(structargs[0] == 2 || structargs[0] == 3)
      {
      for(i_=0;i_<=structargs[5];i_++)
         if(*(allread+i_))
           {
           j_ = (i_*cseqs_)+(int)coloffset;
           swaprec_(instr+j_,(long)inlen);
           first_ = 1;
           while((writereclen_ = setqtmstrout(c_tmp,(long)inlen,asc_s,wfp)) || first_)
              {
              if(first_)
                fprintf(filedef_[(int)wfp].fp,"Columns  %5ld -  %5ld are |",(long)j_,(long)j_+(inlen-1));
              else
                {
                if(filedef_[(int)wfp].mptype != 3)
                  fprintf(filedef_[(int)wfp].fp,"                            |");
                else
                  fprintf(filedef_[(int)wfp].fp,"                             ");
                }
              fprintf(filedef_[(int)wfp].fp,"%s\n",asc_s);
              mkhead(wfp,1);
              first_ = 0;
              }
           }
      }
    else
      {
      if(*(allread+0))
        {
        k_ = ((int)inlen+99) / 100;
        for(i_=0;i_<k_;i_++)
           {
           j_ = (i_*100);
           if((j_+100) <= (int)inlen)
             l_ = 100;
           else
             l_ = (int)inlen % 100;
           j_ += coloffset;
           swaprec_(instr+j_,(long)l_);
           first_ = 1;
           while((writereclen_ = setqtmstrout(c_tmp,(long)l_,asc_s,wfp)) || first_)
              {
              if(first_)
                fprintf(filedef_[(int)wfp].fp,"Columns  %5ld -  %5ld are |",(long)j_,(long)j_+(l_ -1));
              else
                {
                if(filedef_[(int)wfp].mptype != 3)
                  fprintf(filedef_[(int)wfp].fp,"                            |");
                else
                  fprintf(filedef_[(int)wfp].fp,"                             ");
                }
              fprintf(filedef_[(int)wfp].fp,"%s\n",asc_s);
              mkhead(wfp,1);
              first_ = 0;
              }
           }
        }
      }
    }
  fprintf(filedef_[(int)wfp].fp,"                              %-.100s\n",req_texts_[(int)msgnbr].text);
  mkhead(wfp,1);
  if(edcorr && !trun_)
    fprintf(stdout,"%-.100s\n",req_texts_[(int)msgnbr].text);
  printed_ = 1;
  }
if(req_texts_[(int)msgnbr].type & 0x0001)
  rejected_ = 1;
req_texts_[(int)msgnbr].wcount += 1;
if(edcorr)
  req_texts_[(int)msgnbr].appear = 1;
}

void subwriteout(wfp,instr,coloffset,inlen,msgnbr)
long wfp;
unsigned short *instr;
long coloffset;
long inlen;
long msgnbr;
{
extern int structargs[];
extern short printed_;
extern int edcorr;
extern short trun_;
int writereclen_;
int first_;
int k_,m_;
char s_[64];
extern unsigned short *c;

if((coloffset < 0L) || (inlen < 1L) || instr == c && (coloffset+inlen) > (cvars + 1))
  errset_(coloffset,inlen);
else
  {
  sprintf(s_,"%-29s%%.%lds\n\0","",inlen);
  k_ = (int)(coloffset % 100) + 1;
  swaprec_(instr+coloffset,(long)inlen);
  mkhead(wfp,0);
  fprintf(filedef_[(int)wfp].fp,"\n");
  m_ = 1;
  if((int)filedef_[(int)wfp].ifser)
    {
    if(structargs[3])
      {
      if(repcount_)
        fprintf(filedef_[(int)wfp].fp,"%23sRecord %s - read %d","",mserial,repcount_);
      else
        fprintf(filedef_[(int)wfp].fp,"%23sRecord %s","",mserial);
      fprintf(filedef_[(int)wfp].fp,"%39s%ld in file\n","",gcount);
      if(edcorr && !trun_)
        {
        if(repcount_)
          fprintf(stdout,"Record %s - read %d\n",mserial,repcount_);
        else
          fprintf(stdout,"Record %s\n",mserial);
        fprintf(stdout,"%ld in file\n",gcount);
        }
      }
    else
      {
      fprintf(filedef_[(int)wfp].fp,"%74s%ld in file\n","",gcount);
      if(edcorr && !trun_)
        fprintf(stdout,"%ld in file\n",gcount);
      }
    ++m_;
    }
  if((int)filedef_[(int)wfp].ifrule)
    {
    fprintf(filedef_[(int)wfp].fp,s_,ruler_+k_);
    ++m_;
    }
  mkhead(wfp,m_);
  first_ = 1;
  while((writereclen_ = setqtmstrout(c_tmp,(long)inlen,asc_s,wfp)) || first_)
     {
     if(first_)
       fprintf(filedef_[(int)wfp].fp,"Columns  %5ld -  %5ld are |",(long)coloffset,(long)coloffset+(inlen-1));
     else
       {
       if(filedef_[(int)wfp].mptype != 3)
         fprintf(filedef_[(int)wfp].fp,"                            |");
       else
         fprintf(filedef_[(int)wfp].fp,"                             ");
       }
     fprintf(filedef_[(int)wfp].fp,"%s\n",asc_s);
     mkhead(wfp,1);
     first_ = 0;
     }
  fprintf(filedef_[(int)wfp].fp,"                              %-.100s\n",req_texts_[(int)msgnbr].text);
  mkhead(wfp,1);
  if(edcorr && !trun_)
    fprintf(stdout,"%-.100s\n",req_texts_[(int)msgnbr].text);
  printed_ = 1;
  }
req_texts_[(int)msgnbr].wcount += 1;
if(edcorr)
  req_texts_[(int)msgnbr].appear = 1;
}

int setqtmstrout(instr,inlen,outstr,wfp)
unsigned short *instr;
long inlen;
char *outstr;
long wfp;
{
register int i_;
unsigned short us_;
static short b_ = 0;

while(!instr[(int)inlen-1])
  --inlen;

if(filedef_[(int)wfp].mptype == 0)
  {
  for(i_=0;i_<(int)inlen;i_++)
     *(outstr+i_) = (char)bt[(int)instr[i_]];
  *(outstr+i_) = '\0';
  i_ = 0;
  }
else
if(filedef_[(int)wfp].mptype == 1)
  {
  for(i_=0;i_<(int)inlen;i_++)
     {
     us_ = gethighval_(instr[i_]);
     *(outstr+i_) = (char)bt[(int)us_];
     instr[i_] &= 0x0FFF - us_;
     }
  *(outstr+i_) = '\0';
  }
else
if(filedef_[(int)wfp].mptype == 2)
  {
  *(outstr+0) = '\0';
  for(i_=0;i_<(int)inlen;i_++)
     {
     if((int)numbf(instr[i_]) > 1)
       {
       strcat(outstr,"{");
       strcat(outstr,mpastr_(instr[i_]));
       strcat(outstr,"}");
       }
     else
       strcat(outstr,mpastr_(instr[i_]));
     }
  i_ = 0;
  }
else
if(filedef_[(int)wfp].mptype == 3)
  {
  if(!b_)
    {
    for(i_=0;i_<(int)inlen;i_++)
       {
       if((int)numbf(instr[i_]) > 1)
         b_ = 1;
       *(outstr+i_) = (char)bt[(int)instr[i_]];
       }
    *(outstr+i_) = '\0';
    if(!b_)
      i_ = 0;
    }
  else
    {
    b_ = 0;
    for(i_=0;i_<(int)inlen;i_++)
       if((int)numbf(instr[i_]) > 1)
         {
         sprintf(outstr,"Column %3d contains codes %s",i_+1,mpastr_(instr[i_]));
         instr[i_] = (unsigned short)0;
         b_ = 1;
         break;
         }
    if(!b_)
      i_ = 0;
    else
      i_ = 1;
    }
  }
return(i_);
}

char *mustcalloc(n_,s_,v_)
unsigned n_;
unsigned s_;
char *v_;
{
char *ret_;

if((ret_ = (char*)calloc(n_,s_)) == NULL)
  {
  printf("memory allocation error: %s\n",v_);
  exit(1);
  }
return(ret_);
}

void swaprec_(instr,inlen_)
unsigned short *instr;
long inlen_;
{
register int i_;

for(i_=0;i_<(int)inlen_;i_++)
   *(c_tmp+i_) = *(instr+i_);
}

unsigned short gethighval_(us_)
unsigned short us_;
{
unsigned short ret_ = 0;
register int i_;

for(i_=0;i_<12;i_++)
   if(us_ & (0x0800 >> i_))
     {
     ret_ = 0x0800 >> i_;
     break;
     }

return(ret_);
}

void reqtype_(rtype,sourcecol,sourcepos,sourcelen,code,par1,par2,msgnbr)
long rtype;
unsigned short *sourcecol;
long sourcepos;
long sourcelen;
unsigned short code;
long par1;
unsigned short par2;
long msgnbr;
{
extern int structargs[];
register int i_;
unsigned short u_;

u_ = (unsigned short)0x0FFF - code;

if(rtype == 1L)
  {
  for(i_=0;i_<(int)sourcelen;i_++)
     if((*(sourcecol+sourcepos+i_) & code) || (par1 && (*(sourcecol+sourcepos+i_) & u_)))
       {
       reqout_((long)sourcepos+i_,sourcecol,msgnbr);
       if((short)par2 != (short)-1)
         *(sourcecol+sourcepos+i_) = par2 ;
       }
  }
else
if(rtype == 2L)
  {
  for(i_=0;i_<(int)sourcelen;i_++)
     if((!(*(sourcecol+sourcepos+i_) & code)) || (par1 && (*(sourcecol+sourcepos+i_) & u_)))
       {
       reqout_((long)sourcepos+i_,sourcecol,msgnbr);
       if((short)par2 != (short)-1)
         *(sourcecol+sourcepos+i_) = par2 ;
       }
  }
else
if(rtype == 3L)
  {
  for(i_=0;i_<(int)sourcelen;i_++)
     if((numbf(*(sourcecol+sourcepos+i_) & code) != 1L) || (par1 && (*(sourcecol+sourcepos+i_) & u_)))
       {
       reqout_((long)sourcepos+i_,sourcecol,msgnbr);
       if((short)par2 != (short)-1)
         *(sourcecol+sourcepos+i_) = par2 ;
       }
  }
else
if(rtype == 4L)
  {
  for(i_=0;i_<(int)sourcelen;i_++)
     if((numbf(*(sourcecol+sourcepos+i_) & code) > 1L) || (par1 && (*(sourcecol+sourcepos+i_) & u_)))
       {
       reqout_((long)sourcepos+i_,sourcecol,msgnbr);
       if((short)par2 != (short)-1)
         *(sourcecol+sourcepos+i_) = par2 ;
       }
  }
}

void reqout_(pos,sourcecol,msgnbr)
long pos;
unsigned short *sourcecol;
long msgnbr;
{
extern int structargs[];

if(req_texts_[(int)msgnbr].start != -1)
  {
  if(!req_texts_[(int)msgnbr].wcount)
    req_texts_[(int)msgnbr].text = (char *)(mustcalloc(128,sizeof(char),"req_texts[n].text"));
  sprintf(req_texts_[(int)msgnbr].text,"%s%ld%s%s","column ",pos," is ",mkmpstr_(*(sourcecol+(int)pos)));
  }
writerecout(0L,sourcecol,1L,(long)filedef_[0].reclen,(long)msgnbr);
}

char *mkmpstr_(u_)
unsigned short u_;
{
register short i_;
short j_ = 0;
static char os_[13];

for(i_=0;i_<12;i_++)
   if(0x0800 & (u_ << i_))
     *(os_+j_++) = qfolg[i_];
*(os_+j_) = '\0';
if(!j_)
  strcpy(os_,"blank");

return(os_);
}

char *mpastr_(u_)
unsigned short u_;
{
register short i_;
short j_ = 0;
static char os_[13];

for(i_=0;i_<12;i_++)
   if(0x0800 & (u_ << i_))
     *(os_+j_++) = qfolg[i_];
*(os_+j_) = '\0';
if(!j_)
  strcpy(os_," ");

return(os_);
}

void mkhead(wfp,l_)
long wfp;
short l_;
{

filedef_[(int)wfp].lineno += l_;
if(filedef_[(int)wfp].lineno != 1002)
  {
  if((!filedef_[(int)wfp].ifdone) && (filedef_[(int)wfp].lineno > (PAGLENO2-5)))
    {
    fprintf(filedef_[(int)wfp].fp,"\f");
    filedef_[(int)wfp].lineno = 0;
    }
  else
  if(filedef_[(int)wfp].lineno >= PAGLENO2)
    {
    fprintf(filedef_[(int)wfp].fp,"\f");
    filedef_[(int)wfp].lineno = 0;
    }
  if(filedef_[(int)wfp].lineno == 0)
    {
    filedef_[(int)wfp].pageno ++;
    fprintf(filedef_[(int)wfp].fp,"%-120sPage %d\n\n\n",filedef_[(int)wfp].heading,filedef_[(int)wfp].pageno);
    filedef_[(int)wfp].lineno = 3;
    }
  }
else
  filedef_[(int)wfp].lineno = 3;
}

void countf(seq,destcol,destpos,destlen,ctxt,ccol,cpos,clen)
long seq;
unsigned short *destcol;
long destpos;
long destlen;
char *ctxt;
unsigned short *ccol;
long cpos;
long clen;
{
extern long crange[][2];
extern float *hcount[];
extern char *textp[];
extern float htotal[];
extern unsigned short *c;
register int i_,j_;
int k_;
int l_;
float gew_ = (float)1.0;

if((destpos < 0L) || (destlen < 1L) || destcol == c && (destpos+destlen) > (cvars + 1))
  errset_(destpos,destlen);
else
  {
  if(!crange[(int)seq][1])
    {
    crange[(int)seq][0] = destpos;
    crange[(int)seq][1] = destpos + destlen;
    hcount[(int)seq] = (float *)(mustcalloc((unsigned)destlen*17,sizeof(float),"hcount[seq]"));
    for(i_=0;i_<(int)destlen*17;i_++)
       hcount[(int)seq][i_] = (float)0.0;
    textp[(int)seq] = ctxt;
    }
  if(cpos != -1)
    gew_ =  (float)fcolfnc_(ccol,cpos,clen);
  htotal[(int)seq] += gew_;
  for(i_=0;i_<(int)destlen;i_++)
     {
     if(!*(destcol+destpos+(long)i_))
       {
       k_ = (i_*17)+12;
       hcount[(int)seq][k_] = hcount[(int)seq][k_] + gew_;
       }
     else
       {
       l_ = 0;
       for(j_=0;j_<12;j_++)
          if(0x0800 & (*(destcol+destpos+(long)i_) << j_))
            {
            k_ = (i_*17)+j_;
            hcount[(int)seq][k_] = hcount[(int)seq][k_] + gew_;
            ++l_;
            }
       if(l_ == 1)
         k_ = (i_*17)+13;
       else
       if(l_ == 2)
         k_ = (i_*17)+14;
       else
       if(l_ >= 3)
         k_ = (i_*17)+15;
       hcount[(int)seq][k_] = hcount[(int)seq][k_] + gew_;
       k_ = (i_*17)+16;
       hcount[(int)seq][k_] = hcount[(int)seq][k_] + ((float)l_ * gew_);
       }
     }
  }
}

void outhct_()
{
register int i_,j_;
int k_;
short l_,m_,n_,o_;
char ptext[133];
extern long crange[][2];
extern int ncounts;
extern float htotal[];
extern float *hcount[];
extern char *textp[];

for(k_=0;k_<ncounts;k_++)
   if(crange[k_][1])
     {
     j_ = 0; m_ = 0;
     for(i_=(int)crange[k_][0],j_=0;i_<(int)crange[k_][1];i_++,j_+= 17)
        {
        if(!(m_%16))
          {
          fprintf(fph,"\f%s\n\n\n",textp[k_]);
          fprintf(fph,"Total = %.0f\n\n",htotal[k_]);
          fprintf(fph,"%s\n",hcr1_);
          fprintf(fph,"%s\n",hcr2_);
          }
        for(l_=0;l_<133;l_++)
           ptext[l_] = ' ';
        ptext[132] = '\0';
        fprintf(fph,"%8s%94s\n","|","|");
        fprintf(fph,"%6d |",i_);
        fprintf(fph,"%6.0f",hcount[k_][j_+ 0]);
        for(n_=1;n_<=12;n_++)
           fprintf(fph,"%7.0f",hcount[k_][j_+ n_]);
        fprintf(fph,"   |");
        fprintf(fph,"%8.0f",hcount[k_][j_+13]);
        for(n_=14;n_<=16;n_++)
           fprintf(fph,"%7.0f",hcount[k_][j_+ n_]);
        fprintf(fph,"\n");
        *(ptext+  7) = '|';
        if(htotal[k_] != (float)0.0 && htotal[k_] != (float)0.0)
          {
          for(n_=0,o_=9;n_<=12;n_++,o_+=7)
             if(hcount[k_][j_+ n_] != (float)0.0)
               sprintf(ptext+ o_,"%5.1f%%",hcount[k_][j_+ n_] / htotal[k_]*100.0);
          if(hcount[k_][j_+13] != (float)0.0)
            sprintf(ptext+105,"%5.1f%%",hcount[k_][j_+13] / htotal[k_]*100.0);
          if(hcount[k_][j_+14] != (float)0.0)
            sprintf(ptext+112,"%5.1f%%",hcount[k_][j_+14] / htotal[k_]*100.0);
          if(hcount[k_][j_+15] != (float)0.0)
            sprintf(ptext+119,"%5.1f%%",hcount[k_][j_+15] / htotal[k_]*100.0);
          sprintf(ptext+126,"%5.2f",hcount[k_][j_+16] / htotal[k_]);
          }
        *(ptext+101) = '|';
        for(l_=0;l_<132;l_++)
           if(ptext[l_] == '\0')
             ptext[l_] = ' ';
        fprintf(fph,"%s\n",ptext);
        ++m_;
        }
     }
}

void nlistf(seq,destcol,destpos,destlen,ctxt,ccol,cpos,clen,way)
long seq;
unsigned short *destcol;
long destpos;
long destlen;
char *ctxt;
unsigned short *ccol;
long cpos;
long clen;
long way;
{
float gew_ = (float)1.0;
short found_ = 0;
struct list_struct *p_;
extern int list_slen[];
extern char *textl[];
extern double list_total[];

if(!list_slen[(int)seq])
  {
  list_slen[(int)seq] = (int)destlen;
  textl[(int)seq] = ctxt;
  lways[(int)seq] = (short)way;
  lcnts[(int)seq] = 0;
  }
if(cpos != -1)
  gew_ =  (float)fcolfnc_(ccol,cpos,clen);
list_total[(int)seq] += gew_;

p_ = &lists_[(int)seq];
while(p_->string != NULL)
  {
  if(colcol_(p_->string,0L,destlen,destcol,destpos,destlen))
    {
    p_->total += gew_;
    found_ = 1;
    break;
    }
  p_ = p_->nextruct;
  }
if(!found_)
  {
  p_->string = (unsigned short *)(mustcalloc((unsigned)destlen,sizeof(unsigned short),"p_->string"));
  colcmv_(p_->string,0L,destlen,destcol,destpos,destlen);
  p_->total += gew_;
  p_->nextruct = (struct list_struct *)(mustcalloc((unsigned)1,sizeof(struct list_struct),"p_->nextruct"));
  p_ = p_->nextruct;
  p_->string = NULL;
  ++lcnts[(int)seq];
  }
}

void outlst_()
{
register short i_;
short k_,subway,j_;
short left_  = 0;
short right_ = 0;
double cm_,sum_,mean_,buff_,stdd_,sumx_,dm_,vor_,zero_;
int lines_;
char sway[32];
extern int nlists;
extern char *textl[];
extern double list_total[];
extern int list_slen[];

for(k_=0;k_<nlists;k_++)
   {
   if(list_total[k_] != 0.0)
     {
     cvtba_(k_);
     while(lways[k_])
       {
       if(lways[k_] & 1)
         {
         subway = 1;
         lways[k_] -= 1;
         strcpy(sway,"Alphabetical sort");
         sortstr_(lsstr,lval,lcnts[k_]);
         }
       else
       if(lways[k_] & 2)
         {
         subway = 2;
         lways[k_] -= 2;
         strcpy(sway,"Rank sort");
         sortval_(lsstr,lval,lcnts[k_]);
         }
       else
       if(lways[k_] & 4)
         {
         subway = 4;
         lways[k_] -= 4;
         strcpy(sway,"Consecutive ranges");
         sortstr_(lsstr,lval,lcnts[k_]);
         }
       cm_ = 0.0; sum_ = 0.0; sumx_ = 0.0; buff_ = 0.0; dm_ = 0.0; vor_ = 0.0;
       lines_ = PAGLEN; zero_ = 0.0; j_ = 0; right_ = 0;
       for(i_=0;i_<lcnts[k_];i_++)
         {
         if(lines_ >= PAGLEN)
           {
           fprintf(fpl,"\f\n%s\n\n",textl[k_]);
           fprintf(fpl,"%79s\n\n",sway);
           fprintf(fpl,"Total = %.0f\n\n",list_total[k_]);
           fprintf(fpl,"%s\n",lst1_);
           fprintf(fpl,"%s\n\n",lst2_);
           lines_ = 10;
           }
         buff_ = 0.0;
         sscanf(*(lsstr+i_),"%lf",&buff_);
         if(subway == 4)
           {
           if(buff_ == 0.0)
             {
             zero_ += *(lval+i_);
             continue;
             }
           if(!j_)
             {
             dm_ += *(lval+i_);
             cm_ += *(lval+i_);
             left_ = i_; vor_ = buff_;
             }
           else
           if(vor_ != 0.0 && (buff_ > 0.0 && (vor_ + 1.0) == buff_ ||
              buff_ < 0.0 && (vor_ - 1.0) == buff_ || vor_ == buff_))
             {
             dm_ += *(lval+i_);
             cm_ += *(lval+i_);
             right_ = i_; vor_ = buff_;
             }
           else
           if(j_)
             {
             fprintf(fpl,"%-25s",*(lsstr+left_));
             if(right_)
               fprintf(fpl,"%-25s",*(lsstr+right_));
             else
               fprintf(fpl,"%-25s","");
             fprintf(fpl,"%5.0f",dm_);
             fprintf(fpl,"%7.1f%%",dm_/list_total[k_]*100.0);
             fprintf(fpl,"%8.0f",cm_);
             fprintf(fpl,"%7.1f%%\n",cm_/list_total[k_]*100.0);
             left_ = i_; right_ = 0; dm_ = *(lval+i_); cm_ += *(lval+i_); vor_ = buff_;
             ++lines_;
             }
           ++j_;
           }
         else
           {
           cm_ += *(lval+i_);
           sum_ += (buff_ * *(lval+i_));
           sumx_ += (*(lval+i_) * (buff_*buff_));
           fprintf(fpl,"%-50s",*(lsstr+i_));
           fprintf(fpl,"%5.0f",*(lval+i_));
           fprintf(fpl,"%7.1f%%",*(lval+i_)/list_total[k_]*100.0);
           fprintf(fpl,"%8.0f",cm_);
           fprintf(fpl,"%7.1f%%\n",cm_/list_total[k_]*100.0);
           ++lines_;
           }
         }
       if(subway == 1)
         {
         fprintf(fpl,"\n\nNumber of categories = %d\n\n",lcnts[k_]);
         if(cm_ > 1.0)
           {
           mean_ = sum_ / cm_;
           stdd_ =  sqrt((sumx_ - ((sum_*sum_)/cm_)) / (cm_-1.0));
           if(lines_+9 > PAGLEN)
             fprintf(fpl,"\f");
           fprintf(fpl,"Number of numeric items = %.0f\n",cm_);
           fprintf(fpl,"Sum of factors = %9.2f\n",sum_);
           fprintf(fpl,"Mean value     = %9.2f\n",mean_);
           fprintf(fpl,"Std deviation  = %9.2f\n",stdd_);
           }
         }
       else
       if(subway == 4)
         {
         fprintf(fpl,"%-25s",*(lsstr+left_));
         if(right_)
           fprintf(fpl,"%-25s",*(lsstr+right_));
         else
           fprintf(fpl,"%-25s","");
         fprintf(fpl,"%5.0f",dm_);
         fprintf(fpl,"%7.1f%%",dm_/list_total[k_]*100.0);
         fprintf(fpl,"%8.0f",cm_);
         fprintf(fpl,"%7.1f%%\n",cm_/list_total[k_]*100.0);
         if(zero_ != 0.0)
           {
           fprintf(fpl,"%-50s","(Zero values)");
           fprintf(fpl,"%5.0f",zero_);
           fprintf(fpl,"%7.1f%%",zero_/list_total[k_]*100.0);
           cm_ += zero_;
           fprintf(fpl,"%8.0f",cm_);
           fprintf(fpl,"%7.1f%%\n",cm_/list_total[k_]*100.0);
           }
         fprintf(fpl,"\n\nNumber of categories = %d\n\n",lcnts[k_]);
         }
       }
     free(lsstr);
     free(lval);
     }
   }
}

char *getstr_(u_,l_)
unsigned short *u_;
int l_;
{
short i_;

for(i_=0;i_<l_;i_++)
   *(t_char+i_) = (char)bt[(int)*(u_+i_)];
*(t_char+i_) = '\0';

return(t_char);
}

char *colasc_(destcol,destpos,destlen)
unsigned short *destcol;
long destpos;
long destlen;
{
short i_;

for(i_=0;i_<(int)destlen;i_++)
   *(t_char+i_) = (char)bt[(int)*(destcol+i_+(int)destpos)];
*(t_char+i_) = '\0';

return(t_char);
}

char getcode_(u_,s_,l_)
unsigned short *u_;
long s_;
long l_;
{
   return((char)bt[(int)*(u_+(int)s_)]);
}

void sortstr_(v_,d_,n_)
char *v_[];
double *d_;
int n_;
{
int gap_,i_,j_;
char *temp_;
double dtemp_;

for(gap_=n_/2;gap_>0;gap_/=2)
   for(i_=gap_;i_<n_;i_++)
      for(j_=i_-gap_;j_>=0;j_-=gap_)
         {
         if(strcmp(v_[j_],v_[j_+gap_]) <= 0)
           break;
         temp_       = v_[j_];
         v_[j_]      = v_[j_+gap_];
         v_[j_+gap_] = temp_;
         dtemp_      = d_[j_];
         d_[j_]      = d_[j_+gap_];
         d_[j_+gap_] = dtemp_;
         }
}

void sortval_(v_,d_,n_)
char *v_[];
double *d_;
int n_;
{
int gap_,i_,j_;
char *temp_;
double dtemp_;

for(gap_=n_/2;gap_>0;gap_/=2)
   for(i_=gap_;i_<n_;i_++)
      for(j_=i_-gap_;j_>=0 && d_[j_]<d_[j_+gap_];j_-=gap_)
         {
         dtemp_      = d_[j_];
         d_[j_]      = d_[j_+gap_];
         d_[j_+gap_] = dtemp_;
         temp_       = v_[j_];
         v_[j_]      = v_[j_+gap_];
         v_[j_+gap_] = temp_;
         }
}

void cvtba_(k_)
short k_;
{
struct list_struct *p_;
short i_ = 0;
extern int list_slen[];

lsstr = (char **)(mustcalloc((unsigned)lcnts[k_],sizeof(char*),"lsstr"));
lval  = (double *)(mustcalloc((unsigned)lcnts[k_],sizeof(double),"lsstr"));
p_ = &lists_[k_];
while(p_->string != NULL)
  {
  strcpy((char*)p_->string,getstr_(p_->string,list_slen[k_]));
  *(lsstr+i_) = (char*)p_->string;
  *(lval+i_)  = p_->total;
  p_ = p_->nextruct;
  ++i_;
  }
}

void val_t1(dv_,vn_,os_,iv_)
unsigned short *dv_;
long vn_;
long os_;
unsigned short iv_;
{
if(os_ > name_vec[(int)vn_].arraysize || os_ < 0)
  printf("Array Dimension Error-Setting 0x%04x in %s[%ld]   arraysize is %ld\n",
         iv_,name_vec[(int)vn_].name,os_,name_vec[(int)vn_].arraysize);
else
  *(dv_+os_) = iv_;
}

void val_t2(dv_,vn_,os_,iv_)
long *dv_;
long vn_;
long os_;
long iv_;
{
if(os_ > name_vec[(int)vn_].arraysize || os_ < 0)
  printf("Array Dimension Error-Setting %ld in %s[%ld]   arraysize is %ld\n",
         iv_,name_vec[(int)vn_].name,os_,name_vec[(int)vn_].arraysize);
else
  *(dv_+os_) = iv_;
}

void val_t3(dv_,vn_,os_,iv_)
double *dv_;
long vn_;
long os_;
double iv_;
{
if(os_ > name_vec[(int)vn_].arraysize || os_ < 0)
  printf("Array Dimension Error-Setting %f in %s[%ld]   arraysize is %ld\n",
         iv_,name_vec[(int)vn_].name,os_,name_vec[(int)vn_].arraysize);
else
  *(dv_+os_) = iv_;
}

void errset_(cp_,cl_)
long cp_;
long cl_;
{
printf("Array Dimension Error-Setting to Col %ld - %ld   maxcol is %d\n",cp_,cp_+(cl_-1),cvars);
}

void sortsum_(n_)
int n_;
{
int gap_,i_,j_;
struct req_struct temp_;

for(gap_=n_/2;gap_>0;gap_/=2)
   for(i_=gap_;i_<n_;i_++)
      for(j_=i_-gap_;j_>=0 && req_texts_[j_].wcount<req_texts_[j_+gap_].wcount;j_-=gap_)
         {
         temp_               = req_texts_[j_];
         req_texts_[j_]      = req_texts_[j_+gap_];
         req_texts_[j_+gap_] = temp_;
         }
}

int nobits_(von_,bis_)
long von_,bis_;
{
extern unsigned short axesbuf_[];
int ret_ = 1;
int i_,idx_,bit_;

for(i_=(int)von_;i_<=(int)bis_;i_++)
   {
   idx_ = (int)((i_ + 15) / 16) - 1;
   bit_ = (int)((i_ + 15) % 16);
   if((axesbuf_[idx_] & (1 << bit_)))
     {
     ret_ = 0;
     break;
     }
   }
return(ret_);
}

void null_division(sig)
int sig;
{
signal(SIGFPE, SIG_IGN);
printf("*** division by zero was detected by ccount (signal %d) - dropped out of run ...\n",sig);
exit(1);
}

void fetch_report_out()
{
extern struct struct_ffile {
       char fname[FNAMLEN+1];
       long maxcount;
       int keylen_;
       int reclen_;
       int efflen_;
       int used_;
       int hits_;
       int calls_;
       char **ftc_;
} ffile[];
extern int f_;
int i_;

if(f_)
  {
  mkhead((long)0,(short)f_+5);
  fprintf(filedef_[0].fp,"\n\n");
  fprintf(filedef_[0].fp,"Fetch file usage (%d files loaded):\n\n",f_);
  fprintf(filedef_[0].fp,"  Records      Used    Unused     Calls      Hits    Misses   File\n");
  for(i_=0;i_<f_;i_++)
     {
     fprintf(filedef_[0].fp,"%9d",ffile[i_].maxcount);
     fprintf(filedef_[0].fp,"%10d",ffile[i_].used_);
     fprintf(filedef_[0].fp,"%10d",ffile[i_].maxcount-ffile[i_].used_);
     fprintf(filedef_[0].fp,"%10d",ffile[i_].calls_);
     fprintf(filedef_[0].fp,"%10d",ffile[i_].hits_);
     fprintf(filedef_[0].fp,"%10d",ffile[i_].calls_-ffile[i_].hits_);
     fprintf(filedef_[0].fp,"   ");
     fprintf(filedef_[0].fp,"%s",ffile[i_].fname);
     fprintf(filedef_[0].fp,"\n");
     }
  }
  fprintf(filedef_[0].fp,"\n");
  mkhead((long)0,(short)1);
}

int test_line_(l_,s_)
char *l_;
char *s_;
{
int ret_,slen_,llen_,i_;

ret_ = slen_ = strlen(s_);
llen_ = strlen(l_);
if(!llen_ || (llen_ <= ret_))
  ret_ = 0;
else
  for(i_=0; i_<ret_;i_++)
     if(*(s_+i_) != (char)tolower((int)*(l_+i_)))
       {
       ret_ = 0;
       break;
       }

if(ret_)
  {
  if(llen_ && *(l_+(llen_-1)) == '\n')
    *(l_+(--llen_)) = '\0';
  while(*(l_+ret_) != '\0' && *(l_+ret_) == ' ')
    ret_++;
  ret_++;
  if(ret_ == (llen_+1))
    ret_ = 0;
  else
    if(*(l_+slen_) != ' ')
      ret_ = 0;
  }

return(ret_);
}

int check_file_end(fp)
FILE *fp;
{
int ret_ = 0;
int filend;

if((filend = getc(fp)) == EOF)
  ret_ = 1;
else
  ungetc(filend,fp);

return(ret_);
}

void qfprnt(long fileidx, char *fmt, ...)
{
va_list argp;

if(fileidx >= (long)max_file || fileidx < 0L)
  {
  printf("Error opening file number %ld in function qfprnt\n",fileidx);
  exit(1);
  }

if(filedef_[(int)fileidx].ftype == PRINT)
  mkhead(fileidx,(short)1);

va_start(argp, fmt);
vfprintf(filedef_[(int)fileidx].fp, fmt, argp);

if(filedef_[(int)fileidx].ftype == PRINT)
  fprintf(filedef_[(int)fileidx].fp,"\n");

va_end(argp);
}

void newrec_rep_()
{
register int i_;
extern int structargs[];
extern long *thisread;
extern int edcorr;

for(i_=0;i_<=structargs[5];i_++)
   *(thisread+i_) = 0;
i_ = 0;
while(filedef_[i_].name != NULL)
  {
  if(filedef_[i_].ifdone == 2)
    fprintf(filedef_[i_].fp,"\n");
  filedef_[i_].ifdone = 0;
  ++i_;
  }
if(edcorr)
  {
  i_ = 0;
  while(req_texts_[i_].text != NULL)
    req_texts_[i_++].appear = 0;
  }
}

int testrep_(card_)
int card_;
{
register int i_;
int ret_ = 0;
extern short rep_cards[];
extern int structargs[];

 i_ = 0;
 while(rep_cards[i_] != -1)
   {
   if(((int)rep_cards[i_] <= structargs[5]) && (card_ == (int)rep_cards[i_]))
     {
     ret_ = 1;
     break;
     }
   ++i_;
   }
return(ret_);
}
