#include "os.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <memory.h>
#include <malloc.h>
#include <signal.h>
#include <math.h>
#include <sys/types.h>

#define TABROUTESIZE    1500
#define COLWID_DEFAULT    16

#define D_N01    (long)0x00000001
#define D_N15    (long)0x00000002
#define D_N10    (long)0x00000004
#define D_N11    (long)0x00000008
#define D_N25    (long)0x00000010
#define D_N03    (long)0x00000020
#define D_N33    (long)0x00000040
#define D_N09    (long)0x00000080
#define D_TTL    (long)0x00000100
#define D_N12    (long)0x00000200
#define D_N17    (long)0x00000400
#define D_N04    (long)0x00000800
#define D_N05    (long)0x00001000
#define D_N13    (long)0x00002000
#define D_N19    (long)0x00004000
#define D_TTC    (long)0x00008000
#define D_TTR    (long)0x00010000
#define D_GCR    (long)0x00020000
#define D_PCR    (long)0x00040000
#define D_N23    (long)0x00080000

#define O_INCREQ    (long)0x00000001
#define O_TXTREQ    (long)0x00000002
#define O_FACREQ    (long)0x00000004
#define O_WASNET    (long)0x00000008

#define WASNONE  0
#define WASFLT   1
#define WASTAB   2

char *mustcalloc();
void newpage();
void mkabsolute_();
void mkpercentage_();
void clearvals();
void mkblank_();
int seteff();
int inumbf();
int hsetline();
int hsetlinel();
char *left();
void clearkstr();
void clearkstrl();
char *justify();
char *hjustify();
char *mktype();
void null_division();
char *mkunl_side();
void mkunl_head();
short side_autobreak();
short side_autobreak_check();
double round_();

struct tabroute {
       char  taba[16];
       short posa;
       short lena;
       short tnuma;
       short inca;
       char  tabb[16];
       short posb;
       short lenb;
       short tnumb;
       short incb;
       short fltnum;
       int   flag_1;
       unsigned short opval;
       short          dpval;
       short          dcval;
       short colwid;
       short paglen;
       short pagwid;
       short side;
       short pagenum;
       char  spechr[2];
       } ;

struct axesdef {
       long           genre;
       long           option;
       short          txtn;
       short          ttlnum;
       short          fltnum;
       short          tcase;
       int            flag_1;
       unsigned short opval;
       short          dpval;
       short          dcval;
       short          colwid;
       } ;

struct titeldef {
       char *txt;
       short tabnum;
       short fltnum;
       short tcase;
       long genre;
       };

long rec_count = 0L;
int page_      = 1;
int line_;
char kstr[200020];
char kstrl[200020];
int hmax;
int hkenn;
int posmerk[20];
int hmaxl;
int hkennl;
int posmerkl[20];
char element_format[16];
char *pbuf_[11];
char unlbuf_[10001];
char abreaktxt_[10001];
char *sbuf_[99];

main(argc,argv)
int argc;
char *argv[];
{
struct tabroute *tr_[TABROUTESIZE];
struct axesdef ad_;
struct titeldef ttl_[TABROUTESIZE];
int t_num[TABROUTESIZE];
int t_anz[TABROUTESIZE];
char **t_txt;
char **h_txt;
long *t_gen;
long *t_opt;
int  *t_eff;
unsigned short *opeff_;
short *dpeff_;
short *dceff_;
short *thlen_;
int *unlmrk_;
short *semcount_;
int *thmrk_;
unsigned short *t_opv;
short *t_dpv;
short *t_dcv;
short *t_col;
float *snn;
float *sss;
float *sqq;
float *basis_zeile;
float *summe_zeile;
float outval_,sof;
short *k_nz;
float basis_spalte,basis_total,summe_spalte;
char datnam[32];
char side_format[16];
char wert_format[16];
char text_format[16];
char spechar_[2];
float *axbuf,*facs_;
FILE *fpc; /* ccroute.inf */
FILE *fpt; /* cctitel.inf */
FILE *fax; /* *.ax-files */
FILE *out; /* ccvals.ccc */
FILE *tab; /* tab_ */
FILE *fpx; /* ccfacs.ccc */
short rcount_  = 0;
short tigm_    = 0;
int txtidx_    = 0;
int axbufidx_  = 0;
int dyncount_  = 0;
int fsidx_     = 0;
short sem_     = 0;
int suppressed_= 0;
int i_,j_,z_,q_,k_,l_,m_,mm_,ka_,la_,ma_,mi_,kmc_,ttlidx_,t_,u_,vkmc_,opc_,dmy_;
int merk_,bsign_,mjneu_,mjalt_,bmerk_,axbuf_inc,opcount_,opmax_,firstrun_,o_,oo_,cnt_;
int kpos_,jj_,ll_,nzc_,maxm_,ntmerk_,thcount_,ntot_,base_;
short fcount_,fkidx_,frew_,nwp_,sws_,swk_,newpag_,notallnz_,sum_is_base;
short basis_zeile_found,basis_total_found,side_,paglen_,pagwid_,flssg_,abreak_,a_,alen_,pctx_;
int pag_,typ_,defflag_,pct_,nzk_,unl_,nz_,unlt_,eff_,fls_,tabeff_,printz_,j_offset_,nocol_,norow_;
float nn,ss,qq,miwe,stdd,stde,facvalv_,facvalh_;
unsigned short opval_,typop_;
short dpval_,dcval_;
short colwid_,colwid_eff,actlen_,err_,gs_,p_num,n_num,p_vor,dc_,nzs_,tigma_,facm_,facma_;
short p_pos[128],actls_,perc_,cweff_,pwerr_,fthpos_,sublen_,semsub_,unl_yes_;

if(signal(SIGFPE,null_division) == SIG_ERR)
   printf("unable to install signal handler\n");

printf("\n");
printf("PAN-DATA CCOUNT - ccout        Version 1.0s\n");
printf("Created 25.11.2003        prog: V. Hoffmann\n\n");

if(argc > 1)
  if(!strcmp(argv[1],"-g"))
    sem_ = 1;
  else
    {
    fprintf(stderr,"valid options: -g\n");
    exit(1);
    }

if((fpc = fopen("ccroute.inf","rb")) == NULL)
  {
  fprintf(stderr,"cannot open ccroute.inf\n");
  exit(1);
  }
if((fpt = fopen("cctitel.inf","rb")) == NULL)
  {
  fprintf(stderr,"cannot open cctitel.inf\n");
  exit(1);
  }
if((out = fopen("ccvals.ccc","rb")) == NULL)
  {
  fprintf(stderr,"cannot open ccvals.ccc\n");
  exit(1);
  }
if((fpx = fopen("ccfacs.ccc","rb")) == NULL)
  {
  fprintf(stderr,"cannot open ccfacs.ccc\n");
  exit(1);
  }
if(sem_)
  {
  if((tab = fopen("grp_","w")) == NULL)
    {
    fprintf(stderr,"cannot open grp_\n");
    exit(1);
    }
  }
else
  {
  if((tab = fopen("tab_","w")) == NULL)
    {
    fprintf(stderr,"cannot open tab_\n");
    exit(1);
    }
  }

fread(&dmy_,sizeof(int),1,fpc);
fread(&dmy_,sizeof(int),1,fpc);
fread(&defflag_,sizeof(int),1,fpc);
fread(&opval_,sizeof(unsigned short),1,fpc);
fread(&dpval_,sizeof(short),1,fpc);
fread(&dcval_,sizeof(short),1,fpc);
fread(&colwid_,sizeof(short),1,fpc);
fread(&pctx_,sizeof(short),1,fpc);
fread(pbuf_,sizeof(char),(int)pctx_,fpc);
*(pbuf_+pctx_) = '\0';

i_ = 1;
while(i_)
  {
  if(rcount_ >= TABROUTESIZE)
    {
    fprintf(stderr,"limit of number of axes in run exeeded\n");
    exit(1);
    }
  tr_[rcount_] = (struct tabroute*)mustcalloc((unsigned)1,(unsigned)sizeof(struct tabroute),"tr_[]");
  i_ = fread(tr_[rcount_],sizeof(struct tabroute),1,fpc);
  if(i_)
    ++rcount_;
  }

ttlidx_ = 0;
while(fread(&ad_,sizeof(struct axesdef),1,fpt))
  {
  if(ttlidx_ >= TABROUTESIZE)
    {
    fprintf(stderr,"too many table titles in run\n");
    exit(1);
    }
  ttl_[ttlidx_].tabnum = ad_.ttlnum;
  ttl_[ttlidx_].fltnum = ad_.fltnum;
  ttl_[ttlidx_].tcase  = ad_.tcase;
  ttl_[ttlidx_].genre  = ad_.genre;
  ttl_[ttlidx_].txt = (char*)mustcalloc((unsigned)ad_.txtn+1,(unsigned)sizeof(char),"ttl_[].txt");
  fread(ttl_[ttlidx_].txt,sizeof(char),(int)ad_.txtn,fpt);
  *(ttl_[ttlidx_].txt+ad_.txtn) = '\0';
  ttlidx_++;
  }

fread(&axbufidx_,sizeof(int),1,out);
if(!axbufidx_)
  {
  printf("no tables to be done\n");
  exit(1);
  }
fread(&fcount_,sizeof(short),1,out);
fread(&fkidx_,sizeof(short),1,out);
axbuf = (float*)mustcalloc((unsigned)axbufidx_,(unsigned)sizeof(float),"axbuf");
if(fcount_)
  facs_ = (float*)mustcalloc((unsigned)fcount_,(unsigned)sizeof(float),"facs_");
fread(axbuf,sizeof(float),axbufidx_,out);
fread(facs_,sizeof(float),(int)fcount_,fpx);


/* allocation of memory for the number of elements in the entire run + number of auto break side texts */
for(i_=0;i_<TABROUTESIZE;i_++)
   t_num[i_] = 0;
j_ = 2;
while(j_--)
  {
  for(i_=0;i_<rcount_;i_++)
     {
     if(j_)
       {
       strcpy(datnam,tr_[i_]->taba);
       z_ = tr_[i_]->tnuma;
       }
     else
       {
       strcpy(datnam,tr_[i_]->tabb);
       z_ = tr_[i_]->tnumb;
       }
     strcat(datnam,".ax");
     if((fax = fopen(datnam,"rb")) == NULL)
       {
       fprintf(stderr,"cannot open %s\n",datnam);
       exit(1);
       }
     q_ = 0;
     while(fread(&ad_,sizeof(struct axesdef),1,fax))
       {
       if(ad_.option & O_FACREQ)
         fread(&facvalv_,sizeof(float),1,fax);
       if(!t_num[z_] || q_)
         {
         if(!q_)
           {
           t_num[z_] = 1;
           q_ = 1;
           }
         if(!sem_ && j_ && (ad_.option & O_TXTREQ) && (ad_.txtn > tr_[i_]->side) && (ad_.genre & (D_N10 | D_N01 | D_N12 | D_N13 | D_N17 | D_N19 | D_N33 | D_N05)))
           {
           fread(abreaktxt_,sizeof(char),(int)ad_.txtn,fax);
           abreak_ = side_autobreak_check(abreaktxt_,ad_.txtn,tr_[i_]->side);
           for(a_=0;a_<abreak_;a_++)
              dyncount_++;
           }
         else
           {
           dyncount_++;
           fseek(fax,(long)ad_.txtn,1);
           }
         }
       else
         fseek(fax,(long)ad_.txtn,1);
       }
     fclose(fax);
     }
  }
t_txt        = (char**)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(char*)         ,"*t_txt");
h_txt        = (char**)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(char*)         ,"*h_txt");
t_gen        = (long*)           mustcalloc((unsigned)dyncount_,(unsigned)sizeof(long)          ,"t_gen" );
t_opt        = (long*)           mustcalloc((unsigned)dyncount_,(unsigned)sizeof(long)          ,"t_opt" );
t_eff        = (int*)            mustcalloc((unsigned)dyncount_,(unsigned)sizeof(int)           ,"t_eff" );
t_opv        = (unsigned short*) mustcalloc((unsigned)dyncount_,(unsigned)sizeof(unsigned short),"t_opv" );
t_dpv        = (short*)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(short)         ,"t_dpv" );
t_dcv        = (short*)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(short)         ,"t_dcv" );
t_col        = (short*)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(short)         ,"t_col" );
snn          = (float*)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(float)         ,"snn"   );
sss          = (float*)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(float)         ,"sss"   );
sqq          = (float*)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(float)         ,"sqq"   );
basis_zeile  = (float*)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(float)         ,"basis_zeile");
summe_zeile  = (float*)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(float)         ,"summe_zeile");
k_nz         = (short*)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(short)         ,"k_nz"  );
opeff_       = (unsigned short*) mustcalloc((unsigned)dyncount_,(unsigned)sizeof(unsigned short),"opeff_");
dpeff_       = (short*)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(short)         ,"dpeff_");
dceff_       = (short*)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(short)         ,"dceff_");
thlen_       = (short*)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(short)         ,"thlen_");
unlmrk_      = (int*)            mustcalloc((unsigned)dyncount_,(unsigned)sizeof(int)           ,"unlmrk_");
semcount_    = (short*)          mustcalloc((unsigned)dyncount_,(unsigned)sizeof(short)         ,"semcount_");
thmrk_       = (int*)            mustcalloc((unsigned)dyncount_,(unsigned)sizeof(int)           ,"thmrk_");

for(i_=0;i_<TABROUTESIZE;i_++)
   t_num[i_] = 0;
j_ = 2;
while(j_--)
  {
  for(i_=0;i_<rcount_;i_++)
     {
     if(j_)
       {
       strcpy(datnam,tr_[i_]->taba);
       z_ = tr_[i_]->tnuma;
       }
     else
       {
       strcpy(datnam,tr_[i_]->tabb);
       z_ = tr_[i_]->tnumb;
       }
     strcat(datnam,".ax");
     if((fax = fopen(datnam,"rb")) == NULL)
       {
       fprintf(stderr,"cannot open %s\n",datnam);
       exit(1);
       }
     q_ = 0;
     while(fread(&ad_,sizeof(struct axesdef),1,fax))
       {
       if(ad_.option & O_FACREQ)
         fread(&facvalv_,sizeof(float),1,fax);
       t_gen[txtidx_] = ad_.genre;
       t_opt[txtidx_] = ad_.option;
       t_eff[txtidx_] = ad_.flag_1;
       t_opv[txtidx_] = ad_.opval;
       t_dpv[txtidx_] = ad_.dpval;
       t_dcv[txtidx_] = ad_.dcval;
       t_col[txtidx_] = ad_.colwid;
       if(!t_num[z_] || q_)
         {
         if(!q_)
           {
           t_num[z_] = (txtidx_ + 1);
           t_anz[z_] = 0;
           q_ = 1;
           }
         if(ad_.option & O_TXTREQ)
           {
           h_txt[txtidx_] = (char*)mustcalloc((unsigned)ad_.txtn+1,(unsigned)sizeof(char),"h_txt[]");
           fread(h_txt[txtidx_],sizeof(char),(int)ad_.txtn,fax);
           *(h_txt[txtidx_]+ad_.txtn) = '\0';
           if(!sem_ && j_ && (ad_.txtn > tr_[i_]->side) && (t_gen[txtidx_] & (D_N10 | D_N01 | D_N12 | D_N13 | D_N17 | D_N19 | D_N33 | D_N05)))
             {
             abreak_ = side_autobreak(h_txt[txtidx_],ad_.txtn,tr_[i_]->side);
             alen_ = strlen(sbuf_[0]);
             t_txt[txtidx_] = (char*)mustcalloc((unsigned)alen_+1,(unsigned)sizeof(char),"t_txt[]");
             strcpy(t_txt[txtidx_],sbuf_[0]);
             for(a_=1;a_<abreak_;a_++)
                {
                ++t_anz[z_];
                ++txtidx_;
                t_gen[txtidx_] = D_N33;
                t_opt[txtidx_] = O_TXTREQ;
                t_eff[txtidx_] = 0;
                t_opv[txtidx_] = 0;
                t_dpv[txtidx_] = 0;
                t_dcv[txtidx_] = 0;
                t_col[txtidx_] = 0;
                alen_ = strlen(sbuf_[a_]);
                t_txt[txtidx_] = (char*)mustcalloc((unsigned)alen_+1,(unsigned)sizeof(char),"t_txt[]");
                strcpy(t_txt[txtidx_],sbuf_[a_]);
                }
             }
           else
             {
             t_txt[txtidx_] = (char*)mustcalloc((unsigned)ad_.txtn+1,(unsigned)sizeof(char),"t_txt[]");
             strcpy(t_txt[txtidx_],h_txt[txtidx_]);
             }
           }
         else
           fseek(fax,(long)ad_.txtn,1);
         ++t_anz[z_];
         ++txtidx_;
         }
       else
         fseek(fax,(long)ad_.txtn,1);
       }
     fclose(fax);
     }
  }

j_ = 0;
for(i_=0;i_<rcount_;i_++)
   {
   printz_ = seteff(tr_[i_]->flag_1,0x00000000,defflag_,0x00018000);
   if(!(printz_ & 0x00018000)) printz_ = 0x00010000;
   if(printz_ & 0x00010000)
     {
     notallnz_ = 0; j_offset_ = 0;
     for(t_=0;t_<tr_[i_]->lena;t_++)
        for(mi_=0;mi_<tr_[i_]->lenb;mi_++)
           {
           j_offset_++;
           jj_ = (t_ * tr_[i_]->lenb) + mi_;
           if(*(axbuf+j_+jj_) != (float)0.0)
             {
             notallnz_ = 1;
             break;
             }
           }
     if(!notallnz_)
       {
       j_ += j_offset_;
       suppressed_++;
       continue;
       }
     }
   ka_=t_num[tr_[i_]->tnumb]-1;
   la_=ka_+t_anz[tr_[i_]->tnumb];
   k_=t_num[tr_[i_]->tnuma]-1;
   l_=k_+t_anz[tr_[i_]->tnuma];
   nwp_ = 0; bsign_ = 0; merk_ = 0; mjneu_ = 0; err_ = 0; maxm_ = 0; nzs_ = 0;
   mjalt_ = j_; line_ = 0; bmerk_ = 0; frew_ = 0; sws_ = 0; gs_ = 0; facm_ = 0;
   tabeff_ = tr_[i_]->flag_1; kmc_ = 0;
   paglen_ = tr_[i_]->paglen; pagwid_ = tr_[i_]->pagwid; side_ = tr_[i_]->side;
   ntmerk_ = 0; newpag_ = 0;
   *(spechar_+0) = *(tr_[i_]->spechr+0);
   *(spechar_+1) = *(tr_[i_]->spechr+1);
   basis_total  = (float)0.0;
   basis_zeile_found = 0;
   basis_total_found = 0;
   sum_is_base = 0;
   for(ma_=ka_;ma_<la_;ma_++)
      summe_zeile[ma_] = (float)0.0;
   if(tr_[i_]->pagenum)
     page_ = tr_[i_]->pagenum;
   pag_ =    seteff(tabeff_,0x00000000,defflag_,0x0000000c);
   typ_ =    seteff(tabeff_,0x00000000,defflag_,0x00000300);
   pct_ =    seteff(tabeff_,0x00000000,defflag_,0x00000030);
   if(!sem_)
     {
     sprintf(text_format,"%%-.%ds",pagwid_);
     sprintf(side_format,"%%-%d.%ds",side_,side_);
     }
   else
     {
     colwid_eff = 0;
     sprintf(text_format,"\"%%-.%ds\";",pagwid_);
     sprintf(side_format,"\"%%-.%ds\";",side_);
     }
   clearkstr();
   clearkstrl(pagwid_);
   for(t_=ka_;t_<la_;t_++)
      if(t_gen[t_] & D_GCR)
        {
        gs_ = 1;
        break;
        }
   if(!gs_)
     {
     for(mi_=0;mi_<tr_[i_]->lenb;mi_++)
        k_nz[mi_] = 0;
     for(t_=0;t_<tr_[i_]->lena;t_++)
        for(mi_=0;mi_<tr_[i_]->lenb;mi_++)
           {
           jj_ = (t_ * tr_[i_]->lenb) + mi_;
           if(*(axbuf+j_+jj_) != (float)0.0)
             k_nz[mi_] = 1;
           }
     mi_ = 0; thcount_ = 0; thlen_[0] = 0; sublen_ = 0; semcount_[0] = 0; semsub_ = 0; unl_yes_ = 0;
     for(ma_=ka_;ma_<la_;ma_++)
        {
        t_ = 1;
        if(t_gen[ma_] & (D_N10 | D_N11 | D_N01 | D_N15 | D_N25))
          {
          nzk_ = seteff(tabeff_,t_eff[ma_],defflag_,0x000000c0);
          if(t_gen[ma_] & D_N25)
            mi_ += 3;
          else
          if(!k_nz[mi_++] && (nzk_ & 0x00000040))
            t_ = 0;
          }
        /* nocol */
        if(t_gen[ma_] & (D_N10 | D_N01 | D_N12 | D_N13 | D_N17 | D_N19 | D_N05))
          {
          nocol_ = seteff(tabeff_,t_eff[ma_],defflag_,0x000c0000);
          if(nocol_ & 0x00040000)
            t_ = 0;
          }
        if(t_ && t_gen[ma_] & (D_N10 | D_N01 | D_N12 | D_N13 | D_N17 | D_N19 | D_N05))
          {
          /* colwid= */
          if(!sem_)
            {
            if(!colwid_)
              colwid_eff = COLWID_DEFAULT;
            else
              colwid_eff = colwid_;
            if(tr_[i_]->colwid)
              colwid_eff = tr_[i_]->colwid;
            if(t_col[ma_])
              colwid_eff = t_col[ma_];
            }
          if(thcount_)
            {
            thlen_[thcount_ - 1] += colwid_eff;
            ++semcount_[thcount_ - 1];
            }
          else
            {
            thlen_[0] += colwid_eff;
            sublen_ += colwid_eff;
            ++semcount_[0];
            ++semsub_;
            }
          }
        if(t_ && (t_opt[ma_] & O_TXTREQ) && (t_gen[ma_] & D_N23))
          {
          if(!sem_)
            {
            unlmrk_[thcount_] = seteff(tabeff_,t_eff[ma_],defflag_,0x00007000);
            if(unlmrk_[thcount_] & 0x00007000)
              unl_yes_ = 1;
            }
          thmrk_[thcount_] = ma_;
          thcount_++;
          thlen_[thcount_] = 0;
          semcount_[thcount_] = 0;
          }
        }
     mi_ = 0; pwerr_ = 0; thcount_ = 0; actlen_ = side_; fthpos_ = 0;
     for(ma_=ka_;ma_<la_;ma_++)
        {
        t_ = 1;
        if(t_gen[ma_] & (D_N10 | D_N11 | D_N01 | D_N15 | D_N25))
          {
          nzk_ = seteff(tabeff_,t_eff[ma_],defflag_,0x000000c0);
          if(t_gen[ma_] & D_N25)
            mi_ += 3;
          else
          if(!k_nz[mi_++] && (nzk_ & 0x00000040))
            t_ = 0;
          }
        /* nocol */
        if(t_gen[ma_] & (D_N10 | D_N01 | D_N12 | D_N13 | D_N17 | D_N19 | D_N05))
          {
          nocol_ = seteff(tabeff_,t_eff[ma_],defflag_,0x000c0000);
          if(nocol_ & 0x00040000)
            t_ = 0;
          }
        if(t_ && (t_opt[ma_] & O_TXTREQ) && (t_gen[ma_] & D_N23))
          {
          actlen_ += colwid_eff;
          if(actlen_ > pagwid_)
            {
            fprintf(stderr,"**** Error - Table %d, Page %d - Page width too small\n",i_+1,page_);
            ++err_; pwerr_ = 1;
            break;
            }
          if(thcount_)
            {
            if(unlmrk_[thcount_ - 1] & 0x00007000)
              mkunl_head(side_,fthpos_+sublen_,thlen_[thcount_ - 1]-sublen_);
            oo_ = hsetlinel(fthpos_+sublen_,thlen_[thcount_ - 1]-sublen_,h_txt[thmrk_[thcount_ - 1]],side_,sem_,semcount_[thcount_ - 1],semsub_);
            if(oo_ > hmaxl)
              hmaxl = oo_;
            fthpos_ += thlen_[thcount_ - 1];
            sublen_ = 0; semsub_ = 0;
            }
          thcount_++;
          }
        }
     if(thcount_ && !pwerr_)
       {
       if(unlmrk_[thcount_ - 1] & 0x00007000)
         mkunl_head(side_,fthpos_+sublen_,thlen_[thcount_ - 1]-sublen_);
       oo_ = hsetlinel(fthpos_+sublen_,thlen_[thcount_ - 1]-sublen_,h_txt[thmrk_[thcount_ - 1]],side_,sem_,semcount_[thcount_ - 1],semsub_);
       if(oo_ > hmaxl)
         hmaxl = oo_;
       }
     mi_ = 0; actlen_ = side_; fthpos_ = 0;
     for(ma_=ka_;ma_<la_;ma_++)
        {
        t_ = 1;
        if(t_gen[ma_] & (D_N10 | D_N11 | D_N01 | D_N15 | D_N25))
          {
          nzk_ = seteff(tabeff_,t_eff[ma_],defflag_,0x000000c0);
          if(t_gen[ma_] & D_N25)
            mi_ += 3;
          else
          if(!k_nz[mi_++] && (nzk_ & 0x00000040))
            t_ = 0;
          }
        /* nocol */
        if(t_gen[ma_] & (D_N10 | D_N01 | D_N12 | D_N13 | D_N17 | D_N19 | D_N05))
          {
          nocol_ = seteff(tabeff_,t_eff[ma_],defflag_,0x000c0000);
          if(nocol_ & 0x00040000)
            t_ = 0;
          }
        if(t_ && (t_opt[ma_] & O_TXTREQ) && (t_gen[ma_] & (D_N01 | D_N10 | D_N12 | D_N13 | D_N17 | D_N19 | D_N05)))
          {
          /* colwid= */
          if(!sem_)
            {
            if(!colwid_)
              colwid_eff = COLWID_DEFAULT;
            else
              colwid_eff = colwid_;
            if(tr_[i_]->colwid)
              colwid_eff = tr_[i_]->colwid;
            if(t_col[ma_])
              colwid_eff = t_col[ma_];
            }
          actlen_ += colwid_eff;
          if(actlen_ > pagwid_)
            {
            if(!pwerr_)
              fprintf(stderr,"**** Error - Table %d, Page %d - Page width too small\n",i_+1,page_);
            ++err_;
            break;
            }
          o_ = hsetline(fthpos_,colwid_eff,h_txt[ma_],side_,sem_);
          if(o_ > hmax)
            hmax = o_;
          fthpos_ += colwid_eff;
          }
        }
     }
   unl_ = 0; unlt_ = 0;
   for(m_=k_;m_<l_;m_++)
      {
      if(!bsign_ && merk_ && !(t_gen[m_] & D_N33))
        {
        m_ = merk_;
        j_ = mjneu_;
        merk_ = 0;
        }
      if(t_gen[m_] & (D_GCR | D_PCR | D_TTL | D_TTC | D_TTR))
        continue;
      if(!sem_ && (t_opt[m_] & O_TXTREQ) && !(t_gen[m_] & D_N33))
        unl_ = seteff(tabeff_,t_eff[m_],defflag_,0x00007000);
      /* norow */
      if(t_gen[m_] & (D_N10 | D_N01 | D_N12 | D_N13 | D_N17 | D_N19 | D_N05))
        {
        norow_ = seteff(tabeff_,t_eff[m_],defflag_,0x00300000);
        if(norow_ & 0x00100000)
          {
          if(t_gen[m_] & (D_N10 | D_N01))
            {
            for(t_=ka_;t_<la_;t_++)
               {
               if(t_gen[t_] & (D_N10 | D_N11 | D_N01 | D_N15))
                 j_++;
               else
               if(t_gen[t_] & D_N25)
                 j_ += 3;
               }
            if(t_opt[m_] & O_FACREQ)
              {
              facvalv_ = *(facs_+fsidx_++);
              facm_ = 1;
              }
            }
          while((m_+1) < l_ && t_gen[m_+1] & D_N33)
            ++m_;
          continue;
          }
        }
      /* nz, nonz */
      if(t_gen[m_] & (D_N01 | D_N15 | D_N10 | D_N11 | D_N05))
        {
        nz_ = seteff(tabeff_,t_eff[m_],defflag_,0x000000c0);
        nzs_ = 0;
        if(nz_ & 0x00000040)
          {
          nzs_ = 1; nzc_ = j_;
          for(t_=ka_;t_<la_;t_++)
             {
             if(t_gen[t_] & (D_N10 | D_N11 | D_N01 | D_N15))
               {
               if(*(axbuf+nzc_++) != (float)0.0)
                 {
                 nzs_ = 0;
                 break;
                 }
               }
             else
             if(t_gen[t_] & D_N25)
               nzc_ += 3;
             }
          }
        if(nzs_)
          {
          if(t_opt[m_] & O_FACREQ)
            {
            facvalv_ = *(facs_+fsidx_++);
            facm_ = 1;
            }
          j_ = nzc_;
          while((m_+1) < l_ && t_gen[m_+1] & D_N33)
            ++m_;
          continue;
          }
        }
      if(!nwp_)
        {
        nwp_ = 1; p_num = 0;
        newpage(tab,pag_,pagwid_,sem_);
        if(sem_)
          fprintf(tab,"\n\"### table %d (%s x %s) ###\"\n",i_+1,tr_[i_]->taba,tr_[i_]->tabb);
        for(t_=0;t_<ttlidx_;t_++)
           if(ttl_[t_].tcase == WASNONE)
             {
             if(!sem_)
               fprintf(tab,"%s",justify(pagwid_,ttl_[t_].genre,ttl_[t_].txt));
             else
               fprintf(tab,"\"%s\";",justify(pagwid_,ttl_[t_].genre,ttl_[t_].txt));
             fprintf(tab,"\n");
             ++line_;
             }
        if(!(typ_ & 0x00000200))
          {
          if(!opval_)
            typop_ = 0x0100;
          else
            typop_ = opval_;
          if(tr_[i_]->opval)
            typop_ = tr_[i_]->opval;
          if(!sem_)
            {
            fprintf(tab,"%s",justify(pagwid_,D_TTR,mktype(typop_)));
            fprintf(tab,"\n");
            ++line_;
            }
          }
        for(t_=0;t_<ttlidx_;t_++)
           if(ttl_[t_].tcase == WASFLT && ttl_[t_].fltnum == tr_[i_]->fltnum)
             {
             if(!sem_)
               fprintf(tab,"%s",justify(pagwid_,ttl_[t_].genre,ttl_[t_].txt));
             else
               fprintf(tab,"\"%s\";",justify(pagwid_,ttl_[t_].genre,ttl_[t_].txt));
             fprintf(tab,"\n");
             ++line_;
             }
        for(t_=0;t_<ttlidx_;t_++)
           if(ttl_[t_].tcase == WASTAB && ttl_[t_].tabnum == (short)(i_+1))
             {
             if(!sem_)
               fprintf(tab,"%s",justify(pagwid_,ttl_[t_].genre,ttl_[t_].txt));
             else
               fprintf(tab,"\"%s\";",justify(pagwid_,ttl_[t_].genre,ttl_[t_].txt));
             fprintf(tab,"\n");
             ++line_;
             }
        for(t_=k_;t_<l_;t_++)
           if(t_gen[t_] & (D_TTL | D_TTC | D_TTR))
             {
             if(!sem_)
               {
               fprintf(tab,"%s",justify(pagwid_,t_gen[t_],t_txt[t_]));
               unlt_ = seteff(tabeff_,t_eff[t_],defflag_,0x00007000);
               if(unlt_ & 0x00007000)
                 fprintf(tab,"%s",mkunl_side(justify(pagwid_,t_gen[t_],t_txt[t_]),unlt_));
               }
             else
               fprintf(tab,"\"%s\";",justify(pagwid_,t_gen[t_],t_txt[t_]));
             fprintf(tab,"\n");
             ++line_;
             }
           else
           if(!(t_gen[t_] & (D_GCR | D_PCR)))
             maxm_ = t_;
        if(ntmerk_)
          {
          if(!(strlen(t_txt[ntmerk_]) == 1 && *(t_txt[ntmerk_]+0) == ' '))
            {
            fprintf(tab,text_format,t_txt[ntmerk_]);
            fprintf(tab,"\n");
            ++line_;
            }
          while((ntmerk_+1) < l_ && t_gen[ntmerk_+1] & D_N33)
            {
            fprintf(tab,text_format,t_txt[ntmerk_+1]);
            fprintf(tab,"\n");
            ++line_; ++ntmerk_;
            }
          ntmerk_ = 0;
          }
        if(!sem_)
          {
          fprintf(tab,"\n\n");
          line_ += 2;
          }
        for(t_=ka_;t_<la_;t_++)
           if(t_gen[t_] & D_PCR)
             {
             ll_ = strlen(t_txt[t_]);
             if((side_ + ll_) > pagwid_ && !sem_)
               {
               fprintf(stderr,"**** Error - Table %d, Page %d - Page width too small\n",i_+1,page_-1);
               ++err_;
               break;
               }
             for(jj_ = 0;jj_ < ll_;jj_++)
                if(*(t_txt[t_]+jj_) != ' ')
                  p_pos[p_num++] = (short)(jj_ + 1);
             }
           else
           if(t_gen[t_] & D_GCR)
             {
             fprintf(tab,side_format,"");
             if(!sem_)
               fprintf(tab,"%s",justify(pagwid_-side_,D_GCR,t_txt[t_]));
             else
               fprintf(tab,"\"%s\";",justify(pagwid_-side_,D_GCR,t_txt[t_]));
             fprintf(tab,"\n");
             ++line_;
             }
        if(!gs_)
          {
          if(sem_)
            {
            if(hmaxl)
              {
              fprintf(tab,"\"\";");
              fprintf(tab,"%s",kstrl);
              fprintf(tab,"\n");
              ++line_;
              }
            if(hmax)
              {
              fprintf(tab,"\"\";");
              fprintf(tab,"%s",kstr);
              fprintf(tab,"\n");
              ++line_;
              }
            }
          else
            {
            for(cnt_=(int)20-hmaxl;cnt_<(int)20;cnt_++)
               {
               kpos_ = (int)10001 * cnt_;
               fprintf(tab,"%s",kstrl+kpos_);
               fprintf(tab,"\n");
               ++line_;
               }
            if(unl_yes_)
              {
              fprintf(tab,"%s",unlbuf_);
              fprintf(tab,"\n");
              ++line_;
              }
            else
            if(hmaxl)
              {
              fprintf(tab,"\n");
              ++line_;
              }
            for(cnt_=(int)20-hmax;cnt_<(int)20;cnt_++)
               {
               kpos_ = (int)10001 * cnt_;
               fprintf(tab,"%s",kstr+kpos_);
               fprintf(tab,"\n");
               ++line_;
               }
            }
          }
        if(!sem_)
          {
          fprintf(tab,"\n");
          line_++;
          }
        }
      if(t_gen[m_] & (D_N01 | D_N12 | D_N13 | D_N17 | D_N10 | D_N19 | D_N05))
        {
        t_ = m_; u_ = 0; tigm_ = 0;
        while(++t_<l_ && t_gen[t_] & D_N33)
          ++u_;
        if((line_ + u_) >= paglen_)
          line_ += u_;
        }
      if(t_gen[m_] & D_N09)
        {
        merk_ = m_ + 1;
        ntmerk_ = m_;
        while(merk_ < l_ && t_gen[merk_] & D_N33)
          {
          ++merk_; ++m_;
          }
        if(newpag_ && !sem_)
          {
          newpag_ = 0;
          if(merk_ < l_)
            base_ = seteff(tabeff_,t_eff[merk_],defflag_,0x00400000);
          if(merk_ < l_ && base_ & 0x00400000)
            {
            merk_ = 0; bsign_ = 1; nwp_ = 0;
            }
          else
          if(merk_ < l_ && t_gen[merk_] & (D_N10 | D_N11))
            {
            merk_ = 0; bsign_ = 1; nwp_ = 0;
            }
          else
            {
            m_ = bmerk_; bsign_ = 1; mjneu_ = j_; j_ = mjalt_; nwp_ = 0;
            }
          }
        else
          {
          merk_ = 0;
          ntmerk_ = 0;
          }
        continue;
        }
      else
      if(line_ >= paglen_ && !sem_)
        {
        merk_ = m_; m_ = bmerk_; bsign_ = 1; mjneu_ = j_; j_ = mjalt_; nwp_ = 0;
        continue;
        }
      if((t_opt[m_] & O_TXTREQ) && !(t_gen[m_] & D_N25) && !((t_gen[m_] & D_N33) && tigm_))
        {
        if(sem_)
          {
          if(t_gen[m_] & (D_N03 | D_N23))
            fprintf(tab,text_format,t_txt[m_]);
          else
          if((!(t_gen[m_] & D_N33)) || ((m_>k_) && t_gen[m_-1] & (D_N03 | D_N23)))
            {
            fprintf(tab,"\"%s",t_txt[m_]);
            mm_ = m_;
            while((mm_+1) < l_ && t_gen[mm_+1] & D_N33)
              fprintf(tab,"%s",t_txt[++mm_]);
            fprintf(tab,"\";");
            }
          }
        else
          {
          if(t_gen[m_] & (D_N03 | D_N23))
            fprintf(tab,text_format,t_txt[m_]);
          else
            fprintf(tab,side_format,t_txt[m_]);
          }
        }
      if(t_gen[m_] & (D_N10 | D_N11))
        {
        bmerk_ = m_ - 1;
        mjalt_ = j_;
        }
      else
        {
        base_ = seteff(tabeff_,t_eff[m_],defflag_,0x00400000);
        if(base_ & 0x00400000)
          {
          bmerk_ = m_ - 1;
          mjalt_ = j_;
          }
        }

      if(t_opt[m_] & O_FACREQ)
        {
        facvalv_ = *(facs_+fsidx_++);
        facm_ = 1;
        }
      if(t_gen[m_] & D_N25)
        {
        for(mi_=0;mi_<tr_[i_]->lenb;mi_++)
           snn[mi_] = *(axbuf+j_++);
        for(mi_=0;mi_<tr_[i_]->lenb;mi_++)
           sss[mi_] = *(axbuf+j_++);
        for(mi_=0;mi_<tr_[i_]->lenb;mi_++)
           sqq[mi_] = *(axbuf+j_++);
        }
      else
      if(t_gen[m_] & (D_N01 | D_N15 | D_N10 | D_N11 | D_N12 | D_N13 | D_N17 | D_N19 | D_N05))
        {
        eff_ = seteff(tabeff_,t_eff[m_],defflag_,0x00000003);
        fls_ = seteff(tabeff_,t_eff[m_],defflag_,0x00000c00);
        mm_ = m_; opmax_ = 1; firstrun_ = 1; axbuf_inc = 0;
        fkidx_ -= frew_; frew_ = 0; facma_ = 0; newpag_ = 1;
        swk_ = 0; bsign_ = 0; nn = (float)0.0; ss = (float)0.0; qq = (float)0.0;
        while(opmax_)
          {
          j_ -= axbuf_inc; axbuf_inc = 0; opc_ = 0; actlen_ = side_;
          n_num = 0; p_vor = 0; vkmc_ = kmc_; kmc_ = 0; mi_ = 0; flssg_ = 0;
          summe_spalte = (float)0.0; basis_spalte = (float)0.0;
          for(ma_=ka_;ma_<la_;ma_++)
             {
             tigma_ = 0;
             if(!gs_ && (t_gen[ma_] & (D_N10 | D_N11 | D_N01 | D_N15 | D_N25)))
               {
               nzk_ = seteff(tabeff_,t_eff[ma_],defflag_,0x000000c0);
               if(t_gen[ma_] & D_N25)
                 mi_ += 3;
               else
               if(!k_nz[mi_++] && (nzk_ & 0x00000040))
                 tigma_ = 1;
               }
             /* nocol */
             if(!gs_ && t_gen[ma_] & (D_N10 | D_N01 | D_N12 | D_N13 | D_N17 | D_N19))
               {
               nocol_ = seteff(tabeff_,t_eff[ma_],defflag_,0x000c0000);
               if(nocol_ & 0x00040000)
                 {
                 if(t_gen[ma_] & (D_N10 | D_N01))
                   tigma_ = 1;
                 else
                   continue;
                 }
               }
             if(err_)
               break;
             else
             if(!tigma_ && (t_gen[ma_] & (D_N01 | D_N10 | D_N12 | D_N13 | D_N17 | D_N19 | D_N05)))
               {
               /* colwid= */
               if(!sem_)
                 {
                 if(!colwid_)
                   colwid_eff = COLWID_DEFAULT;
                 else
                   colwid_eff = colwid_;
                 if(tr_[i_]->colwid)
                   colwid_eff = tr_[i_]->colwid;
                 if(t_col[ma_])
                   colwid_eff = t_col[ma_];
                 }
               if(p_num)
                 {
                 if(!sem_)
                   colwid_eff = p_pos[n_num] - p_vor;
                 else
                   colwid_eff = 0;
                 p_vor = p_pos[n_num];
                 n_num++;
                 }
               actlen_ += colwid_eff;
               actls_ = actlen_;
               if(!(fls_ & 0x00000400))
                 ++actls_;
               if(actls_ > pagwid_)
                 {
                 fprintf(stderr,"**** Error - Table %d, Page %d - Page width too small\n",i_+1,page_-1);
                 ++err_;
                 break;
                 }
               }
             if(t_gen[ma_] & (D_N01 | D_N15 | D_N10 | D_N11 | D_N05))
               {
               if(t_gen[ma_] & (D_N10 | D_N11))
                 {
                 if(t_gen[m_] & D_N05)
                   basis_spalte = summe_zeile[ma_];
                 else
                   basis_spalte = *(axbuf+j_);
                 }
               if(t_gen[ma_] & (D_N11 | D_N15))
                 tigma_ = 1;
               if(facma_ && swk_)
                 {
                 nn = (float)0.0;
                 ss = (float)0.0;
                 qq = (float)0.0;
                 swk_ = 0;
                 }
               if(facm_ && (t_gen[m_] & (D_N01 | D_N10 | D_N11 | D_N15)) && sws_)
                 {
                 clearvals(snn,vkmc_);
                 clearvals(sss,vkmc_);
                 clearvals(sqq,vkmc_);
                 sws_ = 0;
                 }
               if(firstrun_ && t_opt[ma_] & O_FACREQ)
                 {
                 ++frew_;
                 facvalh_ = *(facs_+fkidx_++);
                 nn += *(axbuf+j_);
                 ss += facvalh_ * *(axbuf+j_);
                 qq += (facvalh_ * facvalh_) * *(axbuf+j_);
                 facma_ = 1;
                 }
               if(firstrun_ && t_opt[m_] & O_FACREQ)
                 {
                 snn[kmc_] += *(axbuf+j_);
                 sss[kmc_] += facvalv_ * *(axbuf+j_);
                 sqq[kmc_] += (facvalv_ * facvalv_) * *(axbuf+j_);
                 }
               if(t_gen[m_] & (D_N10 | D_N11))
                 {
                 basis_zeile_found = 1;
                 if(t_gen[ma_] & D_N05)
                   basis_zeile[kmc_] = summe_spalte;
                 else
                   basis_zeile[kmc_] = *(axbuf+j_);
                 if((m_+1)>l_ && t_gen[m_+1] & D_N33)
                   bsign_ = 1;
                 }

               if(t_gen[m_] & (D_N10 | D_N01))
                 outval_ = *(axbuf+j_);
               else
               if(t_gen[m_] & D_N05)
                 outval_ = summe_zeile[ma_];

               if(t_gen[m_] & D_N05)
                 {
                 base_ = seteff(tabeff_,t_eff[m_],defflag_,0x00400000);
                 if(base_ & 0x00400000)
                   sum_is_base = 1;
                 else
                   sum_is_base = 0;
                 }
               else
               if(t_gen[m_] & (D_N10 | D_N11))
                 sum_is_base = 0;
               else
               if(!t_gen[m_] & D_N05)
                 {
                 base_ = seteff(tabeff_,t_eff[m_],defflag_,0x00400000);
                 if(base_ & 0x00400000)
                   sum_is_base = 0;
                 }

               if(firstrun_ && t_gen[m_] & (D_N01 | D_N15) && !(t_opt[m_] & O_WASNET) && !sum_is_base)
                 {
                 ntot_ = seteff(tabeff_,t_eff[m_],defflag_,0x00020000);
                 base_ = seteff(tabeff_,t_eff[m_],defflag_,0x00400000);
                 if(!(ntot_ & 0x00020000) && !(base_ & 0x00400000))
                   summe_zeile[ma_] += *(axbuf+j_);
                 }

               base_ = seteff(tabeff_,t_eff[ma_],defflag_,0x00400000);
               if(base_ & 0x00400000)
                 {
                 if(t_gen[ma_] & D_N05)
                   basis_spalte = summe_spalte;
                 else
                 if(t_gen[ma_] & (D_N01 | D_N15))
                   {
                   if(t_gen[m_] & D_N05)
                     basis_spalte = summe_zeile[ma_];
                   else
                     basis_spalte = *(axbuf+j_);
                   }
                 }

               base_ = seteff(tabeff_,t_eff[ma_],defflag_,0x00400000);
               if(t_gen[ma_] & (D_N10 | D_N11) || base_ & 0x00400000)
                 summe_spalte = (float)0.0;
               else
               if(t_gen[ma_] & (D_N01 | D_N15) && !(t_opt[ma_] & O_WASNET) && !(base_ & 0x00400000))
                 {
                 ntot_ = seteff(tabeff_,t_eff[ma_],defflag_,0x00020000);
                 if(!(ntot_ & 0x00020000))
                   {
                   if(t_gen[m_] & D_N05)
                     summe_spalte += summe_zeile[ma_];
                   else
                     summe_spalte += *(axbuf+j_);
                   }
                 }
               else
               if(t_gen[ma_] & D_N05)
                 outval_ = summe_spalte;

               base_ = seteff(tabeff_,t_eff[m_],defflag_,0x00400000);
               if(base_ & 0x00400000)
                 {
                 if(t_gen[m_] & D_N05)
                   {
                   if(t_gen[ma_] & D_N05)
                     basis_zeile[kmc_] = summe_spalte;
                   else
                     basis_zeile[kmc_] = summe_zeile[ma_];
                   }
                 else
                 if(t_gen[m_] & (D_N01 | D_N15))
                   {
                   if(t_gen[ma_] & D_N05)
                     basis_zeile[kmc_] = summe_spalte;
                   else
                     basis_zeile[kmc_] = *(axbuf+j_);
                   }
                 basis_zeile_found = 1;
                 if((m_+1)>l_ && t_gen[m_+1] & D_N33)
                   bsign_ = 1;
                 }

               if(t_gen[ma_] & D_N05)
                 summe_spalte = (float)0.0;

               if(t_gen[m_] & D_N12)
                 {
                 if(snn[kmc_] != (float)0.0)
                   miwe = sss[kmc_] / snn[kmc_];
                 else
                   miwe = (float)0.0;
                 if(t_dcv[m_])
                   dc_ = t_dcv[m_];
                 else
                   dc_ = 2;
                 if(!tigma_)
                   {
                   if(!sem_)
                     sprintf(wert_format,"%%%d.%df",colwid_eff,dc_-1);
                   else
                     sprintf(wert_format,"%%.%df;",dc_-1);
                   /* vorlaeufig */
                   if(t_gen[ma_] & D_N05)
                     miwe = (float)0.0;
                   else
                     miwe = (float)round_((double)miwe,dc_-1);
                   fprintf(tab,wert_format,miwe);
                   base_ = seteff(tabeff_,t_eff[m_],defflag_,0x00400000);
                   if(base_ & 0x00400000)
                     {
                     basis_zeile[kmc_] = miwe;
                     basis_zeile_found = 1;
                     if((m_+1)>l_ && t_gen[m_+1] & D_N33)
                       bsign_ = 1;
                     }
                   }
                 sws_ = 1;
                 }
               else
               if(t_gen[m_] & D_N13)
                 {
                 sof = sss[kmc_];
                 if(t_dcv[m_])
                   dc_ = t_dcv[m_];
                 else
                   dc_ = 1;
                 if(!tigma_)
                   {
                   if(!sem_)
                     sprintf(wert_format,"%%%d.%df",colwid_eff,dc_-1);
                   else
                     sprintf(wert_format,"%%.%df;",dc_-1);
                   /* vorlaeufig */
                   if(t_gen[ma_] & D_N05)
                     sof = (float)0.0;
                   else
                     sof = (float)round_((double)sof,dc_-1);
                   fprintf(tab,wert_format,sof);
                   base_ = seteff(tabeff_,t_eff[m_],defflag_,0x00400000);
                   if(base_ & 0x00400000)
                     {
                     basis_zeile[kmc_] = sof;
                     basis_zeile_found = 1;
                     if((m_+1)>l_ && t_gen[m_+1] & D_N33)
                       bsign_ = 1;
                     }
                   }
                 sws_ = 1;
                 }
               else
               if(t_gen[m_] & D_N17)
                 {
                 if(snn[kmc_] > (float)1.0)
                   stdd = (sqq[kmc_]-((sss[kmc_]*sss[kmc_])/snn[kmc_]))/(snn[kmc_]-(float)1.0);
                 else
                   stdd = (float)0.0;
                 if(stdd >= (float)0.0)
                   stdd = (float)sqrt((double)stdd);
                 else
                   stdd = (float)0.0;
                 if(t_dcv[m_])
                   dc_ = t_dcv[m_];
                 else
                   dc_ = 3;
                 if(!tigma_)
                   {
                   if(!sem_)
                     sprintf(wert_format,"%%%d.%df",colwid_eff,dc_-1);
                   else
                     sprintf(wert_format,"%%.%df;",dc_-1);
                   /* vorlaeufig */
                   if(t_gen[ma_] & D_N05)
                     stdd = (float)0.0;
                   else
                     stdd = (float)round_((double)stdd,dc_-1);
                   fprintf(tab,wert_format,stdd);
                   base_ = seteff(tabeff_,t_eff[m_],defflag_,0x00400000);
                   if(base_ & 0x00400000)
                     {
                     basis_zeile[kmc_] = stdd;
                     basis_zeile_found = 1;
                     if((m_+1)>l_ && t_gen[m_+1] & D_N33)
                       bsign_ = 1;
                     }
                   }
                 sws_ = 1;
                 }
               else
               if(t_gen[m_] & D_N19)
                 {
                 if(snn[kmc_] > (float)1.0)
                   stdd = (sqq[kmc_]-((sss[kmc_]*sss[kmc_])/snn[kmc_]))/(snn[kmc_]-(float)1.0);
                 else
                   stdd = (float)0.0;
                 if(stdd >= (float)0.0)
                   stdd = (float)sqrt((double)stdd);
                 else
                   stdd = (float)0.0;
                 if(snn[kmc_] > (float)0.0)
                   stde = stdd / (float)sqrt((double)snn[kmc_]);
                 else
                   stde = (float)0.0;
                 if(t_dcv[m_])
                   dc_ = t_dcv[m_];
                 else
                   dc_ = 3;
                 if(!tigma_)
                   {
                   if(!sem_)
                     sprintf(wert_format,"%%%d.%df",colwid_eff,dc_-1);
                   else
                     sprintf(wert_format,"%%.%df;",dc_-1);
                   /* vorlaeufig */
                   if(t_gen[ma_] & D_N05)
                     stde = (float)0.0;
                   else
                     stde = (float)round_((double)stde,dc_-1);
                   fprintf(tab,wert_format,stde);
                   base_ = seteff(tabeff_,t_eff[m_],defflag_,0x00400000);
                   if(base_ & 0x00400000)
                     {
                     basis_zeile[kmc_] = stde;
                     basis_zeile_found = 1;
                     if((m_+1)>l_ && t_gen[m_+1] & D_N33)
                       bsign_ = 1;
                     }
                   }
                 sws_ = 1;
                 }
               else
               if(t_gen[m_] & (D_N01 | D_N10 | D_N05))
                 {
                 if(t_gen[m_] & (D_N01 | D_N10))
                   {
                   if(!basis_total_found)
                     {
                     basis_total = *(axbuf+j_);
                     basis_total_found = 1;
                     }
                   if(!basis_zeile_found)
                     basis_zeile[kmc_] = (float)0.0;
                   }
                 if(firstrun_)
                   {
                   /* op= */
                   if(!(opval_ & 0xffef))
                     {
                     perc_ = 0;
                     opeff_[opc_] = 0x0100;
                     }
                   else
                     {
                     if(opval_ & 0x0010)
                       perc_ = 1;
                     else
                       perc_ = 0;
                     opeff_[opc_] = opval_ & (unsigned short)0xffef;
                     }
                   if(tr_[i_]->opval & 0xffef)
                     {
                     if(tr_[i_]->opval & 0x0010)
                       perc_ = 1;
                     else
                       perc_ = 0;
                     opeff_[opc_] = tr_[i_]->opval & (unsigned short)0xffef;
                     }
                   if(t_opv[m_] & 0xffef)
                     {
                     if(t_opv[m_] & 0x0010)
                       perc_ = 1;
                     else
                       perc_ = 0;
                     opeff_[opc_] = t_opv[m_] & (unsigned short)0xffef;
                     }
                   if(t_opv[ma_] & 0xffef)
                     {
                     if(t_opv[ma_] & 0x0010)
                       perc_ = 1;
                     else
                       perc_ = 0;
                     opeff_[opc_] = t_opv[ma_] & (unsigned short)0xffef;
                     }
                   base_ = seteff(tabeff_,t_eff[m_],defflag_,0x00400000);
                   if(opeff_[opc_] & 0x0080 && (t_gen[m_] & D_N10 || base_ & 0x00400000) && !perc_)
                     {
                     opeff_[opc_] |= 0x0100;
                     opeff_[opc_] &= 0xffff - 0x0080;
                     }
                   base_ = seteff(tabeff_,t_eff[ma_],defflag_,0x00400000);
                   if(opeff_[opc_] & 0x0200 && (t_gen[ma_] & D_N10 || base_ & 0x00400000) && !perc_)
                     {
                     opeff_[opc_] |= 0x0100;
                     opeff_[opc_] &= 0xffff - 0x0200;
                     }
                   opcount_ = inumbf(opeff_[opc_]);
                   if(opcount_ > opmax_)
                     opmax_ = opcount_;
                   /* decp= */
                   if(!dpval_)
                     dpeff_[opc_] = 2;
                   else
                     dpeff_[opc_] = dpval_;
                   if(tr_[i_]->dpval)
                     dpeff_[opc_] = tr_[i_]->dpval;
                   if(t_dpv[m_])
                     dpeff_[opc_] = t_dpv[m_];
                   if(t_dpv[ma_])
                     dpeff_[opc_] = t_dpv[ma_];
                   /* dec= */
                   if(!dcval_)
                     dceff_[opc_] = 1;
                   else
                     dceff_[opc_] = dcval_;
                   if(tr_[i_]->dcval)
                     dceff_[opc_] = tr_[i_]->dcval;
                   if(t_dcv[m_])
                     dceff_[opc_] = t_dcv[m_];
                   if(t_dcv[ma_])
                     dceff_[opc_] = t_dcv[ma_];
                   }
                 if(opeff_[opc_] & 0x0100)
                   {
                   if(!tigma_)
                     {
                     if(flssg_)
                       {
                       flssg_ = 0;
                       cweff_ = colwid_eff - 1;
                       }
                     else
                       cweff_ = colwid_eff;
                     mkabsolute_(tab,outval_,cweff_,dceff_[opc_],spechar_,sem_);
                     }
                   opeff_[opc_++] &= 0xffff - 0x0100;
                   }
                 else
                 if(opeff_[opc_] & 0x0080)
                   {
                   if(!tigma_)
                     {
                     if(!sem_ && !flssg_ && !(fls_ & 0x00000400))
                       {
                       fprintf(tab," ");
                       flssg_ = 1;
                       }
                     mkpercentage_(tab,outval_,basis_zeile[kmc_],colwid_eff,pct_,dpeff_[opc_],spechar_,sem_);
                     }
                   opeff_[opc_++] &= 0xffff - 0x0080;
                   }
                 else
                 if(opeff_[opc_] & 0x0200)
                   {
                   if(!tigma_)
                     {
                     if(!sem_ && !flssg_ && !(fls_ & 0x00000400))
                       {
                       fprintf(tab," ");
                       flssg_ = 1;
                       }
                     mkpercentage_(tab,outval_,basis_spalte,colwid_eff,pct_,dpeff_[opc_],spechar_,sem_);
                     }
                   opeff_[opc_++] &= 0xffff - 0x0200;
                   }
                 else
                 if(opeff_[opc_] & 0x0800)
                   {
                   if(!tigma_)
                     {
                     if(!sem_ && !flssg_ && !(fls_ & 0x00000400))
                       {
                       fprintf(tab," ");
                       flssg_ = 1;
                       }
                     mkpercentage_(tab,outval_,basis_total,colwid_eff,pct_,dpeff_[opc_],spechar_,sem_);
                     }
                   opeff_[opc_++] &= 0xffff - 0x0800;
                   }
                 else
                   {
                   if(!tigma_)
                     mkblank_(tab,colwid_eff,sem_);
                   opc_++;
                   }
                 if(t_gen[m_] & (D_N01 | D_N10) && !(t_gen[ma_] & D_N05))
                   {
                   j_++;
                   ++axbuf_inc;
                   }
                 }
               else
               if(t_gen[m_] & (D_N15 | D_N11) && !(t_gen[ma_] & D_N05))
                 {
                 ++j_;
                 axbuf_inc++;
                 tigm_ = 1;
                 }
               ++kmc_;
               }
             else
             if((t_gen[ma_] & D_N25) && !(t_gen[m_] & (D_N12 | D_N13 | D_N17 | D_N19 | D_N05)))
               {
               nn = *(axbuf+j_++);
               ss = *(axbuf+j_++);
               qq = *(axbuf+j_++);
               axbuf_inc += 3;
               facma_ = 1;
               }
             else
             if(!facm_ && (t_gen[ma_] & D_N25) && (t_gen[m_] & (D_N12 | D_N13 | D_N17 | D_N19 | D_N05)))
               kmc_ += 3;
             else
             if(t_gen[ma_] & D_N12 && firstrun_)
               {
               if(t_dcv[ma_])
                 dc_ = t_dcv[ma_];
               else
                 dc_ = 2;
               if(flssg_)
                 {
                 flssg_ = 0;
                 cweff_ = colwid_eff - 1;
                 }
               else
                 cweff_ = colwid_eff;
               if(!sem_)
                 sprintf(wert_format,"%%%d.%df",cweff_,dc_-1);
               else
                 sprintf(wert_format,"%%.%df;",dc_-1);
               if(t_gen[m_] & (D_N12 | D_N13 | D_N17 | D_N19 | D_N05))
                 {
                 /* vorlaeufig */
                 if(!tigm_)
                   fprintf(tab,wert_format,(float)0.0);
                 }
               else
                 {
                 if(nn != (float)0.0)
                   miwe = ss / nn;
                 else
                   miwe = (float)0.0;
                 if(!tigm_)
                   {
                   miwe = (float)round_((double)miwe,dc_-1);
                   fprintf(tab,wert_format,miwe);
                   }
                 base_ = seteff(tabeff_,t_eff[ma_],defflag_,0x00400000);
                 if(base_ & 0x00400000)
                   basis_spalte = miwe;
                 }
               swk_ = 1;
               }
             else
             if(t_gen[ma_] & D_N13 && firstrun_)
               {
               if(t_dcv[ma_])
                 dc_ = t_dcv[ma_];
               else
                 dc_ = 1;
               if(flssg_)
                 {
                 flssg_ = 0;
                 cweff_ = colwid_eff - 1;
                 }
               else
                 cweff_ = colwid_eff;
               if(!sem_)
                 sprintf(wert_format,"%%%d.%df",cweff_,dc_-1);
               else
                 sprintf(wert_format,"%%.%df;",dc_-1);
               if(t_gen[m_] & (D_N12 | D_N13 | D_N17 | D_N19 | D_N05))
                 {
                 /* vorlaeufig */
                 if(!tigm_)
                   fprintf(tab,wert_format,(float)0.0);
                 }
               else
                 {
                 if(!tigm_)
                   {
                   ss = (float)round_((double)ss,dc_-1);
                   fprintf(tab,wert_format,ss);
                   }
                 base_ = seteff(tabeff_,t_eff[ma_],defflag_,0x00400000);
                 if(base_ & 0x00400000)
                   basis_spalte = ss;
                 }
               swk_ = 1;
               }
             else
             if(t_gen[ma_] & D_N17 && firstrun_)
               {
               if(t_dcv[ma_])
                 dc_ = t_dcv[ma_];
               else
                 dc_ = 3;
               if(flssg_)
                 {
                 flssg_ = 0;
                 cweff_ = colwid_eff - 1;
                 }
               else
                 cweff_ = colwid_eff;
               if(!sem_)
                 sprintf(wert_format,"%%%d.%df",cweff_,dc_-1);
               else
                 sprintf(wert_format,"%%.%df;",dc_-1);
               if(t_gen[m_] & (D_N12 | D_N13 | D_N17 | D_N19 | D_N05))
                 {
                 /* vorlaeufig */
                 if(!tigm_)
                   fprintf(tab,wert_format,(float)0.0);
                 }
               else
                 {
                 if(nn > (float)1.0)
                   stdd = (qq-((ss*ss)/nn))/(nn-(float)1.0);
                 else
                   stdd = (float)0.0;
                 if(stdd >= (float)0.0)
                   stdd = (float)sqrt((double)stdd);
                 else
                   stdd = (float)0.0;
                 if(!tigm_)
                   {
                   stdd = (float)round_((double)stdd,dc_-1);
                   fprintf(tab,wert_format,stdd);
                   }
                 base_ = seteff(tabeff_,t_eff[ma_],defflag_,0x00400000);
                 if(base_ & 0x00400000)
                   basis_spalte = stdd;
                 }
               swk_ = 1;
               }
             else
             if(t_gen[ma_] & D_N19 && firstrun_)
               {
               if(t_dcv[ma_])
                 dc_ = t_dcv[ma_];
               else
                 dc_ = 3;
               if(flssg_)
                 {
                 flssg_ = 0;
                 cweff_ = colwid_eff - 1;
                 }
               else
                 cweff_ = colwid_eff;
               if(!sem_)
                 sprintf(wert_format,"%%%d.%df",cweff_,dc_-1);
               else
                 sprintf(wert_format,"%%.%df;",dc_-1);
               if(t_gen[m_] & (D_N12 | D_N13 | D_N17 | D_N19 | D_N05))
                 {
                 /* vorlaeufig */
                 if(!tigm_)
                   fprintf(tab,wert_format,(float)0.0);
                 }
               else
                 {
                 if(nn > (float)1.0)
                   stdd = (qq-((ss*ss)/nn))/(nn-(float)1.0);
                 else
                   stdd = (float)0.0;
                 if(stdd >= (float)0.0)
                   stdd = (float)sqrt((double)stdd);
                 else
                   stdd = (float)0.0;
                 if(nn > (float)0.0)
                   stde = stdd / (float)sqrt((double)nn);
                 else
                   stde = (float)0.0;
                 if(!tigm_)
                   {
                   stde = (float)round_((double)stde,dc_-1);
                   fprintf(tab,wert_format,stde);
                   }
                 base_ = seteff(tabeff_,t_eff[ma_],defflag_,0x00400000);
                 if(base_ & 0x00400000)
                   basis_spalte = stde;
                 }
               swk_ = 1;
               }
             else
             if(t_gen[ma_] & (D_N12 | D_N13 | D_N17 | D_N19))
               mkblank_(tab,colwid_eff,sem_);
             } /* Ende der for - to ma_ Schleife */
          if((unl_ & 0x00007000) && firstrun_ && !(t_gen[m_] & D_N25) && !(t_gen[m_] & (D_N33 | D_N15 | D_N11) && tigm_))
            fprintf(tab,"%s",mkunl_side(t_txt[m_],unl_));
          if(--opmax_)
            {
            if((mm_+1)<l_ && t_gen[mm_+1] & D_N33)
              {
              if(unl_ & 0x00007000 && !firstrun_)
                fprintf(tab,"%s",mkunl_side(t_txt[mm_],unl_));
              fprintf(tab,"\n");
              if(!sem_)
                fprintf(tab,side_format,t_txt[mm_+1]);
              else
                fprintf(tab,"\"\";");
              ++mm_;
              }
            else
              {
              if((unl_ & 0x00007000) && !firstrun_ && (t_gen[mm_] & D_N33))
                fprintf(tab,"%s",mkunl_side(t_txt[mm_],unl_));
              unl_ = 0;
              fprintf(tab,"\n");
              fprintf(tab,side_format,"");
              }
            ++line_;
            }
          firstrun_ = 0;
          }

        if(!merk_ & !sum_is_base)
          {
          if(t_gen[m_] & D_N05)
            {
            for(ma_=ka_;ma_<la_;ma_++)
               summe_zeile[ma_] = (float)0.0;
            }
          else
          if(t_gen[m_] & (D_N10 | D_N11))
            {
            for(ma_=ka_;ma_<la_;ma_++)
               summe_zeile[ma_] = (float)0.0;
            }
          else
            {
            base_ = seteff(tabeff_,t_eff[m_],defflag_,0x00400000);
            if(base_ & 0x00400000)
              {
              for(ma_=ka_;ma_<la_;ma_++)
                 summe_zeile[ma_] = (float)0.0;
              }
            }
          }

        m_ = mm_;
        }
      if(!(t_gen[m_] & D_N25) && !(t_gen[m_] & (D_N33 | D_N15 | D_N11) && tigm_))
        {
        if((!(sem_ && (m_+1) < l_ && t_gen[m_+1] & D_N33)) || ((sem_ && t_gen[m_] & (D_N03 | D_N23))
           && ((m_+1) < l_ && t_gen[m_+1] & D_N33)))
          {
          if((unl_ & 0x00007000) && (t_gen[m_] & (D_N33 | D_N03 | D_N23)))
            fprintf(tab,"%s",mkunl_side(t_txt[m_],unl_));
          fprintf(tab,"\n");
          ++line_;
          }
        if(eff_ & 0x00000001 && (m_ < maxm_) && (line_ < paglen_) && !sem_)
          {
          if((m_+1)<l_ && !(t_gen[m_+1] & (D_N33 | D_N09)) && !(t_gen[m_] & (D_N03 | D_N23) &&
            t_gen[m_+1] & (D_N03 | D_N23 | D_N01 | D_N10 | D_N12 | D_N13 | D_N17 | D_N19 | D_N05)))
            {
            fprintf(tab,"\n");
            ++line_;
            }
          }
        }
      }
   clearvals(snn,kmc_);
   clearvals(sss,kmc_);
   clearvals(sqq,kmc_);
   }
if(sem_)
  printf(" %ld tables done.\n\n",rec_count);
else
  printf(" %ld pages done.\n\n",rec_count);
if(suppressed_)
  printf("%d zero tables suppressed.\n\n",suppressed_);

exit(0);
}

char *mustcalloc(n_,s_,v_)
unsigned n_;
unsigned s_;
char *v_;
{
char *ret_;

if((ret_ = (char*)calloc(n_,s_)) == NULL)
  {
  printf("memory allocation error: %s\n",v_);
  exit(1);
  }
return(ret_);
}

void newpage(fp,p_,pw_,s_)
FILE *fp;
int p_;
short pw_;
short s_;
{
char pf_[16];
char pb_[16];

if(!s_)
  {
  fprintf(fp,"\f\n");
  line_ = 1;
  if(!(p_ & 0x00000008))
    {
    sprintf(pb_,"%s %d",pbuf_,page_);
    sprintf(pf_,"%%%d.%ds",pw_,pw_);
    fprintf(fp,pf_,pb_);
    fprintf(fp,"\n");
    ++line_;
    }
  }
++page_;
if(!(++rec_count % 100))
  {
  if(!s_)
    printf(" %ld Pages\n",rec_count);
  else
    printf(" %ld Tables\n",rec_count);
  }
else
if(!(rec_count % 10))
  {
  putchar('.');
  fflush(stdout);
  }
}

void clearvals(var_,num_)
float *var_;
int num_;
{
register int i_;

for(i_=0;i_<num_;i_++)
   *(var_+i_) = (float)0.0;
}

int seteff(t_a,t_b,t_c,t_comp_)
int t_a,t_b,t_c,t_comp_;
{
int ret_;

if(!(t_b & t_comp_) && (t_a & t_comp_))
  ret_ = t_a;
else
if(!(t_b & t_comp_) && (t_c & t_comp_))
  ret_ = t_c;
else
  ret_ = t_b;

return(ret_ & t_comp_);
}

void mkabsolute_(fp,value,colwid,dec_,sc_,s_)
FILE *fp;
float value;
short colwid;
short dec_;
char *sc_;
short s_;
{
char wf_[16];
char bf_[16];
char z_[2];
float rval_;

rval_ = (float)5.0 / (float)pow((float)10.0,(float)dec_);

sprintf(wf_,"%%%d.%df",colwid,dec_-1);
sprintf(bf_,"%%%d.%ds",colwid,colwid);

if(value != (float)0.0 || *(sc_+0) == 0x7f || s_)
  {
  if(value >= rval_ || *(sc_+1) == 0x7f || s_)
    {
    value = (float)round_((double)value,dec_-1);
    fprintf(fp,wf_,value);
    }
  else
    {
    *(z_+0) = *(sc_+1);
    *(z_+1) = '\0';
    fprintf(fp,bf_,z_);
    }
  }
else
  {
  *(z_+0) = *(sc_+0);
  *(z_+1) = '\0';
  fprintf(fp,bf_,z_);
  }
if(s_)
  fprintf(fp,";");
}

void mkpercentage_(fp,value,base,colwid,p_,dp_,sc_,s_)
FILE *fp;
float value;
float base;
short colwid;
int p_;
short dp_;
char *sc_;
short s_;
{
float ovalue_;
char wf_[16];
char bf_[16];
char z_[2];
float rval_;

rval_ = (float)5.0 / (float)pow((float)10.0,(float)dp_);

if(!(p_ & 0x00000020))
  sprintf(wf_,"%%%d.%df%%%%",colwid-1,dp_-1);
else
  sprintf(wf_,"%%%d.%df",colwid,dp_-1);
sprintf(bf_,"%%%d.%ds",colwid,colwid);

if(base != (float)0.0)
  {
  ovalue_ = (float)round_((double)value / (double)base,dp_+1) * (float)100.0;
  if(value != (float)0.0 || *(sc_+0) == 0x7f || s_)
    {
    if(ovalue_ >= rval_ || *(sc_+1) == 0x7f || s_)
      fprintf(fp,wf_,ovalue_);
    else
      {
      *(z_+0) = *(sc_+1);
      *(z_+1) = '\0';
      fprintf(fp,bf_,z_);
      }
    }
  else
    {
    *(z_+0) = *(sc_+0);
    *(z_+1) = '\0';
    fprintf(fp,bf_,z_);
    }
  }
else
  {
  if(value != (float)0.0)
    fprintf(fp,bf_,"???");
  else
    {
    if(*(sc_+0) == 0x7f || s_)
      fprintf(fp,wf_,(float)0.0);
    else
      {
      *(z_+0) = *(sc_+0);
      *(z_+1) = '\0';
      fprintf(fp,bf_,z_);
      }
    }
  }
if(s_)
  fprintf(fp,";");
}

void mkblank_(fp,colwid,s_)
FILE *fp;
short colwid,s_;
{
char bf_[16];
sprintf(bf_,"%%%d.%ds",colwid,colwid);
fprintf(fp,bf_," ");
if(s_)
  fprintf(fp,";");
}

int inumbf(u_)
unsigned short u_;
{
int ret_ = 0;
register int ii_;

for(ii_=0;ii_<12;ii_++)
   {
   if(u_ & 0x0800)
     ++ret_;
   u_ <<= 1;
   }
return(ret_);
}

int hsetline(lp,cw,txt,sid,s_)
short lp;
short cw;
char *txt;
short sid;
short s_;
{
char wbuf[10001];
int rowpos_ = 0;
int offset_ = 20;
int i_,l_,linepos_,actpos_,charcount_,start_,bfind_;

strcpy(wbuf,left(txt));
if(!s_)
  {
  linepos_ = (int)sid + (int)lp;
  l_ = strlen(wbuf);
  charcount_ = 0; bfind_ = 0;
  for(i_=0;i_<l_;i_++)
     if(++charcount_ == (cw-1) && i_ != (l_-1))
       {
       if(*(wbuf+i_) != ' ' && *(wbuf+(i_+1)) != ' ' && bfind_)
         {
         charcount_ -= (i_ - bfind_);
         i_ = bfind_;
         }
       if(*(wbuf+i_) == ' ')
         --charcount_;
       if(*(wbuf+(i_+1)) == ' ')
         ++i_;
       if(charcount_)
         {
         charcount_ = 0;
         if(!(--offset_))
           break;
         }
       bfind_ = 0;
       }
     else
     if(*(wbuf+i_) == ' ')
       bfind_ = i_;
  if(charcount_)
    --offset_;

  charcount_ = 0; start_ = 0; bfind_ = 0;
  for(i_=0;i_<l_;i_++)
     if(++charcount_ == (cw-1) && i_ != (l_-1))
       {
       if(*(wbuf+i_) != ' ' && *(wbuf+(i_+1)) != ' ' && bfind_)
         {
         charcount_ -= (i_ - bfind_);
         i_ = bfind_;
         }
       if(*(wbuf+i_) == ' ')
         --charcount_;
       if(*(wbuf+(i_+1)) == ' ')
         ++i_;
       if(charcount_)
         {
         *(kstr+posmerk[rowpos_+offset_]) = ' ';
         actpos_ = linepos_ + ((rowpos_+offset_) * 10001);
         sprintf(element_format,"%%%d.%ds",cw,charcount_);
         sprintf(kstr+actpos_,element_format,wbuf+start_);
         posmerk[rowpos_+offset_] = actpos_ + cw;
         charcount_ = 0;
         if(++rowpos_ == 20)
           break;
         }
       start_ = i_+1; bfind_ = 0;
       }
     else
     if(*(wbuf+i_) == ' ')
       bfind_ = i_;
  if(charcount_)
    {
    *(kstr+posmerk[rowpos_+offset_]) = ' ';
    actpos_ = linepos_ + ((rowpos_+offset_) * 10001);
    sprintf(element_format,"%%%d.%ds",cw,charcount_);
    sprintf(kstr+actpos_,element_format,wbuf+start_);
    posmerk[rowpos_+offset_] = actpos_ + cw;
    ++rowpos_;
    }
  }
else
  {
  if(!hkenn)
    {
    *(kstr+0) = '\0';
    hkenn = 1;
    }
  strcat(kstr,"\"");
  strcat(kstr,wbuf);
  strcat(kstr,"\";");
  rowpos_ = 1;
  }
return(rowpos_);
}

int hsetlinel(lp,cw,txt,sid,s_,semcount,semsub)
short lp;
short cw;
char *txt;
short sid;
short s_;
short semcount;
short semsub;
{
char wbuf[10001];
int rowpos_ = 0;
int offset_ = 20;
int i_,l_,linepos_,actpos_,charcount_,start_,bfind_;

strcpy(wbuf,left(txt));
if((!s_) && cw)
  {
  linepos_ = (int)sid + (int)lp;
  l_ = strlen(wbuf);
  charcount_ = 0; bfind_ = 0;
  for(i_=0;i_<l_;i_++)
     if(++charcount_ == (cw-1) && i_ != (l_-1))
       {
       if(*(wbuf+i_) != ' ' && *(wbuf+(i_+1)) != ' ' && bfind_)
         {
         charcount_ -= (i_ - bfind_);
         i_ = bfind_;
         }
       if(*(wbuf+i_) == ' ')
         --charcount_;
       if(*(wbuf+(i_+1)) == ' ')
         ++i_;
       if(charcount_)
         {
         charcount_ = 0;
         if(!(--offset_))
           break;
         }
       bfind_ = 0;
       }
     else
     if(*(wbuf+i_) == ' ')
       bfind_ = i_;
  if(charcount_)
    --offset_;

  charcount_ = 0; start_ = 0; bfind_ = 0;
  for(i_=0;i_<l_;i_++)
     if(++charcount_ == (cw-1) && i_ != (l_-1))
       {
       if(*(wbuf+i_) != ' ' && *(wbuf+(i_+1)) != ' ' && bfind_)
         {
         charcount_ -= (i_ - bfind_);
         i_ = bfind_;
         }
       if(*(wbuf+i_) == ' ')
         --charcount_;
       if(*(wbuf+(i_+1)) == ' ')
         ++i_;
       if(charcount_)
         {
         *(kstrl+posmerkl[rowpos_+offset_]) = ' ';
         actpos_ = linepos_ + ((rowpos_+offset_) * 10001);
         sprintf(element_format,"%%%ds",cw);
         sprintf(kstrl+actpos_,element_format,hjustify(cw,charcount_,wbuf+start_));
         posmerkl[rowpos_+offset_] = actpos_ + cw;
         charcount_ = 0;
         if(++rowpos_ == 20)
           break;
         }
       start_ = i_+1; bfind_ = 0;
       }
     else
     if(*(wbuf+i_) == ' ')
       bfind_ = i_;
  if(charcount_)
    {
    *(kstrl+posmerkl[rowpos_+offset_]) = ' ';
    actpos_ = linepos_ + ((rowpos_+offset_) * 10001);
    sprintf(element_format,"%%%ds",cw);
    sprintf(kstrl+actpos_,element_format,hjustify(cw,charcount_,wbuf+start_));
    posmerkl[rowpos_+offset_] = actpos_ + cw;
    ++rowpos_;
    }
  }
else
if(s_ && semcount)
  {
  if(!hkennl)
    {
    *(kstrl+0) = '\0';
    hkennl = 1;
    }
  for(i_=0; i_< semsub; i_++)
     strcat(kstrl,";");
  if(semcount-semsub)
    {
    strcat(kstrl,"\"");
    strcat(kstrl,wbuf);
    strcat(kstrl,"\"");
    }
  for(i_=0; i_< (semcount-semsub); i_++)
     strcat(kstrl,";");
  rowpos_ = 1;
  }
return(rowpos_);
}

char *left(p)
char *p;
{
while(*p == ' ')
  ++p;
return(p);
}

void clearkstr()
{
register int i_;

for(i_=0;i_<200020;i_++)
   *(kstr+i_) = ' ';
hmax = 0; hkenn = 0;
for(i_=0;i_<20;i_++)
   posmerk[i_] = 0;
for(i_=0;i_<20;i_++)
   posmerk[i_] = 0;
}

void clearkstrl(p_)
short p_;
{
register int i_;

for(i_=0;i_<200020;i_++)
   *(kstrl+i_) = ' ';
hmaxl = 0; hkennl = 0;
for(i_=0;i_<20;i_++)
   posmerkl[i_] = 0;
for(i_=0;i_<p_;i_++)
   *(unlbuf_+i_) = ' ';
*(unlbuf_+p_) = '\0';
}

char *justify(pw_,gen_,s_)
short pw_;
long gen_;
char *s_;
{
static char js_[10001];
char j_format[16];
int l_,m_;

if(gen_ & (D_TTL | D_GCR))
  sprintf(j_format,"%%-.%ds",pw_);
else
if(gen_ & D_TTR)
  sprintf(j_format,"%%%d.%ds",pw_,pw_);
else
if(gen_ & D_TTC)
  {
  l_ = strlen(s_);
  m_ = (pw_ - l_) / 2;
  m_ += l_;
  if(m_ > pw_)
    m_ = pw_;
  sprintf(j_format,"%%%d.%ds",m_,pw_);
  }
sprintf(js_,j_format,s_);
return(js_);
}

char *mktype(ov_)
unsigned short ov_;
{
static char typstr[128];
unsigned short ovv_ = ov_ & (unsigned short)0xffef;
short m_ = 0;

*(typstr+0) = '\0';
while(ovv_)
  {
  if(m_)
    strcat(typstr,"/");
  if(ovv_ & 0x0100)
    {
    strcat(typstr,"Absolutes");
    m_ = 1;
    ovv_ &= 0xffff - 0x0100;
    }
  else
  if(ovv_ & 0x0080)
    {
    strcat(typstr,"col percents");
    m_ = 1;
    ovv_ &= 0xffff - 0x0080;
    }
  else
  if(ovv_ & 0x0200)
    {
    strcat(typstr,"row percents");
    m_ = 1;
    ovv_ &= 0xffff - 0x0200;
    }
  else
  if(ovv_ & 0x0800)
    {
    strcat(typstr,"total percents");
    m_ = 1;
    ovv_ &= 0xffff - 0x0800;
    }
  }
return(typstr);
}

char *hjustify(pw_,len_,s_)
short pw_;
int len_;
char *s_;
{
static char js_[10001];
char j_format[16];
int m_;
char *dum_ = "";

m_ = (pw_ / 2) - (len_ / 2);

sprintf(j_format,"%%%d.%ds",m_,m_);
sprintf(js_,j_format,dum_);
sprintf(j_format,"%%%d.%ds",len_,len_);
sprintf(js_+m_,j_format,s_);
sprintf(j_format,"%%%d.%ds",pw_-(m_+len_),pw_-(m_+len_));
sprintf(js_+m_+len_,j_format,dum_);

return(js_);
}

char *mkunl_side(s_,t_)
char *s_;
int t_;
{
register int i_;
short stop_ = 1;
short doit_ = 0;
int l_;
static char rs_[10002];

*(rs_+0) = '\0';
l_ = strlen(s_);
for(i_=0; i_<l_; i_++)
   if(*(s_+i_) != ' ')
     {
     doit_ = 1;
     break;
     }

if(doit_)
  {
  *(rs_+0) = 0x0D;
  if(t_ & 0x00001000)
    {
    for(i_=0; i_<l_; i_++)
       {
       if(stop_ && *(s_+i_) != ' ')
         stop_ = 0;
       if(stop_)
         *(rs_+(i_+1)) = ' ';
       else
         *(rs_+(i_+1)) = '_';
       }
    *(rs_+(i_+1)) = '\0';
    }
  else
  if(t_ & 0x00002000)
    {
    for(i_=0; i_<l_; i_++)
       {
       if(stop_ && *(s_+i_) != ' ')
         stop_ = 0;
       if(stop_)
         *(rs_+(i_+1)) = ' ';
       else
         {
         if(*(s_+i_) != ' ' || ((i_ && *((s_+i_)-1) != ' ') && ((i_+1)<l_ && *((s_+i_)+1) != ' ')))
           *(rs_+(i_+1)) = '_';
         else
           *(rs_+(i_+1)) = ' ';
         }
       }
    *(rs_+(i_+1)) = '\0';
    }
  else
  if(t_ & 0x00004000)
    {
    for(i_=0; i_<l_; i_++)
       {
       if(stop_ && *(s_+i_) != ' ')
         stop_ = 0;
       if(stop_)
         *(rs_+(i_+1)) = ' ';
       else
         {
         if(*(s_+i_) != ' ')
           *(rs_+(i_+1)) = '_';
         else
           *(rs_+(i_+1)) = ' ';
         }
       }
    *(rs_+(i_+1)) = '\0';
    }
  }

return(rs_);
}

void mkunl_head(o_,p_,l_)
short o_;
short p_;
short l_;
{
int i_;

for(i_=((p_+1)+o_); i_<((p_+o_)+l_); i_++)
   *(unlbuf_+i_) = '-';
}

/* Rest In Peace */
void null_division(sig)
int sig;
{

signal(SIGFPE, SIG_IGN);
printf("*** division by zero was detected by ccount (signal %d) - dropped out of run ...\n",sig);
exit(1);
}

short side_autobreak(s,slen,side)
char *s;
short slen;
short side;
{
char *spointer_ = s;
char *dpointer_ = s;
short i_,j_,k_,bmerk_,endlen_;
short idx_ = 0;
short totcount_ = 0;

for(i_=0;i_<99;i_++)
   {
   bmerk_ = 0;
   for(j_=0;j_<side && totcount_<slen;j_++,totcount_++)
      {
      if(*(spointer_+j_) == ' ')
        bmerk_ = j_;
      else
      if(*(spointer_+j_) == '-' && (j_+1) < side)
        bmerk_ = j_+1;
      else
      if(*(spointer_+j_) == '/' && (j_+1) < side)
        bmerk_ = j_+1;
      }
   if(totcount_<slen && *(spointer_+j_) == ' ')
     bmerk_ = j_;
   if(bmerk_ && totcount_<slen)
     endlen_ = bmerk_;
   else
     endlen_ = j_;
   sbuf_[idx_] = (char*)mustcalloc((unsigned)endlen_+1,(unsigned)sizeof(char),"sbuf_[]");
   for(k_=0;k_<endlen_;k_++)
      *(sbuf_[idx_]+k_) = *(spointer_+k_);
   *(sbuf_[idx_]+k_) = '\0';
   spointer_ += endlen_;
   while(*spointer_ == ' ')
        spointer_++;
   totcount_ = (short)(spointer_ - dpointer_);
   idx_++;
   if(totcount_ >= slen)
     break;
   }

return(idx_);
}

short side_autobreak_check(s,slen,side)
char *s;
short slen;
short side;
{
char *spointer_ = s;
char *dpointer_ = s;
short i_,j_,bmerk_,endlen_;
short idx_ = 0;
short totcount_ = 0;

for(i_=0;i_<99;i_++)
   {
   bmerk_ = 0;
   for(j_=0;j_<side && totcount_<slen;j_++,totcount_++)
      {
      if(*(spointer_+j_) == ' ')
        bmerk_ = j_;
      else
      if(*(spointer_+j_) == '-' && (j_+1) < side)
        bmerk_ = j_+1;
      else
      if(*(spointer_+j_) == '/' && (j_+1) < side)
        bmerk_ = j_+1;
      }
   if(totcount_<slen && *(spointer_+j_) == ' ')
     bmerk_ = j_;
   if(bmerk_ && totcount_<slen)
     endlen_ = bmerk_;
   else
     endlen_ = j_;
   spointer_ += endlen_;
   while(*spointer_ == ' ')
        spointer_++;
   totcount_ = (short)(spointer_ - dpointer_);
   idx_++;
   if(totcount_ >= slen)
     break;
   }

return(idx_);
}

double round_(zahl,stellen)
double zahl;
int stellen;
{
int x;
double wert;

x = (int)pow((double)10.0,(double)(stellen+1));
wert = zahl * (double)x;
if(wert > (double)0.0)
  {
  wert += (double)5.0;
  wert = floor((double)wert / (double)10.0);
  }
else
if(wert < (double)0.0)
  {
  wert -= (double)5.0;
  wert = ceil(wert / (double)10.0);
  }
x = (int)pow((double)10.0,(double)stellen);

return(wert/(double)x);
}
