/******************************/
/*                            */
/*         fetch.c            */
/*                            */
/*       Version 1.9          */
/*                            */
/*                            */
/* prog: V.Hoffmann  01.12.03 */
/******************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "os.h"

#define MAXELEM 65536
#define MAXSIZE 99999
#define MAXFILE 10
#define FNAMLEN 256

extern char *mustcalloc();
extern char *getstr_();
extern void colsmv_();
extern void fillblankf_();

void fetch();
int isopen();

struct struct_ffile {
       char fname[FNAMLEN+1];
       long maxcount;
       int keylen_;
       int reclen_;
       int efflen_;
       int used_;
       int hits_;
       int calls_;
       char **ftc_;
} ffile[MAXFILE];

/* global variables */
int f_ = 0;

void fetch(dat_,sourcecol_,destcol_)
char *dat_;
unsigned short *sourcecol_;
unsigned short *destcol_;
{
register int i_;
static int alrdydone_ = 0;
int err_   = 0;
int found_ = 0;
int comp_,q_;
int asc_l;
long min_,max_,curr_,reccount_;
static char *rec_used[MAXFILE];
extern char *asc_s;
FILE *ffp;

if(!alrdydone_)
  {
  for(i_=0;i_<MAXFILE;i_++)
     {
     *(ffile[i_].fname+0) = '\0';
     ffile[i_].used_      = 0;
     ffile[i_].hits_      = 0;
     ffile[i_].calls_     = 0;
     }
  alrdydone_ = 1;
  }

if(!(q_ = isopen(dat_,f_)))
  {
  if(f_ >= MAXFILE)
    {
    printf("Error: more than %d fetch files\n",MAXFILE);
    exit(1);
    }
  if(strlen(dat_) > FNAMLEN)
    {
    printf("Error: fetch filename %s longer than %d characters\n",dat_,FNAMLEN);
    exit(1);
    }
  strcpy(ffile[f_].fname,dat_);
  if((ffp = fopen(ffile[f_].fname,"r")) == NULL)
    {
    printf("cannot open %s\n",ffile[f_].fname);
    exit(1);
    }
  ffile[f_].ftc_ = (char **)mustcalloc((unsigned)MAXELEM,sizeof(char *),"*ftc_");
  fgets(asc_s,MAXSIZE,ffp);
  sscanf(asc_s,"%d%d",&ffile[f_].keylen_,&ffile[f_].reclen_);
  if(ffile[f_].keylen_ > MAXSIZE || ffile[f_].reclen_ > MAXSIZE)
    {
    printf("%s: keylen or reclen > %d\n",ffile[f_].fname,MAXSIZE);
    exit(1);
    }
  if(ffile[f_].keylen_ == 0 || ffile[f_].reclen_ == 0 ||
     ffile[f_].reclen_ <= ffile[f_].keylen_)
    {
    printf("incorrect parameters on line 1 of fetch file %s\n",ffile[f_].fname);
    exit(1);
    }
  ffile[f_].efflen_ = ffile[f_].reclen_ - ffile[f_].keylen_;
  reccount_ = 0;
  while(fgets(asc_s,MAXSIZE,ffp) != NULL)
    {
    if(reccount_ >= MAXELEM)
      {
      printf("too many records in fetch file %s\n",ffile[f_].fname);
      exit(1);
      }
    asc_l = strlen(asc_s) - 1;
    if(asc_l && *(asc_s+(asc_l-1)) == 0x0d)
      asc_l--;
    for(i_=asc_l;i_<ffile[f_].reclen_;i_++)
       *(asc_s+i_) = ' ';
    *(asc_s+ffile[f_].reclen_) = '\0';
    ffile[f_].ftc_[reccount_] = (char *)mustcalloc((unsigned)ffile[f_].reclen_+1,sizeof(char),"ftc_");
    if(reccount_ && strncmp(ffile[f_].ftc_[reccount_-1],asc_s,ffile[f_].keylen_) >= 0)
      {
      printf("%s: record %ld out of order\n",ffile[f_].fname,reccount_);
      err_ = 1;
      }
    strcpy(ffile[f_].ftc_[reccount_],asc_s);
    ++reccount_;
    }
  rec_used[f_] = (char *)mustcalloc((unsigned)reccount_,sizeof(char),"rec_used");
  for(i_=0;i_<reccount_;i_++)
     rec_used[f_][i_] = (char)0;
  ffile[f_].maxcount = reccount_;
  ++f_; q_ = f_;
  fclose(ffp);
  if(err_)
    exit(1);
  }
--q_;
min_ = 0; max_ = ffile[q_].maxcount; ffile[q_].calls_++;
while(min_ < max_)
  {
  curr_ = min_ + ((max_ - min_) / 2);
  comp_ = strncmp(getstr_(sourcecol_,ffile[q_].keylen_),ffile[q_].ftc_[(int)curr_],ffile[q_].keylen_);
  if(comp_ > 0)
    min_ = curr_ + 1;
  else
  if(comp_ < 0)
    max_ = curr_;
  else
    {
    found_ = 1;
    ffile[q_].hits_++;
    if(!(int)rec_used[q_][curr_])
      {
      rec_used[q_][curr_] = (char)1;
      ffile[q_].used_++;
      }
    break;
    }
  }
if(found_)
  colsmv_(destcol_,0L,(long)ffile[q_].efflen_,ffile[q_].ftc_[(int)curr_]+ffile[q_].keylen_,(long)ffile[q_].efflen_);
else
  fillblankf_(destcol_,0L,(long)ffile[q_].efflen_);
}

int isopen(s_,f_)
char *s_;
int f_;
{
int ret_ = 0;
int i_;

for(i_=0;i_<f_;i_++)
   if(!strcmp(ffile[i_].fname,s_))
     {
     ret_ = i_ + 1;
     break;
     }
return(ret_);
}
