/******************************/
/*                            */
/*        online.c            */
/*                            */
/*       Version 2.4          */
/*                            */
/*                            */
/* prog: V.Hoffmann  16.03.04 */
/******************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include "os.h"

#define CMDSIZE 32000
#define INSIZE 128
#define MACROS 10
#define CONDTS 10

#define NO_ 0
#define ED_ NO_+1
#define RT_ ED_+1
#define RJ_ RT_+1
#define CA_ RJ_+1
#define AC_ CA_+1

#define NERR 0
#define NINT 1
#define NPNT 2

extern struct req_struct {
char *text;        /*text to accompany print*/
short type;        /*0-7 for require action code*/
short start;       /*first column for requires to examine*/
short finish;      /*last column to examine, or -1*/
short appear;      /*message occured this time*/
long wcount;       /*number of records passed this write*/
} req_texts_[];
extern struct file_def {
char *name;        /*file name*/
char *heading;     /*page heading for print files*/
short mptype;      /*how to output multipunches*/
char seqno;        /*filedef_ sequence number*/
char ifrule;       /*whether to print ruler*/
char ifser;        /*whether to print 'Record NNN'*/
short ifdone;      /*whether current (level of) record output to this file yet*/
int   reclen;      /*number of columns in record*/
short lineno;      /*current line number on current page*/
short pageno;      /*current page number*/
short ftype;       /*type of file*/
FILE *fp;          /*where the file is open*/
} filedef_[];
extern int cvars;
extern int cseqs_;
extern int structargs[];
extern int edcorr;
extern short rejected_;
extern unsigned short bt[];
extern unsigned short *c;
extern unsigned short *c_tmp;
extern char *asc_s;
extern char qfolg[];
extern long *thisread;
extern long *allread;
extern short printed_;
extern char mserial[];
extern short trun_;
extern short lastrec;

int online_edit();
int edintp();
char *formatline();
void errmsg();
void o_writerecout();
void o_subwriteout();
void swaprec_();
int o_setqtmstrout();
int isnumb();
void mkhead();
char *mkmpstr_();
unsigned short asctoqtm();
int ispunch();
int isstr();
int isstpnch();
void colsmv_();
void colcmv_();
char *nospc();
int isc_();
int isf_();
int allblank();
void fillblankf_();
int cmdend();
char *mustcalloc();
void writecmds();
char *left();
int fmacro();
int nmacro();
void shmac();
void shcon();
void print_errors();
int fcon();
int ncon();
int msgfound();
int getfield();

unsigned short qval_[ ] = {
0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,
0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,
0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x1fff,0x0000,
0x0482,0x0006,0x0042,0x0442,0x0222,0x0800,0x0012,0x0812,0x0412,0x0422,0x080a,
0x0242,0x0400,0x0842,0x0300,0x0200,0x0100,0x0080,0x0040,0x0020,0x0010,0x0008,
0x0004,0x0002,0x0001,0x0082,0x040a,0x0822,0x000a,0x020a,0x0206,0x0022,0x0900,
0x0880,0x0840,0x0820,0x0810,0x0808,0x0804,0x0802,0x0801,0x0500,0x0480,0x0440,
0x0420,0x0410,0x0408,0x0404,0x0402,0x0401,0x0280,0x0240,0x0220,0x0210,0x0208,
0x0204,0x0202,0x0201,0x1fff,0x0282,0x1fff,0x1fff,0x0212,0x0902,0x0b00,0x0a80,
0x0a40,0x0a20,0x0a10,0x0a08,0x0a04,0x0a02,0x0a01,0x0d00,0x0c80,0x0c40,0x0c20,
0x0c10,0x0c08,0x0c04,0x0c02,0x0c01,0x0680,0x0640,0x0620,0x0610,0x0608,0x0604,
0x0602,0x0601,0x0a00,0x0882,0x0600,0x0700,0x0000,
0x2001,0x2002,0x2003,0x2004,0x2005,0x2006,0x2007,0x2008,0x2009,0x200a,0x200b,
0x200c,0x200d,0x200e,0x200f,0x2010,0x2011,0x2012,0x2013,0x2014,0x2015,0x2016,
0x2017,0x2018,0x2019,0x201a,0x201b,0x201c,0x201d,0x201e,0x201f,0x2020,0x2021,
0x2022,0x2023,0x2024,0x2025,0x2026,0x2027,0x2028,0x2029,0x202a,0x202b,0x202c,
0x202d,0x202e,0x202f,0x2030,0x2031,0x2032,0x2033,0x2034,0x2035,0x2036,0x2037,
0x2038,0x2039,0x203a,0x203b,0x203c,0x203d,0x203e,0x203f,0x2040,0x2041,0x2042,
0x2043,0x2044,0x2045,0x2046,0x2047,0x2048,0x2049,0x204a,0x204b,0x204c,0x204d,
0x204e,0x204f,0x2050,0x2051,0x2052,0x2053,0x2054,0x2055,0x2056,0x2057,0x2058,
0x2059,0x205a,0x205b,0x205c,0x205d,0x205e,0x205f,0x2060,0x2061,0x2062,0x2063,
0x2064,0x2065,0x2066,0x2067,0x2068,0x2069,0x206a,0x206b,0x206c,0x206d,0x206e,
0x206f,0x2070,0x2071,0x2072,0x2073,0x2074,0x2075,0x2076,0x2077,0x2078,0x2079,
0x207a,0x207b,0x207c,0x207d,0x207e,0x207f,0x2080
                         } ; /* 0x0000, da Compiler Blanks in 0x7f umwandelt */
struct cmd_struct {
       char *cmdptr;                /*pointer to command string*/
       struct cmd_struct *nextcmd;  /*the next structure*/
} cmds_[CMDSIZE];
struct mac_struct {
       char m_name[9];
       char m_string[INSIZE];
} macs_[MACROS];
struct con_struct {
       int c_num;
       char c_string[INSIZE];
} conds_[CONDTS];

struct cmd_struct *cstart_ = &cmds_[0];
int ins_ = 0;
int maxerr_ = 0;
short cr_ = 0;
short len;
short count;
short i;
int mjn,expcount_;
char *ctab[64];
char wbuf[INSIZE];
char xbuf[INSIZE];
char ruler2_[] = "   ___+___ 1 ___+___ 2 ___+___ 3 ___+___ 4 ___+___ 5 ___+___ 6 ___+___ 7 ___+___ 8 ___+___ 9 ___+___ 0 ___+___ 1 ___+___ 2 ___+___ 3 ___+___ 4 ___+___ 5 ___+___ 6 ___+___ 7 ___+___ 8 ___+___ 9 ___+___ 0";

int online_edit()
{
int ret_ = NO_;
static FILE *cfp;
static FILE *tfp;
static int ad_ = 0;
static int rd_ = 0;
static int ro_ = 0;
static int rr_ = 0;
static int frs_ = 0;
static int dne_ = 0;
static int cmdcount_ = 0;
static int maxcmd_ = 0;
int clen_,i_;

if(!rd_)
  {
  signal(SIGINT,SIG_IGN);
  if((cfp = fopen("online.rcd","r")) != NULL)
    ro_ = 1;
  for(i_=0;i_<MACROS;i_++)
     *(macs_[i_].m_name+0) = '\0';
  for(i_=0;i_<CONDTS;i_++)
     *(conds_[i_].c_string+0) = '\0';
  while(req_texts_[maxerr_].text != NULL)
       ++maxerr_;
  rd_ = 1;
  }

if(ro_)
  {
  while(!rr_ && fgets(xbuf,INSIZE,cfp) != NULL)
    {
    if(!cmdcount_)
      printf("\n*** reading corrections...\n\n");
    clen_ = strlen(xbuf) - 1;
    if(clen_ < structargs[4])
      {
      fprintf(stderr,"\ninvalid record in online.rcd line %d\n",cmdcount_);
      exit(1);
      }
    *(xbuf+clen_) = '\0';
    cmds_[cmdcount_].cmdptr = (char *)(mustcalloc((unsigned)clen_+1,sizeof(char),"cmds_[].cmdptr"));
    strcpy(cmds_[cmdcount_].cmdptr,xbuf);
    cmds_[cmdcount_].nextcmd = NULL;
    if(cmdcount_)
      cmds_[cmdcount_-1].nextcmd = &cmds_[cmdcount_];
    ++cmdcount_;
    }
  if(!rr_)
    {
    cmds_[cmdcount_].cmdptr = NULL;
    maxcmd_ = cmdcount_ + 1;
    cmdcount_ = 0;
    rr_ = 1;
    }
  trun_ = 1;
  while(cmds_[cmdcount_].cmdptr != NULL)
    {
    strcpy(xbuf,cmds_[cmdcount_].cmdptr);
    if(strncmp(xbuf,mserial,(unsigned)structargs[4]) < 0)
      {
      ++cmdcount_; dne_ = 0;
      continue;
      }
    else
    if(!printed_)
      {
      while(ret_ <= 0 && cmds_[cmdcount_].cmdptr != NULL)
        {
        strcpy(xbuf,cmds_[cmdcount_].cmdptr);
        if(strncmp(xbuf,mserial,(unsigned)structargs[4]))
          break;
        if(cmds_[cmdcount_].nextcmd == NULL)
          trun_ = 0;
        strcpy(wbuf,xbuf+structargs[4]);
        ret_ = edintp(wbuf);
        if(ret_ != ED_)
          {
          fprintf(filedef_[0].fp,"correction file setting %s  in record %s\n",xbuf+structargs[4],mserial);
          mkhead((long)0,1);
          }
        if(ret_ == RT_ && lastrec && ins_)
          {
          writecmds();
          ins_ = 0;
          }
        ++cmdcount_; dne_ = 0;
        }
      frs_ = 0;
      goto END;
      }
    else
    if(strncmp(xbuf,mserial,(unsigned)structargs[4]) > 0)
      {
      trun_ = 0;
      while(ret_ <= 0)
        {
        if(!frs_)
          {
          frs_ = 1;
          ret_ = ED_;
          filedef_[0].ifdone = 0;
          fprintf(filedef_[0].fp,"-> ed\n\n");
          mkhead((long)0,2);
          printed_ = 0;
          goto END;
          }
        ins_ = 1;
        if((i_ = msgfound()))
          strcpy(xbuf,conds_[i_-1].c_string);
        else
          {
          printf("\n(insert-mode) -> ");
          fgets(xbuf,INSIZE,stdin);
          *(xbuf+(strlen(xbuf)-1)) = '\0';
          }
        strcpy(wbuf,xbuf);
        ret_ = edintp(wbuf);
        if(ret_ && ret_ != CA_ && ret_ != AC_ && !trun_)
          {
          clen_ = strlen(xbuf);
          cmds_[maxcmd_].cmdptr = (char *)(mustcalloc((unsigned)clen_+structargs[4]+2,sizeof(char),"cmds_[].cmdptr"));
          sprintf(cmds_[maxcmd_].cmdptr,"%s %s",mserial,xbuf);
          cmds_[maxcmd_].nextcmd = &cmds_[cmdcount_];
          if(!dne_)
            {
            dne_ = 1;
            if(cmdcount_)
              cmds_[cmdcount_-1].nextcmd = &cmds_[maxcmd_];
            else
              cstart_ = &cmds_[maxcmd_];
            }
          else
            cmds_[maxcmd_-1].nextcmd = &cmds_[maxcmd_];
          ++maxcmd_;
          }
        if(ret_)
          {
          fprintf(filedef_[0].fp,"-> %s\n\n",xbuf);
          mkhead((long)0,2);
          }
        if(ret_ == CA_ || (ret_ == RT_ && lastrec))
          {
          writecmds();
          ins_ = 0;
          }
        }
      }
    else
      {
      if(cmds_[cmdcount_].nextcmd == NULL)
        trun_ = 0;
      strcpy(wbuf,xbuf+structargs[4]);
      ret_ = edintp(wbuf);
      fprintf(filedef_[0].fp,"-> %s\n\n",xbuf);
      mkhead((long)0,2);
      if(ret_ == RT_ && lastrec && ins_)
        {
        writecmds();
        ins_ = 0;
        }
      ++cmdcount_; frs_ = 0; dne_ = 0;
      }
    if(ret_ > 0)
      goto END;
    }
  }
if(ro_)
  {
  fclose(cfp);
  if(ins_)
    writecmds();
  ro_ = 0; trun_ = 0; ins_ = 0;
  }
if(!printed_)
  {
  ret_ = NO_;
  goto END;
  }
if(!ad_)
  {
  if((cfp = fopen("online.rcd","a")) == NULL)
    {
    fprintf(stderr,"cannot open online.rcd\n");
    exit(1);
    }
  if((tfp = fopen("online.tch","w")) == NULL)
    {
    fprintf(stderr,"cannot open online.tch\n");
    exit(1);
    }
  fprintf(tfp,"Ccount (C) V. Hoffmann  -  records in error\n\n");
  ad_ = 1;
  }

if(trun_)
  {
  fprintf(tfp,"Record %s __\n\n",mserial);
  ret_ = RT_;
  goto END;
  }

while(ret_ <= 0)
  {
  if((i_ = msgfound()))
    strcpy(xbuf,conds_[i_-1].c_string);
  else
    {
    printf("\n(append-mode) -> ");
    fgets(xbuf,INSIZE,stdin);
    *(xbuf+(strlen(xbuf)-1)) = '\0';
    }
  strcpy(wbuf,xbuf);
  ret_ = edintp(wbuf);
  if(ret_ && ret_ != CA_ && ret_ != AC_ && !trun_)
    {
    fprintf(cfp,"%s %s\n",mserial,xbuf);
    fclose(cfp);
    cfp = fopen("online.rcd","a");
    }
    if(ret_)
      {
      fprintf(filedef_[0].fp,"-> %s\n\n",xbuf);
      mkhead((long)0,2);
      }
  }

END: ;
return(ret_);
}

int edintp(buf)
char *buf;
{
int ret_ = 0;
int sfn_ = 1;
long lval_;
long lstr_;
long mval_;
long mstr_;
long slen_;
int k1_,k2_,i_;
unsigned short k_;
char macb_[INSIZE];
char *inbuf_;

strcpy(buf,left(buf));
strcpy(macb_,buf);
strcpy(buf,formatline(buf));
len = (short)strlen(buf);
count = 0; mjn = 0;
for(i=0;i<len;i++)
   {
   if(*(buf + i) != ' ')
     {
     if(!mjn)
       {
       ctab[count++] = buf + i;
       mjn = 1;
       }
     }
     else
     {
     *(buf + i) = '\0';
     mjn = 0;
     }
   }
expcount_ = 1;
if(!count)
  {
  ret_ = ED_;
  filedef_[0].ifdone = 0;
  printed_ = 0;
  }
for(i=0;i<count;i++)
   {
   if(!strcmp(ctab[i],";"))
     {
     ++expcount_;
     sfn_ = 1;
     continue;
     }
   if(!sfn_)
     {
     errmsg(  1);
     break;
     }
   if(!i && !strcmp(ctab[i],"ca") && cmdend(i+1))
     {
     edcorr = 0;
     ret_ = CA_;
     sfn_ = 0;
     continue;
     }
   if(!i && !strcmp(ctab[i],"cron") && cmdend(i+1))
     {
     cr_ = 1;
     sfn_ = 0;
     continue;
     }
   if(!i && !strcmp(ctab[i],"croff") && cmdend(i+1))
     {
     cr_ = 0;
     sfn_ = 0;
     continue;
     }
   if(!i && !strcmp(ctab[i],"touch") && cmdend(i+1))
     {
     if(ins_)
       {
       errmsg(  8);
       break;
       }
     trun_ = 1;
     ret_ = ED_;
     sfn_ = 0;
     continue;
     }
   if(!i && !strcmp(ctab[i],"ed") && cmdend(i+1))
     {
     ret_ = ED_;
     filedef_[0].ifdone = 0;
     printed_ = 0;
     sfn_ = 0;
     continue;
     }
   if(!i && !strcmp(ctab[i],"ac") && cmdend(i+1))
     {
     ret_ = AC_;
     rejected_ = 0;
     sfn_ = 0;
     continue;
     }
   if(!i && !strcmp(ctab[i],"rj") && cmdend(i+1))
     {
     ret_ = RJ_;
     rejected_ = 1;
     sfn_ = 0;
     continue;
     }
   if(!i && !strcmp(ctab[i],"rt") && cmdend(i+1))
     {
     ret_ = RT_;
     sfn_ = 0;
     continue;
     }
   if(!i && !strcmp(ctab[i],"macro") && !cmdend(i+1))
     {
     if(strlen(ctab[i+1]) > 8)
       {
       errmsg(  9);
       break;
       }
     if(cmdend(i+2))
       {
       if(!(i_ = fmacro(ctab[i+1])))
         {
         errmsg( 10);
         break;
         }
       *(macs_[i_-1].m_name+0) = '\0';
       if(!trun_)
         printf("macro %s deleted\n",ctab[i+1]);
       }
     else
       {
       if(fmacro(ctab[i+1]))
         {
         errmsg( 11);
         break;
         }
       if(!(i_ = nmacro(ctab[i+1],macb_+6)))
         {
         errmsg( 12);
         break;
         }
       if(!trun_)
         printf("macro %s created\n",ctab[i+1]);
       }
     ret_ = -1;
     sfn_ = 0;
     break;
     }
   if(!i && !strcmp(ctab[i],"macro") && cmdend(i+1))
     {
     if(!trun_)
       shmac();
     sfn_ = 0;
     continue;
     }
   if(!i && !strcmp(ctab[i],"cond") && !cmdend(i+1))
     {
     if(isnumb(ctab[i+1]) != NINT)
       {
       errmsg(  2);
       break;
       }
     sscanf(ctab[i+1],"%d",&i_);
     if(i_ >= maxerr_)
       {
       errmsg( 13);
       break;
       }
     if(cmdend(i+2))
       {
       if(!(i_ = fcon(ctab[i+1])))
         {
         errmsg( 14);
         break;
         }
       *(conds_[i_-1].c_string+0) = '\0';
       if(!trun_)
         printf("condition %s deleted\n",ctab[i+1]);
       }
     else
       {
       if(fcon(ctab[i+1]))
         {
         errmsg( 15);
         break;
         }
       if(!(i_ = ncon(ctab[i+1],macb_+5)))
         {
         errmsg( 16);
         break;
         }
       if(!trun_)
         printf("condition %s created\n",ctab[i+1]);
       }
     sfn_ = 0;
     break;
     }
   if(!i && !strcmp(ctab[i],"cond") && cmdend(i+1))
     {
     if(!trun_)
       shcon();
     sfn_ = 0;
     continue;
     }
   if(!i && !strcmp(ctab[i],"stop") && cmdend(i+1))
     {
     if(ins_)
       writecmds();
     printf("*** Data Correction has been stopped\n\n");
     exit(0);
     sfn_ = 0;
     continue;
     }
   if(!strcmp(ctab[i],"di") && cmdend(i+1))
     {
     if(cvars > 80)
       lval_ = 80L;
     else
       lval_ = (long)cvars;
     if(!trun_)
       o_writerecout(c,1L,lval_);
     sfn_ = 0;
     continue;
     }
   if(!strcmp(ctab[i],"di") && !cmdend(i+3))
     {
     if(isnumb(ctab[i+1]) != NINT)
       {
       errmsg(  2);
       break;
       }
     if(strcmp(ctab[i+2],",") && strcmp(ctab[i+2],"-"))
       {
       errmsg(  1);
       break;
       }
     if(isnumb(ctab[i+3]) != NINT)
       {
       errmsg(  2);
       break;
       }
     sscanf(ctab[i+1],"%ld",&lval_);
     sscanf(ctab[i+3],"%ld",&lstr_);
     if(structargs[5] && lval_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(structargs[5] && lstr_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(lval_ > lstr_)
       {
       errmsg(  3);
       break;
       }
     lstr_ = (lstr_ - lval_) + 1L;
     if((lval_ + (lstr_ - 1L)) > (long)cvars)
       {
       errmsg(  4);
       break;
       }
     if(lstr_ > 80L)
       lstr_ = 80L;
     if(!trun_)
       o_subwriteout(c,lval_,lstr_);
     i += 3;
     sfn_ = 0;
     continue;
     }
   if(!strcmp(ctab[i],"di") && !cmdend(i+2) && !strcmp(ctab[i+2],"+"))
     {
     if(isnumb(ctab[i+1]) != NINT)
       {
       errmsg(  2);
       break;
       }
     sscanf(ctab[i+1],"%ld",&lval_);
     if(structargs[5] && lval_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(lval_ > (long)cvars)
       {
       errmsg(  4);
       break;
       }
     lstr_ = (long)cvars - lval_;
     if(lstr_ > 80L)
       lstr_ = 80L;
     if(!trun_)
       o_subwriteout(c,lval_,lstr_);
     i += 2;
     sfn_ = 0;
     continue;
     }
   if(!strcmp(ctab[i],"di") && !cmdend(i+1) && isnumb(ctab[i+1]) == NINT)
     {
     sscanf(ctab[i+1],"%ld",&lval_);
     if(structargs[5] && lval_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(lval_ > (long)cvars)
       {
       errmsg(  4);
       break;
       }
     if(!trun_)
       printf("\n%s%ld%s%s\n","column ",lval_," is ",mkmpstr_(*(c+(int)lval_)));
     i += 1;
     sfn_ = 0;
     continue;
     }
   if(!strncmp(ctab[i],"inp",3) && !cmdend(i+3))
     {
     if(trun_)
       {
       i += 3;
       sfn_ = 0;
       continue;
       }
     if(isnumb(ctab[i+1]) != NINT)
       {
       errmsg(  2);
       break;
       }
     if(strcmp(ctab[i+2],",") && strcmp(ctab[i+2],"-"))
       {
       errmsg(  1);
       break;
       }
     if(isnumb(ctab[i+3]) != NINT)
       {
       errmsg(  2);
       break;
       }
     sscanf(ctab[i+1],"%ld",&lval_);
     sscanf(ctab[i+3],"%ld",&lstr_);
     if(structargs[5] && lval_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(structargs[5] && lstr_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(lval_ > lstr_)
       {
       errmsg(  3);
       break;
       }
     lstr_ = (lstr_ - lval_) + 1L;
     if((lval_ + (lstr_ - 1L)) > (long)cvars)
       {
       errmsg(  4);
       break;
       }
     inbuf_ = (char *)(mustcalloc((unsigned)128,sizeof(char),"inbuf_"));
     do {
        if((i_ = getfield((int)lval_,(int)lstr_,inbuf_)))
          errmsg( 17);
        else
          {
          mstr_ = (long)strlen(inbuf_);
          if(mstr_ && mstr_ != lstr_)
            errmsg(  5);
          }
        } while(mstr_ && (mstr_ != lstr_ || i_));
     sprintf(macb_,";%s,%s$%s$",ctab[i+1],ctab[i+3],inbuf_);
     strcat(xbuf,macb_);
     colsmv_(c,lval_,lstr_,inbuf_,mstr_);
     free(inbuf_);
     i += 3;
     sfn_ = 0; ret_ = -1;
     continue;
     }
   if(!strncmp(ctab[i],"mess",4) && cmdend(i+1))
     {
     if(!trun_)
       print_errors(-1);
     continue;
     }
   if(!strncmp(ctab[i],"mess",4) && isnumb(ctab[i+1]) == NINT && cmdend(i+2))
     {
     sscanf(ctab[i+1],"%d",&i_);
     if(i_ >= maxerr_)
       {
       errmsg( 13);
       break;
       }
     if(!trun_)
       print_errors(i_);
     i += 1;
     continue;
     }
   if(isnumb(ctab[i]) == NINT && !cmdend(i+3) && isstr(ctab[i+3]))
     {
     if(strcmp(ctab[i+1],",") && strcmp(ctab[i+1],"-"))
       {
       errmsg(  1);
       break;
       }
     if(isnumb(ctab[i+2]) != NINT)
       {
       errmsg(  2);
       break;
       }
     slen_ = (long)isstr(ctab[i+3]);
     sscanf(ctab[i  ],"%ld",&lval_);
     sscanf(ctab[i+2],"%ld",&lstr_);
     k1_ = (int)lval_ / 100;
     k2_ = (int)lstr_ / 100;
     if(k1_ != k2_ && structargs[5])
       {
       errmsg(  7);
       break;
       }
     if(structargs[5] && lval_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(structargs[5] && lstr_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(lval_ > lstr_)
       {
       errmsg(  3);
       break;
       }
     lstr_ = (lstr_ - lval_) + 1L;
     if((lval_ + (lstr_ - 1L)) > (long)cvars)
       {
       errmsg(  4);
       break;
       }
     if(lstr_ > 80L)
       lstr_ = 80L;
     if(allblank(ctab[i+3]))
       fillblankf_(c,lval_,lstr_);
     else
       {
       if(lstr_ != slen_)
         {
         errmsg(  5);
         break;
         }
       colsmv_(c,lval_,lstr_,nospc(ctab[i+3])+1,lstr_);
       }
     i += 3; ret_ = -1;
     sfn_ = 0;
     continue;
     }
   if(isnumb(ctab[i]) == NINT && !cmdend(i+1) && isstr(ctab[i+1]))
     {
     sscanf(ctab[i],"%ld",&lval_);
     if(structargs[5] && lval_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(lval_ > (long)cvars)
       {
       errmsg(  4);
       break;
       }
     slen_ = (long)isstr(ctab[i+1]);
     if(slen_ != 1L)
       {
       errmsg(  5);
       break;
       }
     colsmv_(c,lval_,1L,nospc(ctab[i+1])+1,1L);
     i += 1; ret_ = -1;
     sfn_ = 0;
     continue;
     }
   if(isnumb(ctab[i]) == NINT && !cmdend(i+1) && ispunch(ctab[i+1]))
     {
     sscanf(ctab[i],"%ld",&lval_);
     if(structargs[5] && lval_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(lval_ > (long)cvars)
       {
       errmsg(  4);
       break;
       }
     k_ = strlen(ctab[i+1]) - 1;
     *(ctab[i+1]+k_) = '\0';
     k_ = asctoqtm(ctab[i+1]+1);
     *(c+(int)lval_) = k_;
     i += 1; ret_ = -1;
     sfn_ = 0;
     continue;
     }
   if(isnumb(ctab[i]) == NINT && !cmdend(i+6) && (!strcmp(ctab[i+3],">") || !strcmp(ctab[i+3],"<")))
     {
     if(strcmp(ctab[i+1],",") && strcmp(ctab[i+1],"-"))
       {
       errmsg(  1);
       break;
       }
     if(isnumb(ctab[i+2]) != NINT)
       {
       errmsg(  2);
       break;
       }
     if(isnumb(ctab[i+4]) != NINT)
       {
       errmsg(  2);
       break;
       }
     if(strcmp(ctab[i+5],",") && strcmp(ctab[i+5],"-"))
       {
       errmsg(  1);
       break;
       }
     if(isnumb(ctab[i+6]) != NINT)
       {
       errmsg(  2);
       break;
       }
     sscanf(ctab[i  ],"%ld",&lval_);
     sscanf(ctab[i+2],"%ld",&lstr_);
     sscanf(ctab[i+4],"%ld",&mval_);
     sscanf(ctab[i+6],"%ld",&mstr_);
     k1_ = (int)lval_ / 100;
     k2_ = (int)lstr_ / 100;
     if(k1_ != k2_ && structargs[5])
       {
       errmsg(  7);
       break;
       }
     k1_ = (int)mval_ / 100;
     k2_ = (int)mstr_ / 100;
     if(k1_ != k2_ && structargs[5])
       {
       errmsg(  7);
       break;
       }
     if(structargs[5] && lval_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(structargs[5] && lstr_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(structargs[5] && mval_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(structargs[5] && mstr_ < 101L)
       {
       errmsg(  6);
       break;
       }
     lstr_ = (lstr_ - lval_) + 1L;
     if((lval_ + (lstr_ - 1L)) > (long)cvars)
       {
       errmsg(  4);
       break;
       }
     mstr_ = (mstr_ - mval_) + 1L;
     if((mval_ + (mstr_ - 1L)) > (long)cvars)
       {
       errmsg(  4);
       break;
       }
     if(lstr_ != mstr_)
       {
       errmsg(  5);
       break;
       }
     if(!strcmp(ctab[i+3],">"))
       colcmv_(c,mval_,mstr_,c,lval_,lstr_);
     else
       colcmv_(c,lval_,lstr_,c,mval_,mstr_);
     i += 6; ret_ = -1;
     sfn_ = 0;
     continue;
     }
   if(isnumb(ctab[i]) == NINT && !cmdend(i+2) && (!strcmp(ctab[i+1],">") || !strcmp(ctab[i+1],"<")) && isnumb(ctab[i+2]) == NINT)
     {
     sscanf(ctab[i  ],"%ld",&lval_);
     sscanf(ctab[i+2],"%ld",&mval_);
     if(structargs[5] && lval_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(structargs[5] && mval_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(lval_ > (long)cvars)
       {
       errmsg(  4);
       break;
       }
     if(mval_ > (long)cvars)
       {
       errmsg(  4);
       break;
       }
     if(!strcmp(ctab[i+1],">"))
       *(c+(int)mval_) = *(c+(int)lval_);
     else
       *(c+(int)lval_) = *(c+(int)mval_);
     i += 2; ret_ = -1;
     sfn_ = 0;
     continue;
     }
   if(!strncmp(ctab[i],"emit",strlen(ctab[i])) && !cmdend(i+2))
     {
     if(isnumb(ctab[i+1]) != NINT)
       {
       errmsg(  2);
       break;
       }
     sscanf(ctab[i+1],"%ld",&lval_);
     if(structargs[5] && lval_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(lval_ > (long)cvars)
       {
       errmsg(  4);
       break;
       }
     if(!ispunch(ctab[i+2]))
       {
       errmsg(  1);
       break;
       }
     k_ = strlen(ctab[i+2]) - 1;
     *(ctab[i+2]+k_) = '\0';
     k_ = asctoqtm(ctab[i+2]+1);
     *(c+(int)lval_) |= k_;
     if(!trun_)
       printf("\n%s%ld%s%s\n","column ",lval_," is ",mkmpstr_(*(c+(int)lval_)));
     i += 2; ret_ = -1;
     sfn_ = 0;
     continue;
     }
   if(!strncmp(ctab[i],"delete",strlen(ctab[i])) && !cmdend(i+2))
     {
     if(isnumb(ctab[i+1]) != NINT)
       {
       errmsg(  2);
       break;
       }
     sscanf(ctab[i+1],"%ld",&lval_);
     if(structargs[5] && lval_ < 101L)
       {
       errmsg(  6);
       break;
       }
     if(lval_ > (long)cvars)
       {
       errmsg(  4);
       break;
       }
     if(!ispunch(ctab[i+2]))
       {
       errmsg(  1);
       break;
       }
     k_ = strlen(ctab[i+2]) - 1;
     *(ctab[i+2]+k_) = '\0';
     k_ = asctoqtm(ctab[i+2]+1);
     *(c+(int)lval_) &= 0x0FFF - k_;
     if(!trun_)
       printf("\n%s%ld%s%s\n","column ",lval_," is ",mkmpstr_(*(c+(int)lval_)));
     i += 2; ret_ = -1;
     sfn_ = 0;
     continue;
     }
   if(!strcmp(ctab[i],"ad") && !cmdend(i+1))
     {
     while(!cmdend(++i))
       {
       if(isnumb(ctab[i]) != NINT)
         {
         errmsg(  2);
         break;
         }
       sfn_ = 1;
       sscanf(ctab[i],"%u",&k_);
       if((int)k_ > structargs[5])
         {
         if(!trun_)
           printf("*** error: C matrix is too small to add card %u\n",k_);
         }
       else
       if(*(thisread+(int)k_))
         {
         if(!trun_)
           printf("*** error: this read already contains card %u\n",k_);
         }
       else
         {
         *(thisread+(int)k_) = 1;
         *(allread+(int)k_) = 1;
         if(!trun_)
           printf("card %u added\n",k_);
         }
       }
     ret_ = -1;
     continue;
     }
   if(!strcmp(ctab[i],"rm") && !cmdend(i+1))
     {
     while(!cmdend(++i))
       {
       if(isnumb(ctab[i]) != NINT)
         {
         errmsg(  2);
         break;
         }
       sfn_ = 1;
       sscanf(ctab[i],"%u",&k_);
       if((int)k_ > structargs[5])
         {
         if(!trun_)
           printf("*** error: this read does not contain card %u\n",k_);
         }
       else
       if(!*(thisread+(int)k_))
         {
         if(!trun_)
           printf("*** error: this read does not contain card %u\n",k_);
         }
       else
         {
         *(thisread+(int)k_) = 0;
         *(allread+(int)k_) = 0;
         if(!trun_)
           printf("card %u removed\n",k_);
         }
       }
     ret_ = -1;
     continue;
     }
   if(!i && (i_ = fmacro(ctab[i])) && (i+1)>=count)
     {
     if(!trun_)
       printf("*** processing macro %s\n",macs_[i_-1].m_string);
     strcpy(macb_,macs_[i_-1].m_string);
     ret_ = edintp(macb_);
     sfn_ = 0;
     break;
     }
   if(!strncmp(ctab[i],"set",strlen(ctab[i])) && !cmdend(i+1))
     continue;
   errmsg(  1);
   break;
   }

return(ret_);
}

char *formatline(buf)
char *buf;
{
register int i_,j_;
short jn_,len_,tjn_;
char wbuf_[INSIZE];

for(i_=0;i_<INSIZE;i_++)
   {
   if(*(buf + i_) == '$')
     *(buf + i_) = '"';
   *(wbuf_ + i_) = '\0';
   }

len_ = strlen(buf);
jn_ = 0; j_ = 0; tjn_ = 0;
for(i_=0;i_<len_;i_++)
   {
   if(!tjn_ && *(buf + i_) == '"')
     jn_ = 1 - jn_;
   else
   if(!jn_ && *(buf + i_) == '\'')
     tjn_ = 1 - tjn_;

   if((jn_ || tjn_) && *(buf + i_) == ' ')
     {
     *(wbuf_ + j_) = 0x7f;
     j_ += 1;
     }
   else
   if(i_ && *(buf + i_) == '"' && *(buf + (i_-1)) == '"')
     {
     *(wbuf_ + j_) = 0x7f;
     ++j_;
     *(wbuf_ + j_) = '"';
     ++j_;
     }
   else
   if(i_ && *(buf + i_) == '\'' && *(buf + (i_-1)) == '\'')
     {
     *(wbuf_ + j_) = 0x7f;
     ++j_;
     *(wbuf_ + j_) = '\'';
     ++j_;
     }
   else
   if(!jn_ && i_ && *(buf + i_) == ' ' && *(buf + (i_-1)) == ' ')
     continue;
   else
   if(!jn_ && (i_+1) < len_ && isc_(*(buf + i_)) && isf_(*(buf + (i_+1))))
     continue;
   else
   if(tjn_ && *(buf + i_) == '\'')
     {
     strcat(wbuf_," '");
     j_ += 2;
     }
   else
   if(!tjn_ && !jn_ && *(buf + i_) == '\'')
     {
     strcat(wbuf_,"' ");
     j_ += 2;
     }
   else
   if(!tjn_ && !jn_ && *(buf + i_) == '\"')
     {
     strcat(wbuf_,"\" ");
     j_ += 2;
     }
   else
   if(jn_ && *(buf + i_) == '"')
     {
     strcat(wbuf_," \"");
     j_ += 2;
     }
   else
   if(!jn_ && !tjn_ && *(buf + i_) == '(')
     continue;
   else
   if(!jn_ && ! tjn_ && *(buf + i_) == ')')
     continue;
   else
   if(!jn_ && !tjn_ && *(buf + i_) == '=')
     continue;
   else
   if(!jn_ && !tjn_ && *(buf + i_) == ',')
     {
     strcat(wbuf_," , ");
     j_ += 3;
     }
   else
   if(!jn_ && !tjn_ && *(buf + i_) == '>')
     {
     strcat(wbuf_," > ");
     j_ += 3;
     }
   else
   if(!jn_ && !tjn_ && *(buf + i_) == '<')
     {
     strcat(wbuf_," < ");
     j_ += 3;
     }
   else
   if(!jn_ && !tjn_ && *(buf + i_) == ';')
     {
     strcat(wbuf_," ; ");
     j_ += 3;
     }
   else
   if(!jn_ && !tjn_ && *(buf + i_) == '-')
     {
     strcat(wbuf_," - ");
     j_ += 3;
     }
   else
   if(!jn_ && !tjn_ && *(buf + i_) == '+')
     {
     strcat(wbuf_," + ");
     j_ += 3;
     }
   else
   if(!jn_ && !tjn_ && (*(buf + i_) >= 'A' && *(buf + i_) <= 'Z'))
     {
     *(wbuf_ + j_) = (*(buf + i_) + 32);
     j_++;
     }
   else
     {
     *(wbuf_ + j_) = *(buf + i_);
     j_++;
     }
   }
if(jn_ || tjn_)
  strcpy(wbuf_,"ERROR 0");
return(wbuf_);
}

void errmsg(errcode)
int errcode;
{
  if(!trun_)
    {
    if(errcode == 1)
      printf("*** error: cannot interpret command");
    else
    if(errcode == 2)
      printf("*** error: digit expected");
    else
    if(errcode == 3)
      printf("*** error: improper subscript");
    else
    if(errcode == 4)
      printf("*** error: column out of range");
    else
    if(errcode == 5)
      printf("*** error: unmatched length");
    else
    if(errcode == 6)
      printf("*** error: no card specified");
    else
    if(errcode == 7)
      printf("*** error: illegal setting in different cards");
    else
    if(errcode == 8)
      printf("*** error: cannot execute command in insert mode");
    else
    if(errcode == 9)
      printf("*** error: macro name too long");
    else
    if(errcode ==10)
      printf("*** error: macro name not found");
    else
    if(errcode ==11)
      printf("*** error: macro name already exists");
    else
    if(errcode ==12)
      printf("*** error: no more space to create a new macro");
    else
    if(errcode ==13)
      printf("*** error: error condition out of range");
    else
    if(errcode ==14)
      printf("*** error: error condition not found");
    else
    if(errcode ==15)
      printf("*** error: error condition already exists");
    else
    if(errcode ==16)
      printf("*** error: no more space to create a new error condition");
    else
    if(errcode ==17)
      printf("*** error: illegal character in input");
    printf(" - (error in command %d)\n",expcount_);
    }
}

void o_writerecout(instr,coloffset,inlen)
unsigned short *instr;
long coloffset;
long inlen;
{
register int i_;
int first_;
int j_,k_,l_;
char s_[64];

if(inlen < 80L || cr_)
  sprintf(s_,"%%.%lds\n\0",inlen);
else
  sprintf(s_,"%%.%lds\0",inlen);
k_ = (int)(coloffset % 100) + 1;
printf("\n");
printf(s_,ruler2_+k_);
if(structargs[0] == 2 || structargs[0] == 3)
  {
  for(i_=0;i_<=structargs[5];i_++)
     if(*(allread+i_))
       {
       j_ = (i_*cseqs_)+(int)coloffset;
       swaprec_(instr+j_,(long)inlen);
       first_ = 1;
       while(o_setqtmstrout(c_tmp,(long)inlen,asc_s) || first_)
          {
          printf("%s",asc_s);
          if(strlen(asc_s) < 80 || cr_)
            printf("\n");
          first_ = 0;
          }
      }
  }
else
  {
  k_ = ((int)inlen+99) / 100;
  for(i_=0;i_<k_;i_++)
     {
     j_ = (i_*100);
     if((j_+100) <= (int)inlen)
       l_ = 100;
     else
       l_ = (int)inlen % 100;
     j_ += coloffset;
     swaprec_(instr+j_,(long)l_);
     first_ = 1;
     while(o_setqtmstrout(c_tmp,(long)l_,asc_s) || first_)
        {
        printf("%s",asc_s);
        if(strlen(asc_s) < 80 || cr_)
          printf("\n");
        first_ = 0;
        }
     }
  }
}

int o_setqtmstrout(instr,inlen,outstr)
unsigned short *instr;
long inlen;
char *outstr;
{
register int i_;

while(!instr[(int)inlen-1])
  --inlen;

for(i_=0;i_<(int)inlen;i_++)
   *(outstr+i_) = bt[(int)instr[i_]];
*(outstr+i_) = '\0';
i_ = 0;

return(i_);
}

int isnumb(s_)
char *s_;
{
short varlen_;
int i_;
int r_   = 0;
int pnt_ = 0;

varlen_ = strlen(s_);
for(i_ = 0;i_ < varlen_;i_++)
   {
   if((*(s_ + i_) < '0' || *(s_ + i_) > '9') && *(s_ + i_) != '.')
     {
     r_ = 1;
     break;
     }
   if(*(s_ + i_) == '.')
     ++pnt_;
   }
if(pnt_ > 1 || r_)
  r_ = NERR;
else
if(pnt_ == 1)
  r_ = NPNT;
else
  r_ = NINT;
return(r_);
}

void o_subwriteout(instr,coloffset,inlen)
unsigned short *instr;
long coloffset;
long inlen;
{
int first_;
int k_;
char s_[64];

if(inlen < 80L || cr_)
  sprintf(s_,"%%.%lds\n\0",inlen);
else
  sprintf(s_,"%%.%lds\0",inlen);
k_ = (int)(coloffset % 100) + 1;
swaprec_(instr+coloffset,(long)inlen);
printf("\n");
printf(s_,ruler2_+k_);
first_ = 1;
while(o_setqtmstrout(c_tmp,(long)inlen,asc_s) || first_)
   {
   printf("%s",asc_s);
   if(strlen(asc_s) < 80 || cr_)
     printf("\n");
   first_ = 0;
   }
}

unsigned short asctoqtm(s_)
char *s_;
{
int len_,i_,j_;
int beg_,end_;
unsigned short e_ = 0x0000;

len_ = strlen(s_);
for(i_=0;i_<len_;i_++)
   {
   if((*(s_+i_) == '/') && i_ && ((i_+1) < len_))
     {
     beg_ = isstpnch(*(s_+(i_-1)),0); end_ = isstpnch(*(s_+(i_+1)),beg_-1);
     if(beg_ && end_ && (beg_ <= end_))
       {
       --beg_; --end_;
       for(j_=beg_;j_<end_;j_++)
          e_ |= qval_[qfolg[j_]];
       }
     else
       {
       errmsg(  1);
       break;
       }
     }
   else
     e_ |= qval_[(unsigned char)s_[i_]];
   }
return(e_);
}

int ispunch(s_)
char *s_;
{
int len_,r_ = 0;

len_ = strlen(s_) - 1;
if(*(s_+0) == '\'' && *(s_+len_) == '\'')
  r_ = 1;
return(r_);
}

int isstr(s_)
char *s_;
{
int len_,r_ = 0;

len_ = strlen(s_);
if(*(s_+0) == '"' && *(s_+(len_-1)) == '"')
  r_ = len_ - 2;
return(r_);
}

int isstpnch(p_char,p_start)
char p_char;
int p_start;
{
int i_;
int ret_ = 0;

for(i_=p_start;i_<15;i_++)
   if(p_char == qfolg[i_])
     {
     ret_ = i_ + 1;
     break;
     }
return(ret_);
}

char *nospc(buf)
char *buf;
{
register int i_;
short len_;

len_ = strlen(buf);
for(i_=0;i_<len_;i_++)
   {
   if(*(buf + i_) == 0x7f)
   *(buf + i_) = ' ';
   }
return(buf);
}

int isc_(s_)
char s_;
{
int ret_ = 0;
if(s_ == 'C' || s_ == 'c')
  ret_ = 1;
return(ret_);
}

int isf_(s_)
char s_;
{
int ret_ = 0;
if(s_ == '(')
  ret_ = 1;
else
if(s_ >= '0' && s_ <= '9')
  ret_ = 1;
return(ret_);
}

int allblank(s_)
char *s_;
{
int r_ = 1;
int len_,i_;

len_ = strlen(s_) - 1;
for(i_=1;i_<len_;i_++)
   if(*(s_+i_) != 0x7f)
     {
     r_ = 0;
     break;
     }
return(r_);
}

int cmdend(i_)
short i_;
{
int ret_ = 0;
if(i_ >= count)
  ret_ = 1;
else
if(!strcmp(ctab[i_],";"))
  ret_ = 1;
return(ret_);
}

void writecmds()
{
FILE *ff;

    printf("\n*** writing corrections...\n\n");
    if((ff = fopen("online.rcd","w")) == NULL)
      {
      fprintf(stderr,"cannot open online.rcd\n");
      exit(1);
      }
    while(cstart_->nextcmd != NULL)
      {
      fprintf(ff,"%s\n",cstart_->cmdptr);
      cstart_ = cstart_->nextcmd;
      }
    fprintf(ff,"%s\n",cstart_->cmdptr);
    fclose(ff);
}

char *left(p)
char *p;
{

while(*p == ' ')
  ++p;

return(p);
}

int fmacro(s_)
char *s_;
{
int ret_ = 0;
int i_;

for(i_=0;i_<MACROS;i_++)
   {
   if(!strcmp(macs_[i_].m_name,s_))
     {
     ret_ = i_ + 1;
     break;
     }
   }
return(ret_);
}

int nmacro(s_,c_)
char *s_;
char *c_;
{
int ret_ = 0;
int i_;

for(i_=0;i_<MACROS;i_++)
   {
   if(*(macs_[i_].m_name+0) == '\0')
     {
     strcpy(macs_[i_].m_name,s_);
     strcpy(macs_[i_].m_string,c_+strlen(s_));
     ret_ = i_ + 1;
     break;
     }
   }
return(ret_);
}

void shmac()
{
int i_;

for(i_=0;i_<MACROS;i_++)
   if(*(macs_[i_].m_name+0) != '\0')
     printf("%9s  %s\n",macs_[i_].m_name,macs_[i_].m_string);
}

void print_errors(j_)
int j_;
{
int i_ = 0;

if(j_ == -1)
  {
  while(req_texts_[i_].text != NULL)
    {
    if(req_texts_[i_].finish && req_texts_[i_].start != -1)
      {
      if(req_texts_[i_].finish == 1)
        printf("[%3d] occurences of column %d\n",i_,req_texts_[i_].start);
      else
      if(req_texts_[i_].finish == -1)
        printf("[%3d] occurences of variable defined columns\n",i_);
      else
        printf("[%3d] occurences in range %d - %d\n",i_,req_texts_[i_].start,(req_texts_[i_].start+req_texts_[i_].finish)-1);
      }
    else
      printf("[%3d] %s\n",i_,req_texts_[i_].text);
    ++i_;
    if(!(i_ % 20))
      {
      printf("press ENTER to continue...");
      getchar();
      }
    }
  }
else
  {
  if(req_texts_[j_].finish && req_texts_[j_].start != -1)
    {
    if(req_texts_[j_].finish == 1)
      printf("[%3d] occurences of column %d\n",j_,req_texts_[j_].start);
    else
    if(req_texts_[j_].finish == -1)
      printf("[%3d] occurences of variable defined columns\n",j_);
    else
      printf("[%3d] occurences in range %d - %d\n",j_,req_texts_[j_].start,(req_texts_[j_].start+req_texts_[j_].finish)-1);
    }
  else
    printf("[%3d] %s\n",j_,req_texts_[j_].text);
  }
}

void shcon()
{
int i_;

for(i_=0;i_<CONDTS;i_++)
   if(*(conds_[i_].c_string+0) != '\0')
     printf("[%3d] %s\n",conds_[i_].c_num,conds_[i_].c_string);
}

int ncon(s_,c_)
char *s_;
char *c_;
{
int ret_ = 0;
int i_;

for(i_=0;i_<MACROS;i_++)
   {
   if(*(conds_[i_].c_string+0) == '\0')
     {
     sscanf(s_,"%d",&conds_[i_].c_num);
     strcpy(conds_[i_].c_string,c_+strlen(s_));
     ret_ = i_ + 1;
     break;
     }
   }
return(ret_);
}

int fcon(s_)
char *s_;
{
int ret_ = 0;
int i_,j_;

sscanf(s_,"%d",&j_);
for(i_=0;i_<CONDTS;i_++)
   {
   if(*(conds_[i_].c_string+0) != '\0' && conds_[i_].c_num == j_)
     {
     ret_ = i_ + 1;
     break;
     }
   }
return(ret_);
}

int msgfound()
{
int ret_ = 0;
int i_,j_;
for(i_=0;i_<maxerr_;i_++)
   {
   if(req_texts_[i_].appear)
     for(j_=0;j_<CONDTS;j_++)
        if(*(conds_[j_].c_string+0) != '\0' && conds_[j_].c_num == i_)
          {
          req_texts_[i_].appear = 0;
          ret_ = j_ + 1;
          if(!trun_)
            printf("*** message conditioned command: [%3d] %s\n",i_,conds_[j_].c_string);
          break;
          }
   if(ret_)
     break;
   }
return(ret_);
}

int getfield(fstart,flen,inbuf)
int fstart,flen;
char *inbuf;
{
int ret_ = 0;
int i_,l_;

printf("\nInput %d to %d: ",fstart,fstart+(flen-1));
for(i_=0;i_<flen;i_++)
   putc('.',stdout);
for(i_=0;i_<flen;i_++)
   putc('\b',stdout);
fflush(stdout);
fgets(inbuf,128,stdin);
l_ = strlen(inbuf) - 1;
*(inbuf+l_) = '\0';
for(i_=0;i_<l_;i_++)
   if((unsigned char)*(inbuf+i_) < ' ' || *(inbuf+i_) == 0x7f)
     {
     ret_ = 1;
     break;
     }
return(ret_);
}
